// AUTOGENERATED FILE. DO NOT MODIFY.

#include <stdlib.h>
#include <stdint.h>

#include "unpack2.h"



static void unpack_1_2bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit signed
	// Skip 0 bits, read 2 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);
}

static void unpack_1_2bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit unsigned
	// Skip 0 bits, read 2 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);
}

static void unpack_1_2bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit signed
	// Skip 1 bits, read 2 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);
}

static void unpack_1_2bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit unsigned
	// Skip 1 bits, read 2 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);
}

static void unpack_1_2bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit signed
	// Skip 2 bits, read 2 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);
}

static void unpack_1_2bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit unsigned
	// Skip 2 bits, read 2 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);
}

static void unpack_1_2bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit signed
	// Skip 3 bits, read 2 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);
}

static void unpack_1_2bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit unsigned
	// Skip 3 bits, read 2 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);
}

static void unpack_1_2bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit signed
	// Skip 4 bits, read 2 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);
}

static void unpack_1_2bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit unsigned
	// Skip 4 bits, read 2 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);
}

static void unpack_1_2bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit signed
	// Skip 5 bits, read 2 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);
}

static void unpack_1_2bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit unsigned
	// Skip 5 bits, read 2 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);
}

static void unpack_1_2bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit signed
	// Skip 6 bits, read 2 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);
}

static void unpack_1_2bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit unsigned
	// Skip 6 bits, read 2 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);
}

static void unpack_1_2bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit signed
	// Skip 7 bits, read 2 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);
}

static void unpack_1_2bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 2-bit unsigned
	// Skip 7 bits, read 2 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);
}

static void unpack_2_2bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit signed
	// Skip 0 bits, read 4 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[1] = (double)(value >> 30);
}

static void unpack_2_2bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit unsigned
	// Skip 0 bits, read 4 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[1] = (double)(value >> 30);
}

static void unpack_2_2bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit signed
	// Skip 1 bits, read 4 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[1] = (double)(value >> 30);
}

static void unpack_2_2bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit unsigned
	// Skip 1 bits, read 4 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[1] = (double)(value >> 30);
}

static void unpack_2_2bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit signed
	// Skip 2 bits, read 4 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[1] = (double)(value >> 30);
}

static void unpack_2_2bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit unsigned
	// Skip 2 bits, read 4 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[1] = (double)(value >> 30);
}

static void unpack_2_2bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit signed
	// Skip 3 bits, read 4 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[1] = (double)(value >> 30);
}

static void unpack_2_2bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit unsigned
	// Skip 3 bits, read 4 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[1] = (double)(value >> 30);
}

static void unpack_2_2bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit signed
	// Skip 4 bits, read 4 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[1] = (double)(value >> 30);
}

static void unpack_2_2bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit unsigned
	// Skip 4 bits, read 4 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[1] = (double)(value >> 30);
}

static void unpack_2_2bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit signed
	// Skip 5 bits, read 4 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[1] = (double)(value >> 30);
}

static void unpack_2_2bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit unsigned
	// Skip 5 bits, read 4 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[1] = (double)(value >> 30);
}

static void unpack_2_2bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit signed
	// Skip 6 bits, read 4 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[1] = (double)(value >> 30);
}

static void unpack_2_2bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit unsigned
	// Skip 6 bits, read 4 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[1] = (double)(value >> 30);
}

static void unpack_2_2bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit signed
	// Skip 7 bits, read 4 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[1] = (double)(value >> 30);
}

static void unpack_2_2bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 2-bit unsigned
	// Skip 7 bits, read 4 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[1] = (double)(value >> 30);
}

static void unpack_3_2bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit signed
	// Skip 0 bits, read 6 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[2] = (double)(value >> 30);
}

static void unpack_3_2bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit unsigned
	// Skip 0 bits, read 6 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[2] = (double)(value >> 30);
}

static void unpack_3_2bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit signed
	// Skip 1 bits, read 6 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[2] = (double)(value >> 30);
}

static void unpack_3_2bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit unsigned
	// Skip 1 bits, read 6 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[2] = (double)(value >> 30);
}

static void unpack_3_2bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit signed
	// Skip 2 bits, read 6 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[2] = (double)(value >> 30);
}

static void unpack_3_2bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit unsigned
	// Skip 2 bits, read 6 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[2] = (double)(value >> 30);
}

static void unpack_3_2bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit signed
	// Skip 3 bits, read 6 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[2] = (double)(value >> 30);
}

static void unpack_3_2bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit unsigned
	// Skip 3 bits, read 6 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[2] = (double)(value >> 30);
}

static void unpack_3_2bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit signed
	// Skip 4 bits, read 6 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[2] = (double)(value >> 30);
}

static void unpack_3_2bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit unsigned
	// Skip 4 bits, read 6 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[2] = (double)(value >> 30);
}

static void unpack_3_2bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit signed
	// Skip 5 bits, read 6 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[2] = (double)(value >> 30);
}

static void unpack_3_2bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit unsigned
	// Skip 5 bits, read 6 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[2] = (double)(value >> 30);
}

static void unpack_3_2bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit signed
	// Skip 6 bits, read 6 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[2] = (double)(value >> 30);
}

static void unpack_3_2bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit unsigned
	// Skip 6 bits, read 6 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[2] = (double)(value >> 30);
}

static void unpack_3_2bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit signed
	// Skip 7 bits, read 6 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[2] = (double)(value >> 30);
}

static void unpack_3_2bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 2-bit unsigned
	// Skip 7 bits, read 6 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[2] = (double)(value >> 30);
}

static void unpack_4_2bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit signed
	// Skip 0 bits, read 8 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[3] = (double)(value >> 30);
}

static void unpack_4_2bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit unsigned
	// Skip 0 bits, read 8 bits of data.
	// Input must be at least 1 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[3] = (double)(value >> 30);
}

static void unpack_4_2bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit signed
	// Skip 1 bits, read 8 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[3] = (double)(value >> 30);
}

static void unpack_4_2bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit unsigned
	// Skip 1 bits, read 8 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[3] = (double)(value >> 30);
}

static void unpack_4_2bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit signed
	// Skip 2 bits, read 8 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[3] = (double)(value >> 30);
}

static void unpack_4_2bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit unsigned
	// Skip 2 bits, read 8 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[3] = (double)(value >> 30);
}

static void unpack_4_2bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit signed
	// Skip 3 bits, read 8 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[3] = (double)(value >> 30);
}

static void unpack_4_2bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit unsigned
	// Skip 3 bits, read 8 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[3] = (double)(value >> 30);
}

static void unpack_4_2bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit signed
	// Skip 4 bits, read 8 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[3] = (double)(value >> 30);
}

static void unpack_4_2bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit unsigned
	// Skip 4 bits, read 8 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[3] = (double)(value >> 30);
}

static void unpack_4_2bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit signed
	// Skip 5 bits, read 8 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[3] = (double)(value >> 30);
}

static void unpack_4_2bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit unsigned
	// Skip 5 bits, read 8 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[3] = (double)(value >> 30);
}

static void unpack_4_2bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit signed
	// Skip 6 bits, read 8 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[3] = (double)(value >> 30);
}

static void unpack_4_2bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit unsigned
	// Skip 6 bits, read 8 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[3] = (double)(value >> 30);
}

static void unpack_4_2bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit signed
	// Skip 7 bits, read 8 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[3] = (double)(value >> 30);
}

static void unpack_4_2bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 2-bit unsigned
	// Skip 7 bits, read 8 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[3] = (double)(value >> 30);
}

static void unpack_5_2bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit signed
	// Skip 0 bits, read 10 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[4] = (double)(value >> 30);
}

static void unpack_5_2bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit unsigned
	// Skip 0 bits, read 10 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[4] = (double)(value >> 30);
}

static void unpack_5_2bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit signed
	// Skip 1 bits, read 10 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[4] = (double)(value >> 30);
}

static void unpack_5_2bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit unsigned
	// Skip 1 bits, read 10 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[4] = (double)(value >> 30);
}

static void unpack_5_2bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit signed
	// Skip 2 bits, read 10 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[4] = (double)(value >> 30);
}

static void unpack_5_2bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit unsigned
	// Skip 2 bits, read 10 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[4] = (double)(value >> 30);
}

static void unpack_5_2bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit signed
	// Skip 3 bits, read 10 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[4] = (double)(value >> 30);
}

static void unpack_5_2bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit unsigned
	// Skip 3 bits, read 10 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[4] = (double)(value >> 30);
}

static void unpack_5_2bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit signed
	// Skip 4 bits, read 10 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[4] = (double)(value >> 30);
}

static void unpack_5_2bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit unsigned
	// Skip 4 bits, read 10 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[4] = (double)(value >> 30);
}

static void unpack_5_2bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit signed
	// Skip 5 bits, read 10 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[4] = (double)(value >> 30);
}

static void unpack_5_2bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit unsigned
	// Skip 5 bits, read 10 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[4] = (double)(value >> 30);
}

static void unpack_5_2bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit signed
	// Skip 6 bits, read 10 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[4] = (double)(value >> 30);
}

static void unpack_5_2bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit unsigned
	// Skip 6 bits, read 10 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[4] = (double)(value >> 30);
}

static void unpack_5_2bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit signed
	// Skip 7 bits, read 10 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[4] = (double)(value >> 30);
}

static void unpack_5_2bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 2-bit unsigned
	// Skip 7 bits, read 10 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[4] = (double)(value >> 30);
}

static void unpack_6_2bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit signed
	// Skip 0 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[5] = (double)(value >> 30);
}

static void unpack_6_2bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit unsigned
	// Skip 0 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[5] = (double)(value >> 30);
}

static void unpack_6_2bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit signed
	// Skip 1 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[5] = (double)(value >> 30);
}

static void unpack_6_2bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit unsigned
	// Skip 1 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[5] = (double)(value >> 30);
}

static void unpack_6_2bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit signed
	// Skip 2 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[5] = (double)(value >> 30);
}

static void unpack_6_2bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit unsigned
	// Skip 2 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[5] = (double)(value >> 30);
}

static void unpack_6_2bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit signed
	// Skip 3 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[5] = (double)(value >> 30);
}

static void unpack_6_2bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit unsigned
	// Skip 3 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[5] = (double)(value >> 30);
}

static void unpack_6_2bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit signed
	// Skip 4 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[5] = (double)(value >> 30);
}

static void unpack_6_2bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit unsigned
	// Skip 4 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[5] = (double)(value >> 30);
}

static void unpack_6_2bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit signed
	// Skip 5 bits, read 12 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[5] = (double)(value >> 30);
}

static void unpack_6_2bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit unsigned
	// Skip 5 bits, read 12 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[5] = (double)(value >> 30);
}

static void unpack_6_2bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit signed
	// Skip 6 bits, read 12 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 16 to 17
	value = ((uint32_t)(input[2] & 0xc0) << 24);
	output[5] = (double)(value >> 30);
}

static void unpack_6_2bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit unsigned
	// Skip 6 bits, read 12 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 16 to 17
	value = ((uint32_t)(input[2] & 0xc0) << 24);
	output[5] = (double)(value >> 30);
}

static void unpack_6_2bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit signed
	// Skip 7 bits, read 12 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 17 to 18
	value = ((uint32_t)(input[2] & 0x60) << 25);
	output[5] = (double)(value >> 30);
}

static void unpack_6_2bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 2-bit unsigned
	// Skip 7 bits, read 12 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 17 to 18
	value = ((uint32_t)(input[2] & 0x60) << 25);
	output[5] = (double)(value >> 30);
}

static void unpack_7_2bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit signed
	// Skip 0 bits, read 14 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[6] = (double)(value >> 30);
}

static void unpack_7_2bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit unsigned
	// Skip 0 bits, read 14 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[6] = (double)(value >> 30);
}

static void unpack_7_2bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit signed
	// Skip 1 bits, read 14 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[6] = (double)(value >> 30);
}

static void unpack_7_2bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit unsigned
	// Skip 1 bits, read 14 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[6] = (double)(value >> 30);
}

static void unpack_7_2bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit signed
	// Skip 2 bits, read 14 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[6] = (double)(value >> 30);
}

static void unpack_7_2bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit unsigned
	// Skip 2 bits, read 14 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[6] = (double)(value >> 30);
}

static void unpack_7_2bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit signed
	// Skip 3 bits, read 14 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[6] = (double)(value >> 30);
}

static void unpack_7_2bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit unsigned
	// Skip 3 bits, read 14 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[6] = (double)(value >> 30);
}

static void unpack_7_2bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit signed
	// Skip 4 bits, read 14 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 16 to 17
	value = ((uint32_t)(input[2] & 0xc0) << 24);
	output[6] = (double)(value >> 30);
}

static void unpack_7_2bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit unsigned
	// Skip 4 bits, read 14 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 16 to 17
	value = ((uint32_t)(input[2] & 0xc0) << 24);
	output[6] = (double)(value >> 30);
}

static void unpack_7_2bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit signed
	// Skip 5 bits, read 14 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 17 to 18
	value = ((uint32_t)(input[2] & 0x60) << 25);
	output[6] = (double)(value >> 30);
}

static void unpack_7_2bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit unsigned
	// Skip 5 bits, read 14 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 17 to 18
	value = ((uint32_t)(input[2] & 0x60) << 25);
	output[6] = (double)(value >> 30);
}

static void unpack_7_2bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit signed
	// Skip 6 bits, read 14 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 16 to 17
	value = ((uint32_t)(input[2] & 0xc0) << 24);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 18 to 19
	value = ((uint32_t)(input[2] & 0x30) << 26);
	output[6] = (double)(value >> 30);
}

static void unpack_7_2bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit unsigned
	// Skip 6 bits, read 14 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 16 to 17
	value = ((uint32_t)(input[2] & 0xc0) << 24);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 18 to 19
	value = ((uint32_t)(input[2] & 0x30) << 26);
	output[6] = (double)(value >> 30);
}

static void unpack_7_2bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit signed
	// Skip 7 bits, read 14 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 17 to 18
	value = ((uint32_t)(input[2] & 0x60) << 25);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 19 to 20
	value = ((uint32_t)(input[2] & 0x18) << 27);
	output[6] = (double)(value >> 30);
}

static void unpack_7_2bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 2-bit unsigned
	// Skip 7 bits, read 14 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 17 to 18
	value = ((uint32_t)(input[2] & 0x60) << 25);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 19 to 20
	value = ((uint32_t)(input[2] & 0x18) << 27);
	output[6] = (double)(value >> 30);
}

static void unpack_8_2bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit signed
	// Skip 0 bits, read 16 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[7] = (double)(value >> 30);
}

static void unpack_8_2bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit unsigned
	// Skip 0 bits, read 16 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 1
	value = ((uint32_t)(input[0] & 0xc0) << 24);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[7] = (double)(value >> 30);
}

static void unpack_8_2bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit signed
	// Skip 1 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[7] = (double)(value >> 30);
}

static void unpack_8_2bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit unsigned
	// Skip 1 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 2
	value = ((uint32_t)(input[0] & 0x60) << 25);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[7] = (double)(value >> 30);
}

static void unpack_8_2bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit signed
	// Skip 2 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 16 to 17
	value = ((uint32_t)(input[2] & 0xc0) << 24);
	output[7] = (double)(value >> 30);
}

static void unpack_8_2bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit unsigned
	// Skip 2 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 3
	value = ((uint32_t)(input[0] & 0x30) << 26);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 16 to 17
	value = ((uint32_t)(input[2] & 0xc0) << 24);
	output[7] = (double)(value >> 30);
}

static void unpack_8_2bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit signed
	// Skip 3 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 17 to 18
	value = ((uint32_t)(input[2] & 0x60) << 25);
	output[7] = (double)(value >> 30);
}

static void unpack_8_2bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit unsigned
	// Skip 3 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 4
	value = ((uint32_t)(input[0] & 0x18) << 27);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 17 to 18
	value = ((uint32_t)(input[2] & 0x60) << 25);
	output[7] = (double)(value >> 30);
}

static void unpack_8_2bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit signed
	// Skip 4 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 16 to 17
	value = ((uint32_t)(input[2] & 0xc0) << 24);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 18 to 19
	value = ((uint32_t)(input[2] & 0x30) << 26);
	output[7] = (double)(value >> 30);
}

static void unpack_8_2bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit unsigned
	// Skip 4 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 5
	value = ((uint32_t)(input[0] & 0x0c) << 28);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 16 to 17
	value = ((uint32_t)(input[2] & 0xc0) << 24);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 18 to 19
	value = ((uint32_t)(input[2] & 0x30) << 26);
	output[7] = (double)(value >> 30);
}

static void unpack_8_2bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit signed
	// Skip 5 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 17 to 18
	value = ((uint32_t)(input[2] & 0x60) << 25);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 19 to 20
	value = ((uint32_t)(input[2] & 0x18) << 27);
	output[7] = (double)(value >> 30);
}

static void unpack_8_2bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit unsigned
	// Skip 5 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 6
	value = ((uint32_t)(input[0] & 0x06) << 29);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 17 to 18
	value = ((uint32_t)(input[2] & 0x60) << 25);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 19 to 20
	value = ((uint32_t)(input[2] & 0x18) << 27);
	output[7] = (double)(value >> 30);
}

static void unpack_8_2bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit signed
	// Skip 6 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 16 to 17
	value = ((uint32_t)(input[2] & 0xc0) << 24);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 18 to 19
	value = ((uint32_t)(input[2] & 0x30) << 26);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 20 to 21
	value = ((uint32_t)(input[2] & 0x0c) << 28);
	output[7] = (double)(value >> 30);
}

static void unpack_8_2bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit unsigned
	// Skip 6 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 7
	value = ((uint32_t)(input[0] & 0x03) << 30);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 8 to 9
	value = ((uint32_t)(input[1] & 0xc0) << 24);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 10 to 11
	value = ((uint32_t)(input[1] & 0x30) << 26);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 12 to 13
	value = ((uint32_t)(input[1] & 0x0c) << 28);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 14 to 15
	value = ((uint32_t)(input[1] & 0x03) << 30);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 16 to 17
	value = ((uint32_t)(input[2] & 0xc0) << 24);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 18 to 19
	value = ((uint32_t)(input[2] & 0x30) << 26);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 20 to 21
	value = ((uint32_t)(input[2] & 0x0c) << 28);
	output[7] = (double)(value >> 30);
}

static void unpack_8_2bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit signed
	// Skip 7 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 17 to 18
	value = ((uint32_t)(input[2] & 0x60) << 25);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 19 to 20
	value = ((uint32_t)(input[2] & 0x18) << 27);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 21 to 22
	value = ((uint32_t)(input[2] & 0x06) << 29);
	output[7] = (double)(value >> 30);
}

static void unpack_8_2bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 2-bit unsigned
	// Skip 7 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 8
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)(input[1] & 0x80) << 23);
	output[0] = (double)(value >> 30);

	// read output[1]: from bit 9 to 10
	value = ((uint32_t)(input[1] & 0x60) << 25);
	output[1] = (double)(value >> 30);

	// read output[2]: from bit 11 to 12
	value = ((uint32_t)(input[1] & 0x18) << 27);
	output[2] = (double)(value >> 30);

	// read output[3]: from bit 13 to 14
	value = ((uint32_t)(input[1] & 0x06) << 29);
	output[3] = (double)(value >> 30);

	// read output[4]: from bit 15 to 16
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)(input[2] & 0x80) << 23);
	output[4] = (double)(value >> 30);

	// read output[5]: from bit 17 to 18
	value = ((uint32_t)(input[2] & 0x60) << 25);
	output[5] = (double)(value >> 30);

	// read output[6]: from bit 19 to 20
	value = ((uint32_t)(input[2] & 0x18) << 27);
	output[6] = (double)(value >> 30);

	// read output[7]: from bit 21 to 22
	value = ((uint32_t)(input[2] & 0x06) << 29);
	output[7] = (double)(value >> 30);
}


unpack_func_t unpack_2bit[UNPACK_2BIT_MAX_COUNT][8][2] = {
	{
		{
			unpack_1_2bit_unsigned_0off,
			unpack_1_2bit_signed_0off,
		},
		{
			unpack_1_2bit_unsigned_1off,
			unpack_1_2bit_signed_1off,
		},
		{
			unpack_1_2bit_unsigned_2off,
			unpack_1_2bit_signed_2off,
		},
		{
			unpack_1_2bit_unsigned_3off,
			unpack_1_2bit_signed_3off,
		},
		{
			unpack_1_2bit_unsigned_4off,
			unpack_1_2bit_signed_4off,
		},
		{
			unpack_1_2bit_unsigned_5off,
			unpack_1_2bit_signed_5off,
		},
		{
			unpack_1_2bit_unsigned_6off,
			unpack_1_2bit_signed_6off,
		},
		{
			unpack_1_2bit_unsigned_7off,
			unpack_1_2bit_signed_7off,
		},
	},
	{
		{
			unpack_2_2bit_unsigned_0off,
			unpack_2_2bit_signed_0off,
		},
		{
			unpack_2_2bit_unsigned_1off,
			unpack_2_2bit_signed_1off,
		},
		{
			unpack_2_2bit_unsigned_2off,
			unpack_2_2bit_signed_2off,
		},
		{
			unpack_2_2bit_unsigned_3off,
			unpack_2_2bit_signed_3off,
		},
		{
			unpack_2_2bit_unsigned_4off,
			unpack_2_2bit_signed_4off,
		},
		{
			unpack_2_2bit_unsigned_5off,
			unpack_2_2bit_signed_5off,
		},
		{
			unpack_2_2bit_unsigned_6off,
			unpack_2_2bit_signed_6off,
		},
		{
			unpack_2_2bit_unsigned_7off,
			unpack_2_2bit_signed_7off,
		},
	},
	{
		{
			unpack_3_2bit_unsigned_0off,
			unpack_3_2bit_signed_0off,
		},
		{
			unpack_3_2bit_unsigned_1off,
			unpack_3_2bit_signed_1off,
		},
		{
			unpack_3_2bit_unsigned_2off,
			unpack_3_2bit_signed_2off,
		},
		{
			unpack_3_2bit_unsigned_3off,
			unpack_3_2bit_signed_3off,
		},
		{
			unpack_3_2bit_unsigned_4off,
			unpack_3_2bit_signed_4off,
		},
		{
			unpack_3_2bit_unsigned_5off,
			unpack_3_2bit_signed_5off,
		},
		{
			unpack_3_2bit_unsigned_6off,
			unpack_3_2bit_signed_6off,
		},
		{
			unpack_3_2bit_unsigned_7off,
			unpack_3_2bit_signed_7off,
		},
	},
	{
		{
			unpack_4_2bit_unsigned_0off,
			unpack_4_2bit_signed_0off,
		},
		{
			unpack_4_2bit_unsigned_1off,
			unpack_4_2bit_signed_1off,
		},
		{
			unpack_4_2bit_unsigned_2off,
			unpack_4_2bit_signed_2off,
		},
		{
			unpack_4_2bit_unsigned_3off,
			unpack_4_2bit_signed_3off,
		},
		{
			unpack_4_2bit_unsigned_4off,
			unpack_4_2bit_signed_4off,
		},
		{
			unpack_4_2bit_unsigned_5off,
			unpack_4_2bit_signed_5off,
		},
		{
			unpack_4_2bit_unsigned_6off,
			unpack_4_2bit_signed_6off,
		},
		{
			unpack_4_2bit_unsigned_7off,
			unpack_4_2bit_signed_7off,
		},
	},
	{
		{
			unpack_5_2bit_unsigned_0off,
			unpack_5_2bit_signed_0off,
		},
		{
			unpack_5_2bit_unsigned_1off,
			unpack_5_2bit_signed_1off,
		},
		{
			unpack_5_2bit_unsigned_2off,
			unpack_5_2bit_signed_2off,
		},
		{
			unpack_5_2bit_unsigned_3off,
			unpack_5_2bit_signed_3off,
		},
		{
			unpack_5_2bit_unsigned_4off,
			unpack_5_2bit_signed_4off,
		},
		{
			unpack_5_2bit_unsigned_5off,
			unpack_5_2bit_signed_5off,
		},
		{
			unpack_5_2bit_unsigned_6off,
			unpack_5_2bit_signed_6off,
		},
		{
			unpack_5_2bit_unsigned_7off,
			unpack_5_2bit_signed_7off,
		},
	},
	{
		{
			unpack_6_2bit_unsigned_0off,
			unpack_6_2bit_signed_0off,
		},
		{
			unpack_6_2bit_unsigned_1off,
			unpack_6_2bit_signed_1off,
		},
		{
			unpack_6_2bit_unsigned_2off,
			unpack_6_2bit_signed_2off,
		},
		{
			unpack_6_2bit_unsigned_3off,
			unpack_6_2bit_signed_3off,
		},
		{
			unpack_6_2bit_unsigned_4off,
			unpack_6_2bit_signed_4off,
		},
		{
			unpack_6_2bit_unsigned_5off,
			unpack_6_2bit_signed_5off,
		},
		{
			unpack_6_2bit_unsigned_6off,
			unpack_6_2bit_signed_6off,
		},
		{
			unpack_6_2bit_unsigned_7off,
			unpack_6_2bit_signed_7off,
		},
	},
	{
		{
			unpack_7_2bit_unsigned_0off,
			unpack_7_2bit_signed_0off,
		},
		{
			unpack_7_2bit_unsigned_1off,
			unpack_7_2bit_signed_1off,
		},
		{
			unpack_7_2bit_unsigned_2off,
			unpack_7_2bit_signed_2off,
		},
		{
			unpack_7_2bit_unsigned_3off,
			unpack_7_2bit_signed_3off,
		},
		{
			unpack_7_2bit_unsigned_4off,
			unpack_7_2bit_signed_4off,
		},
		{
			unpack_7_2bit_unsigned_5off,
			unpack_7_2bit_signed_5off,
		},
		{
			unpack_7_2bit_unsigned_6off,
			unpack_7_2bit_signed_6off,
		},
		{
			unpack_7_2bit_unsigned_7off,
			unpack_7_2bit_signed_7off,
		},
	},
	{
		{
			unpack_8_2bit_unsigned_0off,
			unpack_8_2bit_signed_0off,
		},
		{
			unpack_8_2bit_unsigned_1off,
			unpack_8_2bit_signed_1off,
		},
		{
			unpack_8_2bit_unsigned_2off,
			unpack_8_2bit_signed_2off,
		},
		{
			unpack_8_2bit_unsigned_3off,
			unpack_8_2bit_signed_3off,
		},
		{
			unpack_8_2bit_unsigned_4off,
			unpack_8_2bit_signed_4off,
		},
		{
			unpack_8_2bit_unsigned_5off,
			unpack_8_2bit_signed_5off,
		},
		{
			unpack_8_2bit_unsigned_6off,
			unpack_8_2bit_signed_6off,
		},
		{
			unpack_8_2bit_unsigned_7off,
			unpack_8_2bit_signed_7off,
		},
	},
};
