// AUTOGENERATED FILE. DO NOT MODIFY.

#include <stdlib.h>
#include <stdint.h>

#include "unpack12.h"



static void unpack_1_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);
}

static void unpack_1_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);
}

static void unpack_1_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);
}

static void unpack_1_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);
}

static void unpack_1_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);
}

static void unpack_1_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);
}

static void unpack_1_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);
}

static void unpack_1_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);
}

static void unpack_1_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);
}

static void unpack_1_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 12 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);
}

static void unpack_1_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 12 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);
}

static void unpack_1_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 12 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);
}

static void unpack_1_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 12 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);
}

static void unpack_1_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 12 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);
}

static void unpack_1_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 12 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);
}

static void unpack_1_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 12 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);
}

static void unpack_2_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 24 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);
}

static void unpack_2_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 24 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);
}

static void unpack_2_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);
}

static void unpack_2_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);
}

static void unpack_2_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);
}

static void unpack_2_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);
}

static void unpack_2_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);
}

static void unpack_2_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);
}

static void unpack_2_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);
}

static void unpack_2_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);
}

static void unpack_2_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);
}

static void unpack_2_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);
}

static void unpack_2_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);
}

static void unpack_2_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);
}

static void unpack_2_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);
}

static void unpack_2_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);
}

static void unpack_3_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 36 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);
}

static void unpack_3_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 36 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);
}

static void unpack_3_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 36 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);
}

static void unpack_3_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 36 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);
}

static void unpack_3_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 36 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);
}

static void unpack_3_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 36 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);
}

static void unpack_3_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 36 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);
}

static void unpack_3_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 36 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);
}

static void unpack_3_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 36 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);
}

static void unpack_3_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 36 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);
}

static void unpack_3_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 36 bits of data.
	// Input must be at least 6 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);
}

static void unpack_3_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 36 bits of data.
	// Input must be at least 6 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);
}

static void unpack_3_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 36 bits of data.
	// Input must be at least 6 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);
}

static void unpack_3_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 36 bits of data.
	// Input must be at least 6 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);
}

static void unpack_3_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 36 bits of data.
	// Input must be at least 6 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);
}

static void unpack_3_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 36 bits of data.
	// Input must be at least 6 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);
}

static void unpack_4_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 48 bits of data.
	// Input must be at least 6 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);
}

static void unpack_4_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 48 bits of data.
	// Input must be at least 6 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);
}

static void unpack_4_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);
}

static void unpack_4_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);
}

static void unpack_4_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);
}

static void unpack_4_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);
}

static void unpack_4_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);
}

static void unpack_4_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);
}

static void unpack_4_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);
}

static void unpack_4_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);
}

static void unpack_4_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);
}

static void unpack_4_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);
}

static void unpack_4_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);
}

static void unpack_4_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);
}

static void unpack_4_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);
}

static void unpack_4_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);
}

static void unpack_5_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 60 bits of data.
	// Input must be at least 8 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);
}

static void unpack_5_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 60 bits of data.
	// Input must be at least 8 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);
}

static void unpack_5_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 60 bits of data.
	// Input must be at least 8 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);
}

static void unpack_5_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 60 bits of data.
	// Input must be at least 8 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);
}

static void unpack_5_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 60 bits of data.
	// Input must be at least 8 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);
}

static void unpack_5_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 60 bits of data.
	// Input must be at least 8 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);
}

static void unpack_5_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 60 bits of data.
	// Input must be at least 8 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);
}

static void unpack_5_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 60 bits of data.
	// Input must be at least 8 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);
}

static void unpack_5_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 60 bits of data.
	// Input must be at least 8 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);
}

static void unpack_5_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 60 bits of data.
	// Input must be at least 8 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);
}

static void unpack_5_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 60 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);
}

static void unpack_5_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 60 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);
}

static void unpack_5_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 60 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);
}

static void unpack_5_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 60 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);
}

static void unpack_5_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 60 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);
}

static void unpack_5_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 60 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);
}

static void unpack_6_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 72 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);
}

static void unpack_6_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 72 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);
}

static void unpack_6_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);
}

static void unpack_6_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);
}

static void unpack_6_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);
}

static void unpack_6_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);
}

static void unpack_6_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);
}

static void unpack_6_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);
}

static void unpack_6_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);
}

static void unpack_6_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);
}

static void unpack_6_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);
}

static void unpack_6_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);
}

static void unpack_6_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);
}

static void unpack_6_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);
}

static void unpack_6_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);
}

static void unpack_6_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);
}

static void unpack_7_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);
}

static void unpack_7_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);
}

static void unpack_7_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);
}

static void unpack_7_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);
}

static void unpack_7_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);
}

static void unpack_7_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);
}

static void unpack_7_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);
}

static void unpack_7_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);
}

static void unpack_7_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);
}

static void unpack_7_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);
}

static void unpack_7_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 84 bits of data.
	// Input must be at least 12 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);
}

static void unpack_7_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 84 bits of data.
	// Input must be at least 12 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);
}

static void unpack_7_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 84 bits of data.
	// Input must be at least 12 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);
}

static void unpack_7_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 84 bits of data.
	// Input must be at least 12 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);
}

static void unpack_7_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 84 bits of data.
	// Input must be at least 12 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);
}

static void unpack_7_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 84 bits of data.
	// Input must be at least 12 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);
}

static void unpack_8_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 96 bits of data.
	// Input must be at least 12 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);
}

static void unpack_8_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 96 bits of data.
	// Input must be at least 12 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);
}

static void unpack_8_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);
}

static void unpack_8_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);
}

static void unpack_8_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);
}

static void unpack_8_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);
}

static void unpack_8_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);
}

static void unpack_8_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);
}

static void unpack_8_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);
}

static void unpack_8_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);
}

static void unpack_8_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);
}

static void unpack_8_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);
}

static void unpack_8_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);
}

static void unpack_8_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);
}

static void unpack_8_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);
}

static void unpack_8_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);
}

static void unpack_9_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 108 bits of data.
	// Input must be at least 14 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);
}

static void unpack_9_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 108 bits of data.
	// Input must be at least 14 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);
}

static void unpack_9_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 108 bits of data.
	// Input must be at least 14 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);
}

static void unpack_9_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 108 bits of data.
	// Input must be at least 14 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);
}

static void unpack_9_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 108 bits of data.
	// Input must be at least 14 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);
}

static void unpack_9_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 108 bits of data.
	// Input must be at least 14 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);
}

static void unpack_9_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 108 bits of data.
	// Input must be at least 14 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);
}

static void unpack_9_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 108 bits of data.
	// Input must be at least 14 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);
}

static void unpack_9_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 108 bits of data.
	// Input must be at least 14 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);
}

static void unpack_9_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 108 bits of data.
	// Input must be at least 14 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);
}

static void unpack_9_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 108 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);
}

static void unpack_9_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 108 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);
}

static void unpack_9_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 108 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);
}

static void unpack_9_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 108 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);
}

static void unpack_9_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 108 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);
}

static void unpack_9_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 108 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);
}

static void unpack_10_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 120 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);
}

static void unpack_10_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 120 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);
}

static void unpack_10_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);
}

static void unpack_10_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);
}

static void unpack_10_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);
}

static void unpack_10_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);
}

static void unpack_10_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);
}

static void unpack_10_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);
}

static void unpack_10_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);
}

static void unpack_10_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);
}

static void unpack_10_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);
}

static void unpack_10_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);
}

static void unpack_10_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);
}

static void unpack_10_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);
}

static void unpack_10_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);
}

static void unpack_10_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);
}

static void unpack_11_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 132 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);
}

static void unpack_11_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 132 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);
}

static void unpack_11_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 132 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);
}

static void unpack_11_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 132 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);
}

static void unpack_11_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 132 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);
}

static void unpack_11_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 132 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);
}

static void unpack_11_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 132 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);
}

static void unpack_11_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 132 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);
}

static void unpack_11_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 132 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);
}

static void unpack_11_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 132 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);
}

static void unpack_11_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 132 bits of data.
	// Input must be at least 18 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);
}

static void unpack_11_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 132 bits of data.
	// Input must be at least 18 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);
}

static void unpack_11_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 132 bits of data.
	// Input must be at least 18 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);
}

static void unpack_11_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 132 bits of data.
	// Input must be at least 18 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);
}

static void unpack_11_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 132 bits of data.
	// Input must be at least 18 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);
}

static void unpack_11_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 132 bits of data.
	// Input must be at least 18 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);
}

static void unpack_12_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 144 bits of data.
	// Input must be at least 18 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);
}

static void unpack_12_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 144 bits of data.
	// Input must be at least 18 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);
}

static void unpack_12_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);
}

static void unpack_12_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);
}

static void unpack_12_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);
}

static void unpack_12_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);
}

static void unpack_12_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);
}

static void unpack_12_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);
}

static void unpack_12_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);
}

static void unpack_12_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);
}

static void unpack_12_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);
}

static void unpack_12_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);
}

static void unpack_12_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);
}

static void unpack_12_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);
}

static void unpack_12_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);
}

static void unpack_12_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);
}

static void unpack_13_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 156 bits of data.
	// Input must be at least 20 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);
}

static void unpack_13_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 156 bits of data.
	// Input must be at least 20 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);
}

static void unpack_13_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 156 bits of data.
	// Input must be at least 20 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);
}

static void unpack_13_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 156 bits of data.
	// Input must be at least 20 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);
}

static void unpack_13_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 156 bits of data.
	// Input must be at least 20 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);
}

static void unpack_13_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 156 bits of data.
	// Input must be at least 20 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);
}

static void unpack_13_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 156 bits of data.
	// Input must be at least 20 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);
}

static void unpack_13_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 156 bits of data.
	// Input must be at least 20 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);
}

static void unpack_13_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 156 bits of data.
	// Input must be at least 20 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);
}

static void unpack_13_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 156 bits of data.
	// Input must be at least 20 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);
}

static void unpack_13_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 156 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);
}

static void unpack_13_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 156 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);
}

static void unpack_13_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 156 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);
}

static void unpack_13_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 156 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);
}

static void unpack_13_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 156 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);
}

static void unpack_13_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 156 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);
}

static void unpack_14_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 168 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);
}

static void unpack_14_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 168 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);
}

static void unpack_14_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);
}

static void unpack_14_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);
}

static void unpack_14_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);
}

static void unpack_14_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);
}

static void unpack_14_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);
}

static void unpack_14_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);
}

static void unpack_14_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);
}

static void unpack_14_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);
}

static void unpack_14_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);
}

static void unpack_14_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);
}

static void unpack_14_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);
}

static void unpack_14_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);
}

static void unpack_14_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);
}

static void unpack_14_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);
}

static void unpack_15_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 180 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);
}

static void unpack_15_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 180 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);
}

static void unpack_15_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 180 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);
}

static void unpack_15_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 180 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);
}

static void unpack_15_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 180 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);
}

static void unpack_15_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 180 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);
}

static void unpack_15_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 180 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);
}

static void unpack_15_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 180 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);
}

static void unpack_15_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 180 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);
}

static void unpack_15_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 180 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);
}

static void unpack_15_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 180 bits of data.
	// Input must be at least 24 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);
}

static void unpack_15_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 180 bits of data.
	// Input must be at least 24 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);
}

static void unpack_15_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 180 bits of data.
	// Input must be at least 24 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);
}

static void unpack_15_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 180 bits of data.
	// Input must be at least 24 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);
}

static void unpack_15_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 180 bits of data.
	// Input must be at least 24 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);
}

static void unpack_15_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 180 bits of data.
	// Input must be at least 24 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);
}

static void unpack_16_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 192 bits of data.
	// Input must be at least 24 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);
}

static void unpack_16_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 192 bits of data.
	// Input must be at least 24 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);
}

static void unpack_16_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);
}

static void unpack_16_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);
}

static void unpack_16_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);
}

static void unpack_16_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);
}

static void unpack_16_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);
}

static void unpack_16_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);
}

static void unpack_16_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);
}

static void unpack_16_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);
}

static void unpack_16_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);
}

static void unpack_16_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);
}

static void unpack_16_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);
}

static void unpack_16_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);
}

static void unpack_16_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);
}

static void unpack_16_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);
}

static void unpack_17_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);
}

static void unpack_17_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);
}

static void unpack_17_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);
}

static void unpack_17_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);
}

static void unpack_17_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);
}

static void unpack_17_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);
}

static void unpack_17_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);
}

static void unpack_17_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);
}

static void unpack_17_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);
}

static void unpack_17_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);
}

static void unpack_17_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 204 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);
}

static void unpack_17_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 204 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);
}

static void unpack_17_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 204 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);
}

static void unpack_17_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 204 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);
}

static void unpack_17_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 204 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);
}

static void unpack_17_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 204 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);
}

static void unpack_18_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 216 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);
}

static void unpack_18_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 216 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);
}

static void unpack_18_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);
}

static void unpack_18_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);
}

static void unpack_18_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);
}

static void unpack_18_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);
}

static void unpack_18_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);
}

static void unpack_18_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);
}

static void unpack_18_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);
}

static void unpack_18_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);
}

static void unpack_18_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);
}

static void unpack_18_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);
}

static void unpack_18_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);
}

static void unpack_18_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);
}

static void unpack_18_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);
}

static void unpack_18_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);
}

static void unpack_19_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 228 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);
}

static void unpack_19_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 228 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);
}

static void unpack_19_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 228 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);
}

static void unpack_19_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 228 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);
}

static void unpack_19_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 228 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);
}

static void unpack_19_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 228 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);
}

static void unpack_19_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 228 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);
}

static void unpack_19_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 228 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);
}

static void unpack_19_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 228 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);
}

static void unpack_19_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 228 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);
}

static void unpack_19_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 228 bits of data.
	// Input must be at least 30 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);
}

static void unpack_19_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 228 bits of data.
	// Input must be at least 30 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);
}

static void unpack_19_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 228 bits of data.
	// Input must be at least 30 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);
}

static void unpack_19_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 228 bits of data.
	// Input must be at least 30 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);
}

static void unpack_19_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 228 bits of data.
	// Input must be at least 30 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);
}

static void unpack_19_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 228 bits of data.
	// Input must be at least 30 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);
}

static void unpack_20_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 240 bits of data.
	// Input must be at least 30 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);
}

static void unpack_20_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 240 bits of data.
	// Input must be at least 30 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);
}

static void unpack_20_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);
}

static void unpack_20_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);
}

static void unpack_20_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);
}

static void unpack_20_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);
}

static void unpack_20_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);
}

static void unpack_20_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);
}

static void unpack_20_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);
}

static void unpack_20_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);
}

static void unpack_20_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);
}

static void unpack_20_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);
}

static void unpack_20_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);
}

static void unpack_20_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);
}

static void unpack_20_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);
}

static void unpack_20_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);
}

static void unpack_21_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);
}

static void unpack_21_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);
}

static void unpack_21_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);
}

static void unpack_21_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);
}

static void unpack_21_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);
}

static void unpack_21_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);
}

static void unpack_21_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);
}

static void unpack_21_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);
}

static void unpack_21_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);
}

static void unpack_21_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);
}

static void unpack_21_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 252 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);
}

static void unpack_21_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 252 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);
}

static void unpack_21_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 252 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);
}

static void unpack_21_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 252 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);
}

static void unpack_21_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 252 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);
}

static void unpack_21_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 252 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);
}

static void unpack_22_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 264 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);
}

static void unpack_22_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 264 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);
}

static void unpack_22_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);
}

static void unpack_22_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);
}

static void unpack_22_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);
}

static void unpack_22_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);
}

static void unpack_22_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);
}

static void unpack_22_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);
}

static void unpack_22_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);
}

static void unpack_22_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);
}

static void unpack_22_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);
}

static void unpack_22_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);
}

static void unpack_22_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);
}

static void unpack_22_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);
}

static void unpack_22_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);
}

static void unpack_22_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);
}

static void unpack_23_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 276 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);
}

static void unpack_23_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 276 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);
}

static void unpack_23_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 276 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);
}

static void unpack_23_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 276 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);
}

static void unpack_23_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 276 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);
}

static void unpack_23_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 276 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);
}

static void unpack_23_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 276 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);
}

static void unpack_23_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 276 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);
}

static void unpack_23_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 276 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);
}

static void unpack_23_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 276 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);
}

static void unpack_23_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 276 bits of data.
	// Input must be at least 36 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);
}

static void unpack_23_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 276 bits of data.
	// Input must be at least 36 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);
}

static void unpack_23_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 276 bits of data.
	// Input must be at least 36 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);
}

static void unpack_23_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 276 bits of data.
	// Input must be at least 36 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);
}

static void unpack_23_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 276 bits of data.
	// Input must be at least 36 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);
}

static void unpack_23_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 276 bits of data.
	// Input must be at least 36 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);
}

static void unpack_24_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 288 bits of data.
	// Input must be at least 36 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);
}

static void unpack_24_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 288 bits of data.
	// Input must be at least 36 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);
}

static void unpack_24_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);
}

static void unpack_24_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);
}

static void unpack_24_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);
}

static void unpack_24_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);
}

static void unpack_24_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);
}

static void unpack_24_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);
}

static void unpack_24_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);
}

static void unpack_24_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);
}

static void unpack_24_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);
}

static void unpack_24_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);
}

static void unpack_24_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);
}

static void unpack_24_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);
}

static void unpack_24_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);
}

static void unpack_24_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);
}

static void unpack_25_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 300 bits of data.
	// Input must be at least 38 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);
}

static void unpack_25_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 300 bits of data.
	// Input must be at least 38 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);
}

static void unpack_25_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 300 bits of data.
	// Input must be at least 38 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);
}

static void unpack_25_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 300 bits of data.
	// Input must be at least 38 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);
}

static void unpack_25_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 300 bits of data.
	// Input must be at least 38 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);
}

static void unpack_25_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 300 bits of data.
	// Input must be at least 38 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);
}

static void unpack_25_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 300 bits of data.
	// Input must be at least 38 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);
}

static void unpack_25_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 300 bits of data.
	// Input must be at least 38 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);
}

static void unpack_25_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 300 bits of data.
	// Input must be at least 38 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);
}

static void unpack_25_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 300 bits of data.
	// Input must be at least 38 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);
}

static void unpack_25_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 300 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);
}

static void unpack_25_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 300 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);
}

static void unpack_25_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 300 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);
}

static void unpack_25_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 300 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);
}

static void unpack_25_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 300 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);
}

static void unpack_25_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 300 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);
}

static void unpack_26_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 312 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);
}

static void unpack_26_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 312 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);
}

static void unpack_26_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);
}

static void unpack_26_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);
}

static void unpack_26_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);
}

static void unpack_26_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);
}

static void unpack_26_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);
}

static void unpack_26_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);
}

static void unpack_26_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);
}

static void unpack_26_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);
}

static void unpack_26_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);
}

static void unpack_26_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);
}

static void unpack_26_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);
}

static void unpack_26_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);
}

static void unpack_26_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);
}

static void unpack_26_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);
}

static void unpack_27_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 324 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);
}

static void unpack_27_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 324 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);
}

static void unpack_27_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 324 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);
}

static void unpack_27_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 324 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);
}

static void unpack_27_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 324 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);
}

static void unpack_27_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 324 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);
}

static void unpack_27_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 324 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);
}

static void unpack_27_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 324 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);
}

static void unpack_27_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 324 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);
}

static void unpack_27_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 324 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);
}

static void unpack_27_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 324 bits of data.
	// Input must be at least 42 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);
}

static void unpack_27_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 324 bits of data.
	// Input must be at least 42 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);
}

static void unpack_27_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 324 bits of data.
	// Input must be at least 42 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);
}

static void unpack_27_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 324 bits of data.
	// Input must be at least 42 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);
}

static void unpack_27_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 324 bits of data.
	// Input must be at least 42 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);
}

static void unpack_27_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 324 bits of data.
	// Input must be at least 42 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);
}

static void unpack_28_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 336 bits of data.
	// Input must be at least 42 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);
}

static void unpack_28_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 336 bits of data.
	// Input must be at least 42 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);
}

static void unpack_28_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);
}

static void unpack_28_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);
}

static void unpack_28_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);
}

static void unpack_28_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);
}

static void unpack_28_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);
}

static void unpack_28_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);
}

static void unpack_28_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);
}

static void unpack_28_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);
}

static void unpack_28_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);
}

static void unpack_28_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);
}

static void unpack_28_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);
}

static void unpack_28_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);
}

static void unpack_28_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);
}

static void unpack_28_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);
}

static void unpack_29_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 348 bits of data.
	// Input must be at least 44 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);
}

static void unpack_29_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 348 bits of data.
	// Input must be at least 44 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);
}

static void unpack_29_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 348 bits of data.
	// Input must be at least 44 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);
}

static void unpack_29_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 348 bits of data.
	// Input must be at least 44 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);
}

static void unpack_29_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 348 bits of data.
	// Input must be at least 44 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);
}

static void unpack_29_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 348 bits of data.
	// Input must be at least 44 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);
}

static void unpack_29_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 348 bits of data.
	// Input must be at least 44 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);
}

static void unpack_29_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 348 bits of data.
	// Input must be at least 44 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);
}

static void unpack_29_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 348 bits of data.
	// Input must be at least 44 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);
}

static void unpack_29_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 348 bits of data.
	// Input must be at least 44 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);
}

static void unpack_29_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 348 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);
}

static void unpack_29_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 348 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);
}

static void unpack_29_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 348 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);
}

static void unpack_29_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 348 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);
}

static void unpack_29_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 348 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);
}

static void unpack_29_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 348 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);
}

static void unpack_30_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 360 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);
}

static void unpack_30_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 360 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);
}

static void unpack_30_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);
}

static void unpack_30_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);
}

static void unpack_30_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);
}

static void unpack_30_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);
}

static void unpack_30_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);
}

static void unpack_30_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);
}

static void unpack_30_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);
}

static void unpack_30_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);
}

static void unpack_30_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);
}

static void unpack_30_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);
}

static void unpack_30_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);
}

static void unpack_30_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);
}

static void unpack_30_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);
}

static void unpack_30_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);
}

static void unpack_31_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 372 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);
}

static void unpack_31_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 372 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);
}

static void unpack_31_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 372 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);
}

static void unpack_31_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 372 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);
}

static void unpack_31_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 372 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);
}

static void unpack_31_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 372 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);
}

static void unpack_31_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 372 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);
}

static void unpack_31_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 372 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);
}

static void unpack_31_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 372 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);
}

static void unpack_31_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 372 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);
}

static void unpack_31_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 372 bits of data.
	// Input must be at least 48 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);
}

static void unpack_31_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 372 bits of data.
	// Input must be at least 48 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);
}

static void unpack_31_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 372 bits of data.
	// Input must be at least 48 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);
}

static void unpack_31_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 372 bits of data.
	// Input must be at least 48 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);
}

static void unpack_31_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 372 bits of data.
	// Input must be at least 48 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);
}

static void unpack_31_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 372 bits of data.
	// Input must be at least 48 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);
}

static void unpack_32_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 384 bits of data.
	// Input must be at least 48 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);
}

static void unpack_32_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 384 bits of data.
	// Input must be at least 48 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);
}

static void unpack_32_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);
}

static void unpack_32_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);
}

static void unpack_32_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);
}

static void unpack_32_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);
}

static void unpack_32_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);
}

static void unpack_32_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);
}

static void unpack_32_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);
}

static void unpack_32_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);
}

static void unpack_32_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);
}

static void unpack_32_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);
}

static void unpack_32_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);
}

static void unpack_32_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);
}

static void unpack_32_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);
}

static void unpack_32_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);
}

static void unpack_33_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 396 bits of data.
	// Input must be at least 50 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);
}

static void unpack_33_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 396 bits of data.
	// Input must be at least 50 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);
}

static void unpack_33_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 396 bits of data.
	// Input must be at least 50 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);
}

static void unpack_33_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 396 bits of data.
	// Input must be at least 50 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);
}

static void unpack_33_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 396 bits of data.
	// Input must be at least 50 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);
}

static void unpack_33_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 396 bits of data.
	// Input must be at least 50 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);
}

static void unpack_33_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 396 bits of data.
	// Input must be at least 50 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);
}

static void unpack_33_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 396 bits of data.
	// Input must be at least 50 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);
}

static void unpack_33_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 396 bits of data.
	// Input must be at least 50 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);
}

static void unpack_33_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 396 bits of data.
	// Input must be at least 50 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);
}

static void unpack_33_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 396 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);
}

static void unpack_33_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 396 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);
}

static void unpack_33_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 396 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);
}

static void unpack_33_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 396 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);
}

static void unpack_33_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 396 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);
}

static void unpack_33_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 396 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);
}

static void unpack_34_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 408 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);
}

static void unpack_34_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 408 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);
}

static void unpack_34_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);
}

static void unpack_34_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);
}

static void unpack_34_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);
}

static void unpack_34_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);
}

static void unpack_34_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);
}

static void unpack_34_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);
}

static void unpack_34_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);
}

static void unpack_34_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);
}

static void unpack_34_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);
}

static void unpack_34_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);
}

static void unpack_34_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);
}

static void unpack_34_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);
}

static void unpack_34_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);
}

static void unpack_34_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);
}

static void unpack_35_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);
}

static void unpack_35_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);
}

static void unpack_35_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);
}

static void unpack_35_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);
}

static void unpack_35_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);
}

static void unpack_35_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);
}

static void unpack_35_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);
}

static void unpack_35_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);
}

static void unpack_35_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);
}

static void unpack_35_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);
}

static void unpack_35_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 420 bits of data.
	// Input must be at least 54 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);
}

static void unpack_35_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 420 bits of data.
	// Input must be at least 54 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);
}

static void unpack_35_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 420 bits of data.
	// Input must be at least 54 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);
}

static void unpack_35_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 420 bits of data.
	// Input must be at least 54 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);
}

static void unpack_35_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 420 bits of data.
	// Input must be at least 54 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);
}

static void unpack_35_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 420 bits of data.
	// Input must be at least 54 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);
}

static void unpack_36_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 432 bits of data.
	// Input must be at least 54 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 420 to 431
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20);
	output[35] = (double)(value >> 20);
}

static void unpack_36_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 432 bits of data.
	// Input must be at least 54 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 420 to 431
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20);
	output[35] = (double)(value >> 20);
}

static void unpack_36_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 421 to 432
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0x80) << 13);
	output[35] = (double)(value >> 20);
}

static void unpack_36_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 421 to 432
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0x80) << 13);
	output[35] = (double)(value >> 20);
}

static void unpack_36_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 422 to 433
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xc0) << 14);
	output[35] = (double)(value >> 20);
}

static void unpack_36_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 422 to 433
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xc0) << 14);
	output[35] = (double)(value >> 20);
}

static void unpack_36_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 423 to 434
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xe0) << 15);
	output[35] = (double)(value >> 20);
}

static void unpack_36_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 423 to 434
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xe0) << 15);
	output[35] = (double)(value >> 20);
}

static void unpack_36_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 424 to 435
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)(input[54] & 0xf0) << 16);
	output[35] = (double)(value >> 20);
}

static void unpack_36_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 424 to 435
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)(input[54] & 0xf0) << 16);
	output[35] = (double)(value >> 20);
}

static void unpack_36_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 425 to 436
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)(input[54] & 0xf8) << 17);
	output[35] = (double)(value >> 20);
}

static void unpack_36_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 425 to 436
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)(input[54] & 0xf8) << 17);
	output[35] = (double)(value >> 20);
}

static void unpack_36_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 426 to 437
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)(input[54] & 0xfc) << 18);
	output[35] = (double)(value >> 20);
}

static void unpack_36_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 426 to 437
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)(input[54] & 0xfc) << 18);
	output[35] = (double)(value >> 20);
}

static void unpack_36_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 427 to 438
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)(input[54] & 0xfe) << 19);
	output[35] = (double)(value >> 20);
}

static void unpack_36_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 427 to 438
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)(input[54] & 0xfe) << 19);
	output[35] = (double)(value >> 20);
}

static void unpack_37_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 444 bits of data.
	// Input must be at least 56 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 420 to 431
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 432 to 443
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)(input[55] & 0xf0) << 16);
	output[36] = (double)(value >> 20);
}

static void unpack_37_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 444 bits of data.
	// Input must be at least 56 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 420 to 431
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 432 to 443
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)(input[55] & 0xf0) << 16);
	output[36] = (double)(value >> 20);
}

static void unpack_37_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 444 bits of data.
	// Input must be at least 56 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 421 to 432
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0x80) << 13);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 433 to 444
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)(input[55] & 0xf8) << 17);
	output[36] = (double)(value >> 20);
}

static void unpack_37_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 444 bits of data.
	// Input must be at least 56 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 421 to 432
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0x80) << 13);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 433 to 444
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)(input[55] & 0xf8) << 17);
	output[36] = (double)(value >> 20);
}

static void unpack_37_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 444 bits of data.
	// Input must be at least 56 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 422 to 433
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xc0) << 14);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 434 to 445
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)(input[55] & 0xfc) << 18);
	output[36] = (double)(value >> 20);
}

static void unpack_37_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 444 bits of data.
	// Input must be at least 56 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 422 to 433
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xc0) << 14);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 434 to 445
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)(input[55] & 0xfc) << 18);
	output[36] = (double)(value >> 20);
}

static void unpack_37_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 444 bits of data.
	// Input must be at least 56 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 423 to 434
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xe0) << 15);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 435 to 446
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)(input[55] & 0xfe) << 19);
	output[36] = (double)(value >> 20);
}

static void unpack_37_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 444 bits of data.
	// Input must be at least 56 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 423 to 434
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xe0) << 15);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 435 to 446
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)(input[55] & 0xfe) << 19);
	output[36] = (double)(value >> 20);
}

static void unpack_37_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 444 bits of data.
	// Input must be at least 56 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 424 to 435
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)(input[54] & 0xf0) << 16);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 436 to 447
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20);
	output[36] = (double)(value >> 20);
}

static void unpack_37_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 444 bits of data.
	// Input must be at least 56 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 424 to 435
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)(input[54] & 0xf0) << 16);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 436 to 447
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20);
	output[36] = (double)(value >> 20);
}

static void unpack_37_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 444 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 425 to 436
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)(input[54] & 0xf8) << 17);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 437 to 448
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0x80) << 13);
	output[36] = (double)(value >> 20);
}

static void unpack_37_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 444 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 425 to 436
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)(input[54] & 0xf8) << 17);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 437 to 448
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0x80) << 13);
	output[36] = (double)(value >> 20);
}

static void unpack_37_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 444 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 426 to 437
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)(input[54] & 0xfc) << 18);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 438 to 449
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xc0) << 14);
	output[36] = (double)(value >> 20);
}

static void unpack_37_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 444 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 426 to 437
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)(input[54] & 0xfc) << 18);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 438 to 449
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xc0) << 14);
	output[36] = (double)(value >> 20);
}

static void unpack_37_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 444 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 427 to 438
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)(input[54] & 0xfe) << 19);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 439 to 450
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xe0) << 15);
	output[36] = (double)(value >> 20);
}

static void unpack_37_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 444 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 427 to 438
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)(input[54] & 0xfe) << 19);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 439 to 450
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xe0) << 15);
	output[36] = (double)(value >> 20);
}

static void unpack_38_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 456 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 420 to 431
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 432 to 443
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)(input[55] & 0xf0) << 16);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 444 to 455
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20);
	output[37] = (double)(value >> 20);
}

static void unpack_38_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 456 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 420 to 431
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 432 to 443
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)(input[55] & 0xf0) << 16);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 444 to 455
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20);
	output[37] = (double)(value >> 20);
}

static void unpack_38_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 421 to 432
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0x80) << 13);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 433 to 444
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)(input[55] & 0xf8) << 17);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 445 to 456
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0x80) << 13);
	output[37] = (double)(value >> 20);
}

static void unpack_38_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 421 to 432
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0x80) << 13);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 433 to 444
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)(input[55] & 0xf8) << 17);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 445 to 456
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0x80) << 13);
	output[37] = (double)(value >> 20);
}

static void unpack_38_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 422 to 433
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xc0) << 14);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 434 to 445
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)(input[55] & 0xfc) << 18);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 446 to 457
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xc0) << 14);
	output[37] = (double)(value >> 20);
}

static void unpack_38_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 422 to 433
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xc0) << 14);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 434 to 445
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)(input[55] & 0xfc) << 18);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 446 to 457
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xc0) << 14);
	output[37] = (double)(value >> 20);
}

static void unpack_38_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 423 to 434
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xe0) << 15);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 435 to 446
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)(input[55] & 0xfe) << 19);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 447 to 458
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)(input[57] & 0xe0) << 15);
	output[37] = (double)(value >> 20);
}

static void unpack_38_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 423 to 434
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xe0) << 15);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 435 to 446
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)(input[55] & 0xfe) << 19);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 447 to 458
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)(input[57] & 0xe0) << 15);
	output[37] = (double)(value >> 20);
}

static void unpack_38_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 424 to 435
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)(input[54] & 0xf0) << 16);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 436 to 447
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 448 to 459
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)(input[57] & 0xf0) << 16);
	output[37] = (double)(value >> 20);
}

static void unpack_38_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 424 to 435
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)(input[54] & 0xf0) << 16);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 436 to 447
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 448 to 459
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)(input[57] & 0xf0) << 16);
	output[37] = (double)(value >> 20);
}

static void unpack_38_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 425 to 436
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)(input[54] & 0xf8) << 17);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 437 to 448
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0x80) << 13);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 449 to 460
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)(input[57] & 0xf8) << 17);
	output[37] = (double)(value >> 20);
}

static void unpack_38_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 425 to 436
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)(input[54] & 0xf8) << 17);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 437 to 448
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0x80) << 13);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 449 to 460
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)(input[57] & 0xf8) << 17);
	output[37] = (double)(value >> 20);
}

static void unpack_38_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 426 to 437
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)(input[54] & 0xfc) << 18);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 438 to 449
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xc0) << 14);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 450 to 461
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)(input[57] & 0xfc) << 18);
	output[37] = (double)(value >> 20);
}

static void unpack_38_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 426 to 437
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)(input[54] & 0xfc) << 18);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 438 to 449
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xc0) << 14);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 450 to 461
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)(input[57] & 0xfc) << 18);
	output[37] = (double)(value >> 20);
}

static void unpack_38_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 427 to 438
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)(input[54] & 0xfe) << 19);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 439 to 450
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xe0) << 15);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 451 to 462
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)(input[57] & 0xfe) << 19);
	output[37] = (double)(value >> 20);
}

static void unpack_38_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 427 to 438
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)(input[54] & 0xfe) << 19);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 439 to 450
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xe0) << 15);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 451 to 462
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)(input[57] & 0xfe) << 19);
	output[37] = (double)(value >> 20);
}

static void unpack_39_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 468 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 420 to 431
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 432 to 443
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)(input[55] & 0xf0) << 16);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 444 to 455
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 456 to 467
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)(input[58] & 0xf0) << 16);
	output[38] = (double)(value >> 20);
}

static void unpack_39_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 468 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 420 to 431
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 432 to 443
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)(input[55] & 0xf0) << 16);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 444 to 455
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 456 to 467
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)(input[58] & 0xf0) << 16);
	output[38] = (double)(value >> 20);
}

static void unpack_39_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 468 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 421 to 432
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0x80) << 13);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 433 to 444
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)(input[55] & 0xf8) << 17);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 445 to 456
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0x80) << 13);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 457 to 468
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)(input[58] & 0xf8) << 17);
	output[38] = (double)(value >> 20);
}

static void unpack_39_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 468 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 421 to 432
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0x80) << 13);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 433 to 444
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)(input[55] & 0xf8) << 17);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 445 to 456
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0x80) << 13);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 457 to 468
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)(input[58] & 0xf8) << 17);
	output[38] = (double)(value >> 20);
}

static void unpack_39_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 468 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 422 to 433
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xc0) << 14);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 434 to 445
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)(input[55] & 0xfc) << 18);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 446 to 457
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xc0) << 14);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 458 to 469
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)(input[58] & 0xfc) << 18);
	output[38] = (double)(value >> 20);
}

static void unpack_39_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 468 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 422 to 433
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xc0) << 14);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 434 to 445
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)(input[55] & 0xfc) << 18);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 446 to 457
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xc0) << 14);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 458 to 469
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)(input[58] & 0xfc) << 18);
	output[38] = (double)(value >> 20);
}

static void unpack_39_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 468 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 423 to 434
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xe0) << 15);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 435 to 446
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)(input[55] & 0xfe) << 19);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 447 to 458
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)(input[57] & 0xe0) << 15);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 459 to 470
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)(input[58] & 0xfe) << 19);
	output[38] = (double)(value >> 20);
}

static void unpack_39_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 468 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 423 to 434
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xe0) << 15);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 435 to 446
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)(input[55] & 0xfe) << 19);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 447 to 458
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)(input[57] & 0xe0) << 15);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 459 to 470
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)(input[58] & 0xfe) << 19);
	output[38] = (double)(value >> 20);
}

static void unpack_39_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 468 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 424 to 435
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)(input[54] & 0xf0) << 16);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 436 to 447
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 448 to 459
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)(input[57] & 0xf0) << 16);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 460 to 471
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20);
	output[38] = (double)(value >> 20);
}

static void unpack_39_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 468 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 424 to 435
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)(input[54] & 0xf0) << 16);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 436 to 447
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 448 to 459
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)(input[57] & 0xf0) << 16);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 460 to 471
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20);
	output[38] = (double)(value >> 20);
}

static void unpack_39_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 468 bits of data.
	// Input must be at least 60 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 425 to 436
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)(input[54] & 0xf8) << 17);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 437 to 448
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0x80) << 13);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 449 to 460
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)(input[57] & 0xf8) << 17);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 461 to 472
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)(input[59] & 0x80) << 13);
	output[38] = (double)(value >> 20);
}

static void unpack_39_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 468 bits of data.
	// Input must be at least 60 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 425 to 436
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)(input[54] & 0xf8) << 17);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 437 to 448
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0x80) << 13);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 449 to 460
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)(input[57] & 0xf8) << 17);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 461 to 472
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)(input[59] & 0x80) << 13);
	output[38] = (double)(value >> 20);
}

static void unpack_39_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 468 bits of data.
	// Input must be at least 60 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 426 to 437
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)(input[54] & 0xfc) << 18);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 438 to 449
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xc0) << 14);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 450 to 461
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)(input[57] & 0xfc) << 18);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 462 to 473
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)(input[59] & 0xc0) << 14);
	output[38] = (double)(value >> 20);
}

static void unpack_39_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 468 bits of data.
	// Input must be at least 60 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 426 to 437
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)(input[54] & 0xfc) << 18);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 438 to 449
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xc0) << 14);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 450 to 461
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)(input[57] & 0xfc) << 18);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 462 to 473
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)(input[59] & 0xc0) << 14);
	output[38] = (double)(value >> 20);
}

static void unpack_39_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 468 bits of data.
	// Input must be at least 60 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 427 to 438
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)(input[54] & 0xfe) << 19);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 439 to 450
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xe0) << 15);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 451 to 462
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)(input[57] & 0xfe) << 19);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 463 to 474
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)(input[59] & 0xe0) << 15);
	output[38] = (double)(value >> 20);
}

static void unpack_39_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 468 bits of data.
	// Input must be at least 60 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 427 to 438
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)(input[54] & 0xfe) << 19);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 439 to 450
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xe0) << 15);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 451 to 462
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)(input[57] & 0xfe) << 19);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 463 to 474
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)(input[59] & 0xe0) << 15);
	output[38] = (double)(value >> 20);
}

static void unpack_40_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 480 bits of data.
	// Input must be at least 60 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 420 to 431
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 432 to 443
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)(input[55] & 0xf0) << 16);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 444 to 455
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 456 to 467
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)(input[58] & 0xf0) << 16);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 468 to 479
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20);
	output[39] = (double)(value >> 20);
}

static void unpack_40_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 480 bits of data.
	// Input must be at least 60 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 420 to 431
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 432 to 443
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)(input[55] & 0xf0) << 16);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 444 to 455
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 456 to 467
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)(input[58] & 0xf0) << 16);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 468 to 479
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20);
	output[39] = (double)(value >> 20);
}

static void unpack_40_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 421 to 432
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0x80) << 13);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 433 to 444
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)(input[55] & 0xf8) << 17);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 445 to 456
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0x80) << 13);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 457 to 468
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)(input[58] & 0xf8) << 17);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 469 to 480
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0x80) << 13);
	output[39] = (double)(value >> 20);
}

static void unpack_40_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 421 to 432
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0x80) << 13);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 433 to 444
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)(input[55] & 0xf8) << 17);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 445 to 456
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0x80) << 13);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 457 to 468
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)(input[58] & 0xf8) << 17);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 469 to 480
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0x80) << 13);
	output[39] = (double)(value >> 20);
}

static void unpack_40_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 422 to 433
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xc0) << 14);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 434 to 445
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)(input[55] & 0xfc) << 18);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 446 to 457
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xc0) << 14);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 458 to 469
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)(input[58] & 0xfc) << 18);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 470 to 481
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xc0) << 14);
	output[39] = (double)(value >> 20);
}

static void unpack_40_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 422 to 433
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xc0) << 14);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 434 to 445
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)(input[55] & 0xfc) << 18);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 446 to 457
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xc0) << 14);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 458 to 469
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)(input[58] & 0xfc) << 18);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 470 to 481
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xc0) << 14);
	output[39] = (double)(value >> 20);
}

static void unpack_40_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 423 to 434
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xe0) << 15);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 435 to 446
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)(input[55] & 0xfe) << 19);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 447 to 458
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)(input[57] & 0xe0) << 15);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 459 to 470
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)(input[58] & 0xfe) << 19);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 471 to 482
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xe0) << 15);
	output[39] = (double)(value >> 20);
}

static void unpack_40_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 423 to 434
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xe0) << 15);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 435 to 446
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)(input[55] & 0xfe) << 19);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 447 to 458
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)(input[57] & 0xe0) << 15);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 459 to 470
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)(input[58] & 0xfe) << 19);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 471 to 482
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xe0) << 15);
	output[39] = (double)(value >> 20);
}

static void unpack_40_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 424 to 435
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)(input[54] & 0xf0) << 16);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 436 to 447
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 448 to 459
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)(input[57] & 0xf0) << 16);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 460 to 471
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 472 to 483
	value = ((uint32_t)input[59] << 24) |
			((uint32_t)(input[60] & 0xf0) << 16);
	output[39] = (double)(value >> 20);
}

static void unpack_40_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 424 to 435
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)(input[54] & 0xf0) << 16);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 436 to 447
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 448 to 459
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)(input[57] & 0xf0) << 16);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 460 to 471
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 472 to 483
	value = ((uint32_t)input[59] << 24) |
			((uint32_t)(input[60] & 0xf0) << 16);
	output[39] = (double)(value >> 20);
}

static void unpack_40_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 425 to 436
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)(input[54] & 0xf8) << 17);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 437 to 448
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0x80) << 13);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 449 to 460
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)(input[57] & 0xf8) << 17);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 461 to 472
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)(input[59] & 0x80) << 13);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 473 to 484
	value = ((uint32_t)(input[59] & 0x7f) << 25) |
			((uint32_t)(input[60] & 0xf8) << 17);
	output[39] = (double)(value >> 20);
}

static void unpack_40_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 425 to 436
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)(input[54] & 0xf8) << 17);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 437 to 448
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0x80) << 13);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 449 to 460
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)(input[57] & 0xf8) << 17);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 461 to 472
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)(input[59] & 0x80) << 13);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 473 to 484
	value = ((uint32_t)(input[59] & 0x7f) << 25) |
			((uint32_t)(input[60] & 0xf8) << 17);
	output[39] = (double)(value >> 20);
}

static void unpack_40_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 426 to 437
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)(input[54] & 0xfc) << 18);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 438 to 449
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xc0) << 14);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 450 to 461
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)(input[57] & 0xfc) << 18);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 462 to 473
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)(input[59] & 0xc0) << 14);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 474 to 485
	value = ((uint32_t)(input[59] & 0x3f) << 26) |
			((uint32_t)(input[60] & 0xfc) << 18);
	output[39] = (double)(value >> 20);
}

static void unpack_40_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 426 to 437
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)(input[54] & 0xfc) << 18);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 438 to 449
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xc0) << 14);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 450 to 461
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)(input[57] & 0xfc) << 18);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 462 to 473
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)(input[59] & 0xc0) << 14);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 474 to 485
	value = ((uint32_t)(input[59] & 0x3f) << 26) |
			((uint32_t)(input[60] & 0xfc) << 18);
	output[39] = (double)(value >> 20);
}

static void unpack_40_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 427 to 438
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)(input[54] & 0xfe) << 19);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 439 to 450
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xe0) << 15);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 451 to 462
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)(input[57] & 0xfe) << 19);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 463 to 474
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)(input[59] & 0xe0) << 15);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 475 to 486
	value = ((uint32_t)(input[59] & 0x1f) << 27) |
			((uint32_t)(input[60] & 0xfe) << 19);
	output[39] = (double)(value >> 20);
}

static void unpack_40_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 427 to 438
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)(input[54] & 0xfe) << 19);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 439 to 450
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xe0) << 15);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 451 to 462
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)(input[57] & 0xfe) << 19);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 463 to 474
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)(input[59] & 0xe0) << 15);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 475 to 486
	value = ((uint32_t)(input[59] & 0x1f) << 27) |
			((uint32_t)(input[60] & 0xfe) << 19);
	output[39] = (double)(value >> 20);
}

static void unpack_41_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 492 bits of data.
	// Input must be at least 62 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 420 to 431
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 432 to 443
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)(input[55] & 0xf0) << 16);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 444 to 455
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 456 to 467
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)(input[58] & 0xf0) << 16);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 468 to 479
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 480 to 491
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)(input[61] & 0xf0) << 16);
	output[40] = (double)(value >> 20);
}

static void unpack_41_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 492 bits of data.
	// Input must be at least 62 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 420 to 431
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 432 to 443
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)(input[55] & 0xf0) << 16);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 444 to 455
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 456 to 467
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)(input[58] & 0xf0) << 16);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 468 to 479
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 480 to 491
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)(input[61] & 0xf0) << 16);
	output[40] = (double)(value >> 20);
}

static void unpack_41_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 492 bits of data.
	// Input must be at least 62 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 421 to 432
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0x80) << 13);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 433 to 444
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)(input[55] & 0xf8) << 17);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 445 to 456
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0x80) << 13);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 457 to 468
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)(input[58] & 0xf8) << 17);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 469 to 480
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0x80) << 13);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 481 to 492
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)(input[61] & 0xf8) << 17);
	output[40] = (double)(value >> 20);
}

static void unpack_41_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 492 bits of data.
	// Input must be at least 62 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 421 to 432
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0x80) << 13);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 433 to 444
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)(input[55] & 0xf8) << 17);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 445 to 456
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0x80) << 13);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 457 to 468
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)(input[58] & 0xf8) << 17);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 469 to 480
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0x80) << 13);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 481 to 492
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)(input[61] & 0xf8) << 17);
	output[40] = (double)(value >> 20);
}

static void unpack_41_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 492 bits of data.
	// Input must be at least 62 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 422 to 433
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xc0) << 14);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 434 to 445
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)(input[55] & 0xfc) << 18);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 446 to 457
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xc0) << 14);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 458 to 469
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)(input[58] & 0xfc) << 18);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 470 to 481
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xc0) << 14);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 482 to 493
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)(input[61] & 0xfc) << 18);
	output[40] = (double)(value >> 20);
}

static void unpack_41_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 492 bits of data.
	// Input must be at least 62 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 422 to 433
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xc0) << 14);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 434 to 445
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)(input[55] & 0xfc) << 18);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 446 to 457
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xc0) << 14);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 458 to 469
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)(input[58] & 0xfc) << 18);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 470 to 481
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xc0) << 14);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 482 to 493
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)(input[61] & 0xfc) << 18);
	output[40] = (double)(value >> 20);
}

static void unpack_41_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 492 bits of data.
	// Input must be at least 62 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 423 to 434
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xe0) << 15);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 435 to 446
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)(input[55] & 0xfe) << 19);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 447 to 458
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)(input[57] & 0xe0) << 15);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 459 to 470
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)(input[58] & 0xfe) << 19);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 471 to 482
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xe0) << 15);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 483 to 494
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)(input[61] & 0xfe) << 19);
	output[40] = (double)(value >> 20);
}

static void unpack_41_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 492 bits of data.
	// Input must be at least 62 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 423 to 434
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xe0) << 15);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 435 to 446
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)(input[55] & 0xfe) << 19);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 447 to 458
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)(input[57] & 0xe0) << 15);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 459 to 470
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)(input[58] & 0xfe) << 19);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 471 to 482
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xe0) << 15);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 483 to 494
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)(input[61] & 0xfe) << 19);
	output[40] = (double)(value >> 20);
}

static void unpack_41_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 492 bits of data.
	// Input must be at least 62 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 424 to 435
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)(input[54] & 0xf0) << 16);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 436 to 447
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 448 to 459
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)(input[57] & 0xf0) << 16);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 460 to 471
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 472 to 483
	value = ((uint32_t)input[59] << 24) |
			((uint32_t)(input[60] & 0xf0) << 16);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 484 to 495
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20);
	output[40] = (double)(value >> 20);
}

static void unpack_41_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 492 bits of data.
	// Input must be at least 62 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 424 to 435
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)(input[54] & 0xf0) << 16);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 436 to 447
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 448 to 459
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)(input[57] & 0xf0) << 16);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 460 to 471
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 472 to 483
	value = ((uint32_t)input[59] << 24) |
			((uint32_t)(input[60] & 0xf0) << 16);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 484 to 495
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20);
	output[40] = (double)(value >> 20);
}

static void unpack_41_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 492 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 425 to 436
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)(input[54] & 0xf8) << 17);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 437 to 448
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0x80) << 13);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 449 to 460
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)(input[57] & 0xf8) << 17);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 461 to 472
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)(input[59] & 0x80) << 13);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 473 to 484
	value = ((uint32_t)(input[59] & 0x7f) << 25) |
			((uint32_t)(input[60] & 0xf8) << 17);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 485 to 496
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0x80) << 13);
	output[40] = (double)(value >> 20);
}

static void unpack_41_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 492 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 425 to 436
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)(input[54] & 0xf8) << 17);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 437 to 448
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0x80) << 13);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 449 to 460
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)(input[57] & 0xf8) << 17);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 461 to 472
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)(input[59] & 0x80) << 13);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 473 to 484
	value = ((uint32_t)(input[59] & 0x7f) << 25) |
			((uint32_t)(input[60] & 0xf8) << 17);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 485 to 496
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0x80) << 13);
	output[40] = (double)(value >> 20);
}

static void unpack_41_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 492 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 426 to 437
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)(input[54] & 0xfc) << 18);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 438 to 449
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xc0) << 14);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 450 to 461
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)(input[57] & 0xfc) << 18);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 462 to 473
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)(input[59] & 0xc0) << 14);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 474 to 485
	value = ((uint32_t)(input[59] & 0x3f) << 26) |
			((uint32_t)(input[60] & 0xfc) << 18);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 486 to 497
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xc0) << 14);
	output[40] = (double)(value >> 20);
}

static void unpack_41_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 492 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 426 to 437
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)(input[54] & 0xfc) << 18);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 438 to 449
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xc0) << 14);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 450 to 461
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)(input[57] & 0xfc) << 18);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 462 to 473
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)(input[59] & 0xc0) << 14);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 474 to 485
	value = ((uint32_t)(input[59] & 0x3f) << 26) |
			((uint32_t)(input[60] & 0xfc) << 18);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 486 to 497
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xc0) << 14);
	output[40] = (double)(value >> 20);
}

static void unpack_41_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 492 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 427 to 438
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)(input[54] & 0xfe) << 19);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 439 to 450
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xe0) << 15);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 451 to 462
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)(input[57] & 0xfe) << 19);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 463 to 474
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)(input[59] & 0xe0) << 15);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 475 to 486
	value = ((uint32_t)(input[59] & 0x1f) << 27) |
			((uint32_t)(input[60] & 0xfe) << 19);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 487 to 498
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xe0) << 15);
	output[40] = (double)(value >> 20);
}

static void unpack_41_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 492 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 427 to 438
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)(input[54] & 0xfe) << 19);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 439 to 450
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xe0) << 15);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 451 to 462
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)(input[57] & 0xfe) << 19);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 463 to 474
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)(input[59] & 0xe0) << 15);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 475 to 486
	value = ((uint32_t)(input[59] & 0x1f) << 27) |
			((uint32_t)(input[60] & 0xfe) << 19);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 487 to 498
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xe0) << 15);
	output[40] = (double)(value >> 20);
}

static void unpack_42_12bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit signed
	// Skip 0 bits, read 504 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 420 to 431
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 432 to 443
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)(input[55] & 0xf0) << 16);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 444 to 455
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 456 to 467
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)(input[58] & 0xf0) << 16);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 468 to 479
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 480 to 491
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)(input[61] & 0xf0) << 16);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 492 to 503
	value = ((uint32_t)(input[61] & 0x0f) << 28) |
			((uint32_t)input[62] << 20);
	output[41] = (double)(value >> 20);
}

static void unpack_42_12bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit unsigned
	// Skip 0 bits, read 504 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 11
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)(input[1] & 0xf0) << 16);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 12 to 23
	value = ((uint32_t)(input[1] & 0x0f) << 28) |
			((uint32_t)input[2] << 20);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 24 to 35
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)(input[4] & 0xf0) << 16);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 36 to 47
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 48 to 59
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)(input[7] & 0xf0) << 16);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 60 to 71
	value = ((uint32_t)(input[7] & 0x0f) << 28) |
			((uint32_t)input[8] << 20);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 72 to 83
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)(input[10] & 0xf0) << 16);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 84 to 95
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 96 to 107
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)(input[13] & 0xf0) << 16);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 108 to 119
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 120 to 131
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)(input[16] & 0xf0) << 16);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 132 to 143
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 144 to 155
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)(input[19] & 0xf0) << 16);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 156 to 167
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 168 to 179
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)(input[22] & 0xf0) << 16);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 180 to 191
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 192 to 203
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)(input[25] & 0xf0) << 16);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 204 to 215
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 216 to 227
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)(input[28] & 0xf0) << 16);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 228 to 239
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 240 to 251
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)(input[31] & 0xf0) << 16);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 252 to 263
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 264 to 275
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)(input[34] & 0xf0) << 16);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 276 to 287
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 288 to 299
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)(input[37] & 0xf0) << 16);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 300 to 311
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 312 to 323
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)(input[40] & 0xf0) << 16);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 324 to 335
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 336 to 347
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)(input[43] & 0xf0) << 16);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 348 to 359
	value = ((uint32_t)(input[43] & 0x0f) << 28) |
			((uint32_t)input[44] << 20);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 360 to 371
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)(input[46] & 0xf0) << 16);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 372 to 383
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 384 to 395
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)(input[49] & 0xf0) << 16);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 396 to 407
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 408 to 419
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)(input[52] & 0xf0) << 16);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 420 to 431
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 432 to 443
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)(input[55] & 0xf0) << 16);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 444 to 455
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 456 to 467
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)(input[58] & 0xf0) << 16);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 468 to 479
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 480 to 491
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)(input[61] & 0xf0) << 16);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 492 to 503
	value = ((uint32_t)(input[61] & 0x0f) << 28) |
			((uint32_t)input[62] << 20);
	output[41] = (double)(value >> 20);
}

static void unpack_42_12bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit signed
	// Skip 1 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 421 to 432
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0x80) << 13);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 433 to 444
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)(input[55] & 0xf8) << 17);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 445 to 456
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0x80) << 13);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 457 to 468
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)(input[58] & 0xf8) << 17);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 469 to 480
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0x80) << 13);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 481 to 492
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)(input[61] & 0xf8) << 17);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 493 to 504
	value = ((uint32_t)(input[61] & 0x07) << 29) |
			((uint32_t)input[62] << 21) |
			((uint32_t)(input[63] & 0x80) << 13);
	output[41] = (double)(value >> 20);
}

static void unpack_42_12bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit unsigned
	// Skip 1 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 12
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)(input[1] & 0xf8) << 17);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 13 to 24
	value = ((uint32_t)(input[1] & 0x07) << 29) |
			((uint32_t)input[2] << 21) |
			((uint32_t)(input[3] & 0x80) << 13);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 25 to 36
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)(input[4] & 0xf8) << 17);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 37 to 48
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0x80) << 13);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 49 to 60
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)(input[7] & 0xf8) << 17);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 61 to 72
	value = ((uint32_t)(input[7] & 0x07) << 29) |
			((uint32_t)input[8] << 21) |
			((uint32_t)(input[9] & 0x80) << 13);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 73 to 84
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)(input[10] & 0xf8) << 17);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 85 to 96
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0x80) << 13);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 97 to 108
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)(input[13] & 0xf8) << 17);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 109 to 120
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0x80) << 13);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 121 to 132
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)(input[16] & 0xf8) << 17);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 133 to 144
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0x80) << 13);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 145 to 156
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)(input[19] & 0xf8) << 17);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 157 to 168
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0x80) << 13);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 169 to 180
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)(input[22] & 0xf8) << 17);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 181 to 192
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0x80) << 13);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 193 to 204
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)(input[25] & 0xf8) << 17);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 205 to 216
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0x80) << 13);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 217 to 228
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)(input[28] & 0xf8) << 17);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 229 to 240
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0x80) << 13);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 241 to 252
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)(input[31] & 0xf8) << 17);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 253 to 264
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)(input[33] & 0x80) << 13);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 265 to 276
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)(input[34] & 0xf8) << 17);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 277 to 288
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0x80) << 13);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 289 to 300
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)(input[37] & 0xf8) << 17);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 301 to 312
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)(input[39] & 0x80) << 13);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 313 to 324
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)(input[40] & 0xf8) << 17);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 325 to 336
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0x80) << 13);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 337 to 348
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)(input[43] & 0xf8) << 17);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 349 to 360
	value = ((uint32_t)(input[43] & 0x07) << 29) |
			((uint32_t)input[44] << 21) |
			((uint32_t)(input[45] & 0x80) << 13);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 361 to 372
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)(input[46] & 0xf8) << 17);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 373 to 384
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0x80) << 13);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 385 to 396
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)(input[49] & 0xf8) << 17);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 397 to 408
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0x80) << 13);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 409 to 420
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)(input[52] & 0xf8) << 17);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 421 to 432
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0x80) << 13);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 433 to 444
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)(input[55] & 0xf8) << 17);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 445 to 456
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0x80) << 13);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 457 to 468
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)(input[58] & 0xf8) << 17);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 469 to 480
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0x80) << 13);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 481 to 492
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)(input[61] & 0xf8) << 17);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 493 to 504
	value = ((uint32_t)(input[61] & 0x07) << 29) |
			((uint32_t)input[62] << 21) |
			((uint32_t)(input[63] & 0x80) << 13);
	output[41] = (double)(value >> 20);
}

static void unpack_42_12bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit signed
	// Skip 2 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 422 to 433
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xc0) << 14);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 434 to 445
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)(input[55] & 0xfc) << 18);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 446 to 457
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xc0) << 14);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 458 to 469
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)(input[58] & 0xfc) << 18);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 470 to 481
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xc0) << 14);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 482 to 493
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)(input[61] & 0xfc) << 18);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 494 to 505
	value = ((uint32_t)(input[61] & 0x03) << 30) |
			((uint32_t)input[62] << 22) |
			((uint32_t)(input[63] & 0xc0) << 14);
	output[41] = (double)(value >> 20);
}

static void unpack_42_12bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit unsigned
	// Skip 2 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 13
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)(input[1] & 0xfc) << 18);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 14 to 25
	value = ((uint32_t)(input[1] & 0x03) << 30) |
			((uint32_t)input[2] << 22) |
			((uint32_t)(input[3] & 0xc0) << 14);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 26 to 37
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)(input[4] & 0xfc) << 18);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 38 to 49
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xc0) << 14);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 50 to 61
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)(input[7] & 0xfc) << 18);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 62 to 73
	value = ((uint32_t)(input[7] & 0x03) << 30) |
			((uint32_t)input[8] << 22) |
			((uint32_t)(input[9] & 0xc0) << 14);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 74 to 85
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)(input[10] & 0xfc) << 18);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 86 to 97
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xc0) << 14);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 98 to 109
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)(input[13] & 0xfc) << 18);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 110 to 121
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)(input[15] & 0xc0) << 14);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 122 to 133
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)(input[16] & 0xfc) << 18);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 134 to 145
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xc0) << 14);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 146 to 157
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)(input[19] & 0xfc) << 18);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 158 to 169
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xc0) << 14);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 170 to 181
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)(input[22] & 0xfc) << 18);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 182 to 193
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xc0) << 14);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 194 to 205
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)(input[25] & 0xfc) << 18);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 206 to 217
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xc0) << 14);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 218 to 229
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)(input[28] & 0xfc) << 18);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 230 to 241
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xc0) << 14);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 242 to 253
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)(input[31] & 0xfc) << 18);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 254 to 265
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)(input[33] & 0xc0) << 14);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 266 to 277
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)(input[34] & 0xfc) << 18);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 278 to 289
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xc0) << 14);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 290 to 301
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)(input[37] & 0xfc) << 18);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 302 to 313
	value = ((uint32_t)(input[37] & 0x03) << 30) |
			((uint32_t)input[38] << 22) |
			((uint32_t)(input[39] & 0xc0) << 14);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 314 to 325
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)(input[40] & 0xfc) << 18);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 326 to 337
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xc0) << 14);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 338 to 349
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)(input[43] & 0xfc) << 18);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 350 to 361
	value = ((uint32_t)(input[43] & 0x03) << 30) |
			((uint32_t)input[44] << 22) |
			((uint32_t)(input[45] & 0xc0) << 14);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 362 to 373
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)(input[46] & 0xfc) << 18);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 374 to 385
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xc0) << 14);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 386 to 397
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)(input[49] & 0xfc) << 18);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 398 to 409
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xc0) << 14);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 410 to 421
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)(input[52] & 0xfc) << 18);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 422 to 433
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xc0) << 14);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 434 to 445
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)(input[55] & 0xfc) << 18);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 446 to 457
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xc0) << 14);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 458 to 469
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)(input[58] & 0xfc) << 18);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 470 to 481
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xc0) << 14);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 482 to 493
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)(input[61] & 0xfc) << 18);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 494 to 505
	value = ((uint32_t)(input[61] & 0x03) << 30) |
			((uint32_t)input[62] << 22) |
			((uint32_t)(input[63] & 0xc0) << 14);
	output[41] = (double)(value >> 20);
}

static void unpack_42_12bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit signed
	// Skip 3 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 423 to 434
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xe0) << 15);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 435 to 446
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)(input[55] & 0xfe) << 19);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 447 to 458
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)(input[57] & 0xe0) << 15);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 459 to 470
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)(input[58] & 0xfe) << 19);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 471 to 482
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xe0) << 15);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 483 to 494
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)(input[61] & 0xfe) << 19);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 495 to 506
	value = ((uint32_t)(input[61] & 0x01) << 31) |
			((uint32_t)input[62] << 23) |
			((uint32_t)(input[63] & 0xe0) << 15);
	output[41] = (double)(value >> 20);
}

static void unpack_42_12bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit unsigned
	// Skip 3 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 14
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)(input[1] & 0xfe) << 19);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 15 to 26
	value = ((uint32_t)(input[1] & 0x01) << 31) |
			((uint32_t)input[2] << 23) |
			((uint32_t)(input[3] & 0xe0) << 15);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 27 to 38
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)(input[4] & 0xfe) << 19);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 39 to 50
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xe0) << 15);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 51 to 62
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)(input[7] & 0xfe) << 19);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 63 to 74
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)(input[9] & 0xe0) << 15);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 75 to 86
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)(input[10] & 0xfe) << 19);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 87 to 98
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xe0) << 15);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 99 to 110
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)(input[13] & 0xfe) << 19);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 111 to 122
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)(input[15] & 0xe0) << 15);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 123 to 134
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)(input[16] & 0xfe) << 19);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 135 to 146
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xe0) << 15);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 147 to 158
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)(input[19] & 0xfe) << 19);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 159 to 170
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)(input[21] & 0xe0) << 15);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 171 to 182
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)(input[22] & 0xfe) << 19);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 183 to 194
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xe0) << 15);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 195 to 206
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)(input[25] & 0xfe) << 19);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 207 to 218
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)(input[27] & 0xe0) << 15);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 219 to 230
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)(input[28] & 0xfe) << 19);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 231 to 242
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xe0) << 15);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 243 to 254
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)(input[31] & 0xfe) << 19);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 255 to 266
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)(input[33] & 0xe0) << 15);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 267 to 278
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)(input[34] & 0xfe) << 19);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 279 to 290
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xe0) << 15);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 291 to 302
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)(input[37] & 0xfe) << 19);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 303 to 314
	value = ((uint32_t)(input[37] & 0x01) << 31) |
			((uint32_t)input[38] << 23) |
			((uint32_t)(input[39] & 0xe0) << 15);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 315 to 326
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)(input[40] & 0xfe) << 19);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 327 to 338
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xe0) << 15);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 339 to 350
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)(input[43] & 0xfe) << 19);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 351 to 362
	value = ((uint32_t)(input[43] & 0x01) << 31) |
			((uint32_t)input[44] << 23) |
			((uint32_t)(input[45] & 0xe0) << 15);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 363 to 374
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)(input[46] & 0xfe) << 19);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 375 to 386
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xe0) << 15);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 387 to 398
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)(input[49] & 0xfe) << 19);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 399 to 410
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)(input[51] & 0xe0) << 15);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 411 to 422
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)(input[52] & 0xfe) << 19);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 423 to 434
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xe0) << 15);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 435 to 446
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)(input[55] & 0xfe) << 19);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 447 to 458
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)(input[57] & 0xe0) << 15);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 459 to 470
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)(input[58] & 0xfe) << 19);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 471 to 482
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xe0) << 15);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 483 to 494
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)(input[61] & 0xfe) << 19);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 495 to 506
	value = ((uint32_t)(input[61] & 0x01) << 31) |
			((uint32_t)input[62] << 23) |
			((uint32_t)(input[63] & 0xe0) << 15);
	output[41] = (double)(value >> 20);
}

static void unpack_42_12bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit signed
	// Skip 4 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 424 to 435
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)(input[54] & 0xf0) << 16);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 436 to 447
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 448 to 459
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)(input[57] & 0xf0) << 16);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 460 to 471
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 472 to 483
	value = ((uint32_t)input[59] << 24) |
			((uint32_t)(input[60] & 0xf0) << 16);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 484 to 495
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 496 to 507
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)(input[63] & 0xf0) << 16);
	output[41] = (double)(value >> 20);
}

static void unpack_42_12bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit unsigned
	// Skip 4 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 15
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 16 to 27
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)(input[3] & 0xf0) << 16);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 28 to 39
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 40 to 51
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)(input[6] & 0xf0) << 16);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 52 to 63
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 64 to 75
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)(input[9] & 0xf0) << 16);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 76 to 87
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 88 to 99
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)(input[12] & 0xf0) << 16);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 100 to 111
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 112 to 123
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)(input[15] & 0xf0) << 16);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 124 to 135
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 136 to 147
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)(input[18] & 0xf0) << 16);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 148 to 159
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 160 to 171
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)(input[21] & 0xf0) << 16);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 172 to 183
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 184 to 195
	value = ((uint32_t)input[23] << 24) |
			((uint32_t)(input[24] & 0xf0) << 16);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 196 to 207
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 208 to 219
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)(input[27] & 0xf0) << 16);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 220 to 231
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 232 to 243
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)(input[30] & 0xf0) << 16);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 244 to 255
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 256 to 267
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)(input[33] & 0xf0) << 16);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 268 to 279
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 280 to 291
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)(input[36] & 0xf0) << 16);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 292 to 303
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 304 to 315
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)(input[39] & 0xf0) << 16);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 316 to 327
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 328 to 339
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)(input[42] & 0xf0) << 16);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 340 to 351
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 352 to 363
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)(input[45] & 0xf0) << 16);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 364 to 375
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 376 to 387
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)(input[48] & 0xf0) << 16);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 388 to 399
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 400 to 411
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)(input[51] & 0xf0) << 16);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 412 to 423
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 424 to 435
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)(input[54] & 0xf0) << 16);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 436 to 447
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 448 to 459
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)(input[57] & 0xf0) << 16);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 460 to 471
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 472 to 483
	value = ((uint32_t)input[59] << 24) |
			((uint32_t)(input[60] & 0xf0) << 16);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 484 to 495
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 496 to 507
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)(input[63] & 0xf0) << 16);
	output[41] = (double)(value >> 20);
}

static void unpack_42_12bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit signed
	// Skip 5 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 425 to 436
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)(input[54] & 0xf8) << 17);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 437 to 448
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0x80) << 13);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 449 to 460
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)(input[57] & 0xf8) << 17);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 461 to 472
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)(input[59] & 0x80) << 13);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 473 to 484
	value = ((uint32_t)(input[59] & 0x7f) << 25) |
			((uint32_t)(input[60] & 0xf8) << 17);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 485 to 496
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0x80) << 13);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 497 to 508
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)(input[63] & 0xf8) << 17);
	output[41] = (double)(value >> 20);
}

static void unpack_42_12bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit unsigned
	// Skip 5 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 16
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0x80) << 13);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 17 to 28
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)(input[3] & 0xf8) << 17);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 29 to 40
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)(input[5] & 0x80) << 13);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 41 to 52
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)(input[6] & 0xf8) << 17);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 53 to 64
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0x80) << 13);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 65 to 76
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)(input[9] & 0xf8) << 17);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 77 to 88
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)(input[11] & 0x80) << 13);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 89 to 100
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)(input[12] & 0xf8) << 17);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 101 to 112
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0x80) << 13);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 113 to 124
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)(input[15] & 0xf8) << 17);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 125 to 136
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0x80) << 13);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 137 to 148
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)(input[18] & 0xf8) << 17);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 149 to 160
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0x80) << 13);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 161 to 172
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)(input[21] & 0xf8) << 17);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 173 to 184
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0x80) << 13);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 185 to 196
	value = ((uint32_t)(input[23] & 0x7f) << 25) |
			((uint32_t)(input[24] & 0xf8) << 17);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 197 to 208
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0x80) << 13);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 209 to 220
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)(input[27] & 0xf8) << 17);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 221 to 232
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0x80) << 13);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 233 to 244
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)(input[30] & 0xf8) << 17);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 245 to 256
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0x80) << 13);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 257 to 268
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)(input[33] & 0xf8) << 17);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 269 to 280
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)(input[35] & 0x80) << 13);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 281 to 292
	value = ((uint32_t)(input[35] & 0x7f) << 25) |
			((uint32_t)(input[36] & 0xf8) << 17);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 293 to 304
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0x80) << 13);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 305 to 316
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)(input[39] & 0xf8) << 17);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 317 to 328
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)(input[41] & 0x80) << 13);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 329 to 340
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)(input[42] & 0xf8) << 17);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 341 to 352
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0x80) << 13);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 353 to 364
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)(input[45] & 0xf8) << 17);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 365 to 376
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)(input[47] & 0x80) << 13);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 377 to 388
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)(input[48] & 0xf8) << 17);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 389 to 400
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0x80) << 13);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 401 to 412
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)(input[51] & 0xf8) << 17);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 413 to 424
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0x80) << 13);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 425 to 436
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)(input[54] & 0xf8) << 17);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 437 to 448
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0x80) << 13);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 449 to 460
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)(input[57] & 0xf8) << 17);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 461 to 472
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)(input[59] & 0x80) << 13);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 473 to 484
	value = ((uint32_t)(input[59] & 0x7f) << 25) |
			((uint32_t)(input[60] & 0xf8) << 17);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 485 to 496
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0x80) << 13);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 497 to 508
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)(input[63] & 0xf8) << 17);
	output[41] = (double)(value >> 20);
}

static void unpack_42_12bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit signed
	// Skip 6 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 426 to 437
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)(input[54] & 0xfc) << 18);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 438 to 449
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xc0) << 14);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 450 to 461
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)(input[57] & 0xfc) << 18);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 462 to 473
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)(input[59] & 0xc0) << 14);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 474 to 485
	value = ((uint32_t)(input[59] & 0x3f) << 26) |
			((uint32_t)(input[60] & 0xfc) << 18);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 486 to 497
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xc0) << 14);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 498 to 509
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)(input[63] & 0xfc) << 18);
	output[41] = (double)(value >> 20);
}

static void unpack_42_12bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit unsigned
	// Skip 6 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 17
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xc0) << 14);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 18 to 29
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)(input[3] & 0xfc) << 18);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 30 to 41
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)(input[5] & 0xc0) << 14);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 42 to 53
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)(input[6] & 0xfc) << 18);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 54 to 65
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xc0) << 14);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 66 to 77
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)(input[9] & 0xfc) << 18);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 78 to 89
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)(input[11] & 0xc0) << 14);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 90 to 101
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)(input[12] & 0xfc) << 18);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 102 to 113
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xc0) << 14);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 114 to 125
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)(input[15] & 0xfc) << 18);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 126 to 137
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xc0) << 14);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 138 to 149
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)(input[18] & 0xfc) << 18);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 150 to 161
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xc0) << 14);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 162 to 173
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)(input[21] & 0xfc) << 18);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 174 to 185
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xc0) << 14);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 186 to 197
	value = ((uint32_t)(input[23] & 0x3f) << 26) |
			((uint32_t)(input[24] & 0xfc) << 18);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 198 to 209
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xc0) << 14);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 210 to 221
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)(input[27] & 0xfc) << 18);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 222 to 233
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xc0) << 14);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 234 to 245
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)(input[30] & 0xfc) << 18);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 246 to 257
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xc0) << 14);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 258 to 269
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)(input[33] & 0xfc) << 18);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 270 to 281
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)(input[35] & 0xc0) << 14);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 282 to 293
	value = ((uint32_t)(input[35] & 0x3f) << 26) |
			((uint32_t)(input[36] & 0xfc) << 18);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 294 to 305
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xc0) << 14);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 306 to 317
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)(input[39] & 0xfc) << 18);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 318 to 329
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)(input[41] & 0xc0) << 14);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 330 to 341
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)(input[42] & 0xfc) << 18);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 342 to 353
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xc0) << 14);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 354 to 365
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)(input[45] & 0xfc) << 18);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 366 to 377
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)(input[47] & 0xc0) << 14);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 378 to 389
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)(input[48] & 0xfc) << 18);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 390 to 401
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xc0) << 14);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 402 to 413
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)(input[51] & 0xfc) << 18);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 414 to 425
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xc0) << 14);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 426 to 437
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)(input[54] & 0xfc) << 18);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 438 to 449
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xc0) << 14);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 450 to 461
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)(input[57] & 0xfc) << 18);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 462 to 473
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)(input[59] & 0xc0) << 14);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 474 to 485
	value = ((uint32_t)(input[59] & 0x3f) << 26) |
			((uint32_t)(input[60] & 0xfc) << 18);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 486 to 497
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xc0) << 14);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 498 to 509
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)(input[63] & 0xfc) << 18);
	output[41] = (double)(value >> 20);
}

static void unpack_42_12bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit signed
	// Skip 7 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 427 to 438
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)(input[54] & 0xfe) << 19);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 439 to 450
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xe0) << 15);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 451 to 462
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)(input[57] & 0xfe) << 19);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 463 to 474
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)(input[59] & 0xe0) << 15);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 475 to 486
	value = ((uint32_t)(input[59] & 0x1f) << 27) |
			((uint32_t)(input[60] & 0xfe) << 19);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 487 to 498
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xe0) << 15);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 499 to 510
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)(input[63] & 0xfe) << 19);
	output[41] = (double)(value >> 20);
}

static void unpack_42_12bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 12-bit unsigned
	// Skip 7 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 18
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xe0) << 15);
	output[0] = (double)(value >> 20);

	// read output[1]: from bit 19 to 30
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)(input[3] & 0xfe) << 19);
	output[1] = (double)(value >> 20);

	// read output[2]: from bit 31 to 42
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)(input[5] & 0xe0) << 15);
	output[2] = (double)(value >> 20);

	// read output[3]: from bit 43 to 54
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)(input[6] & 0xfe) << 19);
	output[3] = (double)(value >> 20);

	// read output[4]: from bit 55 to 66
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xe0) << 15);
	output[4] = (double)(value >> 20);

	// read output[5]: from bit 67 to 78
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)(input[9] & 0xfe) << 19);
	output[5] = (double)(value >> 20);

	// read output[6]: from bit 79 to 90
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)(input[11] & 0xe0) << 15);
	output[6] = (double)(value >> 20);

	// read output[7]: from bit 91 to 102
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)(input[12] & 0xfe) << 19);
	output[7] = (double)(value >> 20);

	// read output[8]: from bit 103 to 114
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xe0) << 15);
	output[8] = (double)(value >> 20);

	// read output[9]: from bit 115 to 126
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)(input[15] & 0xfe) << 19);
	output[9] = (double)(value >> 20);

	// read output[10]: from bit 127 to 138
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)(input[17] & 0xe0) << 15);
	output[10] = (double)(value >> 20);

	// read output[11]: from bit 139 to 150
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)(input[18] & 0xfe) << 19);
	output[11] = (double)(value >> 20);

	// read output[12]: from bit 151 to 162
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xe0) << 15);
	output[12] = (double)(value >> 20);

	// read output[13]: from bit 163 to 174
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)(input[21] & 0xfe) << 19);
	output[13] = (double)(value >> 20);

	// read output[14]: from bit 175 to 186
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)(input[23] & 0xe0) << 15);
	output[14] = (double)(value >> 20);

	// read output[15]: from bit 187 to 198
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)(input[24] & 0xfe) << 19);
	output[15] = (double)(value >> 20);

	// read output[16]: from bit 199 to 210
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xe0) << 15);
	output[16] = (double)(value >> 20);

	// read output[17]: from bit 211 to 222
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)(input[27] & 0xfe) << 19);
	output[17] = (double)(value >> 20);

	// read output[18]: from bit 223 to 234
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)(input[29] & 0xe0) << 15);
	output[18] = (double)(value >> 20);

	// read output[19]: from bit 235 to 246
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)(input[30] & 0xfe) << 19);
	output[19] = (double)(value >> 20);

	// read output[20]: from bit 247 to 258
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xe0) << 15);
	output[20] = (double)(value >> 20);

	// read output[21]: from bit 259 to 270
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)(input[33] & 0xfe) << 19);
	output[21] = (double)(value >> 20);

	// read output[22]: from bit 271 to 282
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)(input[35] & 0xe0) << 15);
	output[22] = (double)(value >> 20);

	// read output[23]: from bit 283 to 294
	value = ((uint32_t)(input[35] & 0x1f) << 27) |
			((uint32_t)(input[36] & 0xfe) << 19);
	output[23] = (double)(value >> 20);

	// read output[24]: from bit 295 to 306
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xe0) << 15);
	output[24] = (double)(value >> 20);

	// read output[25]: from bit 307 to 318
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)(input[39] & 0xfe) << 19);
	output[25] = (double)(value >> 20);

	// read output[26]: from bit 319 to 330
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)(input[41] & 0xe0) << 15);
	output[26] = (double)(value >> 20);

	// read output[27]: from bit 331 to 342
	value = ((uint32_t)(input[41] & 0x1f) << 27) |
			((uint32_t)(input[42] & 0xfe) << 19);
	output[27] = (double)(value >> 20);

	// read output[28]: from bit 343 to 354
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xe0) << 15);
	output[28] = (double)(value >> 20);

	// read output[29]: from bit 355 to 366
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)(input[45] & 0xfe) << 19);
	output[29] = (double)(value >> 20);

	// read output[30]: from bit 367 to 378
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)(input[47] & 0xe0) << 15);
	output[30] = (double)(value >> 20);

	// read output[31]: from bit 379 to 390
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)(input[48] & 0xfe) << 19);
	output[31] = (double)(value >> 20);

	// read output[32]: from bit 391 to 402
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xe0) << 15);
	output[32] = (double)(value >> 20);

	// read output[33]: from bit 403 to 414
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)(input[51] & 0xfe) << 19);
	output[33] = (double)(value >> 20);

	// read output[34]: from bit 415 to 426
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)(input[53] & 0xe0) << 15);
	output[34] = (double)(value >> 20);

	// read output[35]: from bit 427 to 438
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)(input[54] & 0xfe) << 19);
	output[35] = (double)(value >> 20);

	// read output[36]: from bit 439 to 450
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xe0) << 15);
	output[36] = (double)(value >> 20);

	// read output[37]: from bit 451 to 462
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)(input[57] & 0xfe) << 19);
	output[37] = (double)(value >> 20);

	// read output[38]: from bit 463 to 474
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)(input[59] & 0xe0) << 15);
	output[38] = (double)(value >> 20);

	// read output[39]: from bit 475 to 486
	value = ((uint32_t)(input[59] & 0x1f) << 27) |
			((uint32_t)(input[60] & 0xfe) << 19);
	output[39] = (double)(value >> 20);

	// read output[40]: from bit 487 to 498
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xe0) << 15);
	output[40] = (double)(value >> 20);

	// read output[41]: from bit 499 to 510
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)(input[63] & 0xfe) << 19);
	output[41] = (double)(value >> 20);
}


unpack_func_t unpack_12bit[UNPACK_12BIT_MAX_COUNT][8][2] = {
	{
		{
			unpack_1_12bit_unsigned_0off,
			unpack_1_12bit_signed_0off,
		},
		{
			unpack_1_12bit_unsigned_1off,
			unpack_1_12bit_signed_1off,
		},
		{
			unpack_1_12bit_unsigned_2off,
			unpack_1_12bit_signed_2off,
		},
		{
			unpack_1_12bit_unsigned_3off,
			unpack_1_12bit_signed_3off,
		},
		{
			unpack_1_12bit_unsigned_4off,
			unpack_1_12bit_signed_4off,
		},
		{
			unpack_1_12bit_unsigned_5off,
			unpack_1_12bit_signed_5off,
		},
		{
			unpack_1_12bit_unsigned_6off,
			unpack_1_12bit_signed_6off,
		},
		{
			unpack_1_12bit_unsigned_7off,
			unpack_1_12bit_signed_7off,
		},
	},
	{
		{
			unpack_2_12bit_unsigned_0off,
			unpack_2_12bit_signed_0off,
		},
		{
			unpack_2_12bit_unsigned_1off,
			unpack_2_12bit_signed_1off,
		},
		{
			unpack_2_12bit_unsigned_2off,
			unpack_2_12bit_signed_2off,
		},
		{
			unpack_2_12bit_unsigned_3off,
			unpack_2_12bit_signed_3off,
		},
		{
			unpack_2_12bit_unsigned_4off,
			unpack_2_12bit_signed_4off,
		},
		{
			unpack_2_12bit_unsigned_5off,
			unpack_2_12bit_signed_5off,
		},
		{
			unpack_2_12bit_unsigned_6off,
			unpack_2_12bit_signed_6off,
		},
		{
			unpack_2_12bit_unsigned_7off,
			unpack_2_12bit_signed_7off,
		},
	},
	{
		{
			unpack_3_12bit_unsigned_0off,
			unpack_3_12bit_signed_0off,
		},
		{
			unpack_3_12bit_unsigned_1off,
			unpack_3_12bit_signed_1off,
		},
		{
			unpack_3_12bit_unsigned_2off,
			unpack_3_12bit_signed_2off,
		},
		{
			unpack_3_12bit_unsigned_3off,
			unpack_3_12bit_signed_3off,
		},
		{
			unpack_3_12bit_unsigned_4off,
			unpack_3_12bit_signed_4off,
		},
		{
			unpack_3_12bit_unsigned_5off,
			unpack_3_12bit_signed_5off,
		},
		{
			unpack_3_12bit_unsigned_6off,
			unpack_3_12bit_signed_6off,
		},
		{
			unpack_3_12bit_unsigned_7off,
			unpack_3_12bit_signed_7off,
		},
	},
	{
		{
			unpack_4_12bit_unsigned_0off,
			unpack_4_12bit_signed_0off,
		},
		{
			unpack_4_12bit_unsigned_1off,
			unpack_4_12bit_signed_1off,
		},
		{
			unpack_4_12bit_unsigned_2off,
			unpack_4_12bit_signed_2off,
		},
		{
			unpack_4_12bit_unsigned_3off,
			unpack_4_12bit_signed_3off,
		},
		{
			unpack_4_12bit_unsigned_4off,
			unpack_4_12bit_signed_4off,
		},
		{
			unpack_4_12bit_unsigned_5off,
			unpack_4_12bit_signed_5off,
		},
		{
			unpack_4_12bit_unsigned_6off,
			unpack_4_12bit_signed_6off,
		},
		{
			unpack_4_12bit_unsigned_7off,
			unpack_4_12bit_signed_7off,
		},
	},
	{
		{
			unpack_5_12bit_unsigned_0off,
			unpack_5_12bit_signed_0off,
		},
		{
			unpack_5_12bit_unsigned_1off,
			unpack_5_12bit_signed_1off,
		},
		{
			unpack_5_12bit_unsigned_2off,
			unpack_5_12bit_signed_2off,
		},
		{
			unpack_5_12bit_unsigned_3off,
			unpack_5_12bit_signed_3off,
		},
		{
			unpack_5_12bit_unsigned_4off,
			unpack_5_12bit_signed_4off,
		},
		{
			unpack_5_12bit_unsigned_5off,
			unpack_5_12bit_signed_5off,
		},
		{
			unpack_5_12bit_unsigned_6off,
			unpack_5_12bit_signed_6off,
		},
		{
			unpack_5_12bit_unsigned_7off,
			unpack_5_12bit_signed_7off,
		},
	},
	{
		{
			unpack_6_12bit_unsigned_0off,
			unpack_6_12bit_signed_0off,
		},
		{
			unpack_6_12bit_unsigned_1off,
			unpack_6_12bit_signed_1off,
		},
		{
			unpack_6_12bit_unsigned_2off,
			unpack_6_12bit_signed_2off,
		},
		{
			unpack_6_12bit_unsigned_3off,
			unpack_6_12bit_signed_3off,
		},
		{
			unpack_6_12bit_unsigned_4off,
			unpack_6_12bit_signed_4off,
		},
		{
			unpack_6_12bit_unsigned_5off,
			unpack_6_12bit_signed_5off,
		},
		{
			unpack_6_12bit_unsigned_6off,
			unpack_6_12bit_signed_6off,
		},
		{
			unpack_6_12bit_unsigned_7off,
			unpack_6_12bit_signed_7off,
		},
	},
	{
		{
			unpack_7_12bit_unsigned_0off,
			unpack_7_12bit_signed_0off,
		},
		{
			unpack_7_12bit_unsigned_1off,
			unpack_7_12bit_signed_1off,
		},
		{
			unpack_7_12bit_unsigned_2off,
			unpack_7_12bit_signed_2off,
		},
		{
			unpack_7_12bit_unsigned_3off,
			unpack_7_12bit_signed_3off,
		},
		{
			unpack_7_12bit_unsigned_4off,
			unpack_7_12bit_signed_4off,
		},
		{
			unpack_7_12bit_unsigned_5off,
			unpack_7_12bit_signed_5off,
		},
		{
			unpack_7_12bit_unsigned_6off,
			unpack_7_12bit_signed_6off,
		},
		{
			unpack_7_12bit_unsigned_7off,
			unpack_7_12bit_signed_7off,
		},
	},
	{
		{
			unpack_8_12bit_unsigned_0off,
			unpack_8_12bit_signed_0off,
		},
		{
			unpack_8_12bit_unsigned_1off,
			unpack_8_12bit_signed_1off,
		},
		{
			unpack_8_12bit_unsigned_2off,
			unpack_8_12bit_signed_2off,
		},
		{
			unpack_8_12bit_unsigned_3off,
			unpack_8_12bit_signed_3off,
		},
		{
			unpack_8_12bit_unsigned_4off,
			unpack_8_12bit_signed_4off,
		},
		{
			unpack_8_12bit_unsigned_5off,
			unpack_8_12bit_signed_5off,
		},
		{
			unpack_8_12bit_unsigned_6off,
			unpack_8_12bit_signed_6off,
		},
		{
			unpack_8_12bit_unsigned_7off,
			unpack_8_12bit_signed_7off,
		},
	},
	{
		{
			unpack_9_12bit_unsigned_0off,
			unpack_9_12bit_signed_0off,
		},
		{
			unpack_9_12bit_unsigned_1off,
			unpack_9_12bit_signed_1off,
		},
		{
			unpack_9_12bit_unsigned_2off,
			unpack_9_12bit_signed_2off,
		},
		{
			unpack_9_12bit_unsigned_3off,
			unpack_9_12bit_signed_3off,
		},
		{
			unpack_9_12bit_unsigned_4off,
			unpack_9_12bit_signed_4off,
		},
		{
			unpack_9_12bit_unsigned_5off,
			unpack_9_12bit_signed_5off,
		},
		{
			unpack_9_12bit_unsigned_6off,
			unpack_9_12bit_signed_6off,
		},
		{
			unpack_9_12bit_unsigned_7off,
			unpack_9_12bit_signed_7off,
		},
	},
	{
		{
			unpack_10_12bit_unsigned_0off,
			unpack_10_12bit_signed_0off,
		},
		{
			unpack_10_12bit_unsigned_1off,
			unpack_10_12bit_signed_1off,
		},
		{
			unpack_10_12bit_unsigned_2off,
			unpack_10_12bit_signed_2off,
		},
		{
			unpack_10_12bit_unsigned_3off,
			unpack_10_12bit_signed_3off,
		},
		{
			unpack_10_12bit_unsigned_4off,
			unpack_10_12bit_signed_4off,
		},
		{
			unpack_10_12bit_unsigned_5off,
			unpack_10_12bit_signed_5off,
		},
		{
			unpack_10_12bit_unsigned_6off,
			unpack_10_12bit_signed_6off,
		},
		{
			unpack_10_12bit_unsigned_7off,
			unpack_10_12bit_signed_7off,
		},
	},
	{
		{
			unpack_11_12bit_unsigned_0off,
			unpack_11_12bit_signed_0off,
		},
		{
			unpack_11_12bit_unsigned_1off,
			unpack_11_12bit_signed_1off,
		},
		{
			unpack_11_12bit_unsigned_2off,
			unpack_11_12bit_signed_2off,
		},
		{
			unpack_11_12bit_unsigned_3off,
			unpack_11_12bit_signed_3off,
		},
		{
			unpack_11_12bit_unsigned_4off,
			unpack_11_12bit_signed_4off,
		},
		{
			unpack_11_12bit_unsigned_5off,
			unpack_11_12bit_signed_5off,
		},
		{
			unpack_11_12bit_unsigned_6off,
			unpack_11_12bit_signed_6off,
		},
		{
			unpack_11_12bit_unsigned_7off,
			unpack_11_12bit_signed_7off,
		},
	},
	{
		{
			unpack_12_12bit_unsigned_0off,
			unpack_12_12bit_signed_0off,
		},
		{
			unpack_12_12bit_unsigned_1off,
			unpack_12_12bit_signed_1off,
		},
		{
			unpack_12_12bit_unsigned_2off,
			unpack_12_12bit_signed_2off,
		},
		{
			unpack_12_12bit_unsigned_3off,
			unpack_12_12bit_signed_3off,
		},
		{
			unpack_12_12bit_unsigned_4off,
			unpack_12_12bit_signed_4off,
		},
		{
			unpack_12_12bit_unsigned_5off,
			unpack_12_12bit_signed_5off,
		},
		{
			unpack_12_12bit_unsigned_6off,
			unpack_12_12bit_signed_6off,
		},
		{
			unpack_12_12bit_unsigned_7off,
			unpack_12_12bit_signed_7off,
		},
	},
	{
		{
			unpack_13_12bit_unsigned_0off,
			unpack_13_12bit_signed_0off,
		},
		{
			unpack_13_12bit_unsigned_1off,
			unpack_13_12bit_signed_1off,
		},
		{
			unpack_13_12bit_unsigned_2off,
			unpack_13_12bit_signed_2off,
		},
		{
			unpack_13_12bit_unsigned_3off,
			unpack_13_12bit_signed_3off,
		},
		{
			unpack_13_12bit_unsigned_4off,
			unpack_13_12bit_signed_4off,
		},
		{
			unpack_13_12bit_unsigned_5off,
			unpack_13_12bit_signed_5off,
		},
		{
			unpack_13_12bit_unsigned_6off,
			unpack_13_12bit_signed_6off,
		},
		{
			unpack_13_12bit_unsigned_7off,
			unpack_13_12bit_signed_7off,
		},
	},
	{
		{
			unpack_14_12bit_unsigned_0off,
			unpack_14_12bit_signed_0off,
		},
		{
			unpack_14_12bit_unsigned_1off,
			unpack_14_12bit_signed_1off,
		},
		{
			unpack_14_12bit_unsigned_2off,
			unpack_14_12bit_signed_2off,
		},
		{
			unpack_14_12bit_unsigned_3off,
			unpack_14_12bit_signed_3off,
		},
		{
			unpack_14_12bit_unsigned_4off,
			unpack_14_12bit_signed_4off,
		},
		{
			unpack_14_12bit_unsigned_5off,
			unpack_14_12bit_signed_5off,
		},
		{
			unpack_14_12bit_unsigned_6off,
			unpack_14_12bit_signed_6off,
		},
		{
			unpack_14_12bit_unsigned_7off,
			unpack_14_12bit_signed_7off,
		},
	},
	{
		{
			unpack_15_12bit_unsigned_0off,
			unpack_15_12bit_signed_0off,
		},
		{
			unpack_15_12bit_unsigned_1off,
			unpack_15_12bit_signed_1off,
		},
		{
			unpack_15_12bit_unsigned_2off,
			unpack_15_12bit_signed_2off,
		},
		{
			unpack_15_12bit_unsigned_3off,
			unpack_15_12bit_signed_3off,
		},
		{
			unpack_15_12bit_unsigned_4off,
			unpack_15_12bit_signed_4off,
		},
		{
			unpack_15_12bit_unsigned_5off,
			unpack_15_12bit_signed_5off,
		},
		{
			unpack_15_12bit_unsigned_6off,
			unpack_15_12bit_signed_6off,
		},
		{
			unpack_15_12bit_unsigned_7off,
			unpack_15_12bit_signed_7off,
		},
	},
	{
		{
			unpack_16_12bit_unsigned_0off,
			unpack_16_12bit_signed_0off,
		},
		{
			unpack_16_12bit_unsigned_1off,
			unpack_16_12bit_signed_1off,
		},
		{
			unpack_16_12bit_unsigned_2off,
			unpack_16_12bit_signed_2off,
		},
		{
			unpack_16_12bit_unsigned_3off,
			unpack_16_12bit_signed_3off,
		},
		{
			unpack_16_12bit_unsigned_4off,
			unpack_16_12bit_signed_4off,
		},
		{
			unpack_16_12bit_unsigned_5off,
			unpack_16_12bit_signed_5off,
		},
		{
			unpack_16_12bit_unsigned_6off,
			unpack_16_12bit_signed_6off,
		},
		{
			unpack_16_12bit_unsigned_7off,
			unpack_16_12bit_signed_7off,
		},
	},
	{
		{
			unpack_17_12bit_unsigned_0off,
			unpack_17_12bit_signed_0off,
		},
		{
			unpack_17_12bit_unsigned_1off,
			unpack_17_12bit_signed_1off,
		},
		{
			unpack_17_12bit_unsigned_2off,
			unpack_17_12bit_signed_2off,
		},
		{
			unpack_17_12bit_unsigned_3off,
			unpack_17_12bit_signed_3off,
		},
		{
			unpack_17_12bit_unsigned_4off,
			unpack_17_12bit_signed_4off,
		},
		{
			unpack_17_12bit_unsigned_5off,
			unpack_17_12bit_signed_5off,
		},
		{
			unpack_17_12bit_unsigned_6off,
			unpack_17_12bit_signed_6off,
		},
		{
			unpack_17_12bit_unsigned_7off,
			unpack_17_12bit_signed_7off,
		},
	},
	{
		{
			unpack_18_12bit_unsigned_0off,
			unpack_18_12bit_signed_0off,
		},
		{
			unpack_18_12bit_unsigned_1off,
			unpack_18_12bit_signed_1off,
		},
		{
			unpack_18_12bit_unsigned_2off,
			unpack_18_12bit_signed_2off,
		},
		{
			unpack_18_12bit_unsigned_3off,
			unpack_18_12bit_signed_3off,
		},
		{
			unpack_18_12bit_unsigned_4off,
			unpack_18_12bit_signed_4off,
		},
		{
			unpack_18_12bit_unsigned_5off,
			unpack_18_12bit_signed_5off,
		},
		{
			unpack_18_12bit_unsigned_6off,
			unpack_18_12bit_signed_6off,
		},
		{
			unpack_18_12bit_unsigned_7off,
			unpack_18_12bit_signed_7off,
		},
	},
	{
		{
			unpack_19_12bit_unsigned_0off,
			unpack_19_12bit_signed_0off,
		},
		{
			unpack_19_12bit_unsigned_1off,
			unpack_19_12bit_signed_1off,
		},
		{
			unpack_19_12bit_unsigned_2off,
			unpack_19_12bit_signed_2off,
		},
		{
			unpack_19_12bit_unsigned_3off,
			unpack_19_12bit_signed_3off,
		},
		{
			unpack_19_12bit_unsigned_4off,
			unpack_19_12bit_signed_4off,
		},
		{
			unpack_19_12bit_unsigned_5off,
			unpack_19_12bit_signed_5off,
		},
		{
			unpack_19_12bit_unsigned_6off,
			unpack_19_12bit_signed_6off,
		},
		{
			unpack_19_12bit_unsigned_7off,
			unpack_19_12bit_signed_7off,
		},
	},
	{
		{
			unpack_20_12bit_unsigned_0off,
			unpack_20_12bit_signed_0off,
		},
		{
			unpack_20_12bit_unsigned_1off,
			unpack_20_12bit_signed_1off,
		},
		{
			unpack_20_12bit_unsigned_2off,
			unpack_20_12bit_signed_2off,
		},
		{
			unpack_20_12bit_unsigned_3off,
			unpack_20_12bit_signed_3off,
		},
		{
			unpack_20_12bit_unsigned_4off,
			unpack_20_12bit_signed_4off,
		},
		{
			unpack_20_12bit_unsigned_5off,
			unpack_20_12bit_signed_5off,
		},
		{
			unpack_20_12bit_unsigned_6off,
			unpack_20_12bit_signed_6off,
		},
		{
			unpack_20_12bit_unsigned_7off,
			unpack_20_12bit_signed_7off,
		},
	},
	{
		{
			unpack_21_12bit_unsigned_0off,
			unpack_21_12bit_signed_0off,
		},
		{
			unpack_21_12bit_unsigned_1off,
			unpack_21_12bit_signed_1off,
		},
		{
			unpack_21_12bit_unsigned_2off,
			unpack_21_12bit_signed_2off,
		},
		{
			unpack_21_12bit_unsigned_3off,
			unpack_21_12bit_signed_3off,
		},
		{
			unpack_21_12bit_unsigned_4off,
			unpack_21_12bit_signed_4off,
		},
		{
			unpack_21_12bit_unsigned_5off,
			unpack_21_12bit_signed_5off,
		},
		{
			unpack_21_12bit_unsigned_6off,
			unpack_21_12bit_signed_6off,
		},
		{
			unpack_21_12bit_unsigned_7off,
			unpack_21_12bit_signed_7off,
		},
	},
	{
		{
			unpack_22_12bit_unsigned_0off,
			unpack_22_12bit_signed_0off,
		},
		{
			unpack_22_12bit_unsigned_1off,
			unpack_22_12bit_signed_1off,
		},
		{
			unpack_22_12bit_unsigned_2off,
			unpack_22_12bit_signed_2off,
		},
		{
			unpack_22_12bit_unsigned_3off,
			unpack_22_12bit_signed_3off,
		},
		{
			unpack_22_12bit_unsigned_4off,
			unpack_22_12bit_signed_4off,
		},
		{
			unpack_22_12bit_unsigned_5off,
			unpack_22_12bit_signed_5off,
		},
		{
			unpack_22_12bit_unsigned_6off,
			unpack_22_12bit_signed_6off,
		},
		{
			unpack_22_12bit_unsigned_7off,
			unpack_22_12bit_signed_7off,
		},
	},
	{
		{
			unpack_23_12bit_unsigned_0off,
			unpack_23_12bit_signed_0off,
		},
		{
			unpack_23_12bit_unsigned_1off,
			unpack_23_12bit_signed_1off,
		},
		{
			unpack_23_12bit_unsigned_2off,
			unpack_23_12bit_signed_2off,
		},
		{
			unpack_23_12bit_unsigned_3off,
			unpack_23_12bit_signed_3off,
		},
		{
			unpack_23_12bit_unsigned_4off,
			unpack_23_12bit_signed_4off,
		},
		{
			unpack_23_12bit_unsigned_5off,
			unpack_23_12bit_signed_5off,
		},
		{
			unpack_23_12bit_unsigned_6off,
			unpack_23_12bit_signed_6off,
		},
		{
			unpack_23_12bit_unsigned_7off,
			unpack_23_12bit_signed_7off,
		},
	},
	{
		{
			unpack_24_12bit_unsigned_0off,
			unpack_24_12bit_signed_0off,
		},
		{
			unpack_24_12bit_unsigned_1off,
			unpack_24_12bit_signed_1off,
		},
		{
			unpack_24_12bit_unsigned_2off,
			unpack_24_12bit_signed_2off,
		},
		{
			unpack_24_12bit_unsigned_3off,
			unpack_24_12bit_signed_3off,
		},
		{
			unpack_24_12bit_unsigned_4off,
			unpack_24_12bit_signed_4off,
		},
		{
			unpack_24_12bit_unsigned_5off,
			unpack_24_12bit_signed_5off,
		},
		{
			unpack_24_12bit_unsigned_6off,
			unpack_24_12bit_signed_6off,
		},
		{
			unpack_24_12bit_unsigned_7off,
			unpack_24_12bit_signed_7off,
		},
	},
	{
		{
			unpack_25_12bit_unsigned_0off,
			unpack_25_12bit_signed_0off,
		},
		{
			unpack_25_12bit_unsigned_1off,
			unpack_25_12bit_signed_1off,
		},
		{
			unpack_25_12bit_unsigned_2off,
			unpack_25_12bit_signed_2off,
		},
		{
			unpack_25_12bit_unsigned_3off,
			unpack_25_12bit_signed_3off,
		},
		{
			unpack_25_12bit_unsigned_4off,
			unpack_25_12bit_signed_4off,
		},
		{
			unpack_25_12bit_unsigned_5off,
			unpack_25_12bit_signed_5off,
		},
		{
			unpack_25_12bit_unsigned_6off,
			unpack_25_12bit_signed_6off,
		},
		{
			unpack_25_12bit_unsigned_7off,
			unpack_25_12bit_signed_7off,
		},
	},
	{
		{
			unpack_26_12bit_unsigned_0off,
			unpack_26_12bit_signed_0off,
		},
		{
			unpack_26_12bit_unsigned_1off,
			unpack_26_12bit_signed_1off,
		},
		{
			unpack_26_12bit_unsigned_2off,
			unpack_26_12bit_signed_2off,
		},
		{
			unpack_26_12bit_unsigned_3off,
			unpack_26_12bit_signed_3off,
		},
		{
			unpack_26_12bit_unsigned_4off,
			unpack_26_12bit_signed_4off,
		},
		{
			unpack_26_12bit_unsigned_5off,
			unpack_26_12bit_signed_5off,
		},
		{
			unpack_26_12bit_unsigned_6off,
			unpack_26_12bit_signed_6off,
		},
		{
			unpack_26_12bit_unsigned_7off,
			unpack_26_12bit_signed_7off,
		},
	},
	{
		{
			unpack_27_12bit_unsigned_0off,
			unpack_27_12bit_signed_0off,
		},
		{
			unpack_27_12bit_unsigned_1off,
			unpack_27_12bit_signed_1off,
		},
		{
			unpack_27_12bit_unsigned_2off,
			unpack_27_12bit_signed_2off,
		},
		{
			unpack_27_12bit_unsigned_3off,
			unpack_27_12bit_signed_3off,
		},
		{
			unpack_27_12bit_unsigned_4off,
			unpack_27_12bit_signed_4off,
		},
		{
			unpack_27_12bit_unsigned_5off,
			unpack_27_12bit_signed_5off,
		},
		{
			unpack_27_12bit_unsigned_6off,
			unpack_27_12bit_signed_6off,
		},
		{
			unpack_27_12bit_unsigned_7off,
			unpack_27_12bit_signed_7off,
		},
	},
	{
		{
			unpack_28_12bit_unsigned_0off,
			unpack_28_12bit_signed_0off,
		},
		{
			unpack_28_12bit_unsigned_1off,
			unpack_28_12bit_signed_1off,
		},
		{
			unpack_28_12bit_unsigned_2off,
			unpack_28_12bit_signed_2off,
		},
		{
			unpack_28_12bit_unsigned_3off,
			unpack_28_12bit_signed_3off,
		},
		{
			unpack_28_12bit_unsigned_4off,
			unpack_28_12bit_signed_4off,
		},
		{
			unpack_28_12bit_unsigned_5off,
			unpack_28_12bit_signed_5off,
		},
		{
			unpack_28_12bit_unsigned_6off,
			unpack_28_12bit_signed_6off,
		},
		{
			unpack_28_12bit_unsigned_7off,
			unpack_28_12bit_signed_7off,
		},
	},
	{
		{
			unpack_29_12bit_unsigned_0off,
			unpack_29_12bit_signed_0off,
		},
		{
			unpack_29_12bit_unsigned_1off,
			unpack_29_12bit_signed_1off,
		},
		{
			unpack_29_12bit_unsigned_2off,
			unpack_29_12bit_signed_2off,
		},
		{
			unpack_29_12bit_unsigned_3off,
			unpack_29_12bit_signed_3off,
		},
		{
			unpack_29_12bit_unsigned_4off,
			unpack_29_12bit_signed_4off,
		},
		{
			unpack_29_12bit_unsigned_5off,
			unpack_29_12bit_signed_5off,
		},
		{
			unpack_29_12bit_unsigned_6off,
			unpack_29_12bit_signed_6off,
		},
		{
			unpack_29_12bit_unsigned_7off,
			unpack_29_12bit_signed_7off,
		},
	},
	{
		{
			unpack_30_12bit_unsigned_0off,
			unpack_30_12bit_signed_0off,
		},
		{
			unpack_30_12bit_unsigned_1off,
			unpack_30_12bit_signed_1off,
		},
		{
			unpack_30_12bit_unsigned_2off,
			unpack_30_12bit_signed_2off,
		},
		{
			unpack_30_12bit_unsigned_3off,
			unpack_30_12bit_signed_3off,
		},
		{
			unpack_30_12bit_unsigned_4off,
			unpack_30_12bit_signed_4off,
		},
		{
			unpack_30_12bit_unsigned_5off,
			unpack_30_12bit_signed_5off,
		},
		{
			unpack_30_12bit_unsigned_6off,
			unpack_30_12bit_signed_6off,
		},
		{
			unpack_30_12bit_unsigned_7off,
			unpack_30_12bit_signed_7off,
		},
	},
	{
		{
			unpack_31_12bit_unsigned_0off,
			unpack_31_12bit_signed_0off,
		},
		{
			unpack_31_12bit_unsigned_1off,
			unpack_31_12bit_signed_1off,
		},
		{
			unpack_31_12bit_unsigned_2off,
			unpack_31_12bit_signed_2off,
		},
		{
			unpack_31_12bit_unsigned_3off,
			unpack_31_12bit_signed_3off,
		},
		{
			unpack_31_12bit_unsigned_4off,
			unpack_31_12bit_signed_4off,
		},
		{
			unpack_31_12bit_unsigned_5off,
			unpack_31_12bit_signed_5off,
		},
		{
			unpack_31_12bit_unsigned_6off,
			unpack_31_12bit_signed_6off,
		},
		{
			unpack_31_12bit_unsigned_7off,
			unpack_31_12bit_signed_7off,
		},
	},
	{
		{
			unpack_32_12bit_unsigned_0off,
			unpack_32_12bit_signed_0off,
		},
		{
			unpack_32_12bit_unsigned_1off,
			unpack_32_12bit_signed_1off,
		},
		{
			unpack_32_12bit_unsigned_2off,
			unpack_32_12bit_signed_2off,
		},
		{
			unpack_32_12bit_unsigned_3off,
			unpack_32_12bit_signed_3off,
		},
		{
			unpack_32_12bit_unsigned_4off,
			unpack_32_12bit_signed_4off,
		},
		{
			unpack_32_12bit_unsigned_5off,
			unpack_32_12bit_signed_5off,
		},
		{
			unpack_32_12bit_unsigned_6off,
			unpack_32_12bit_signed_6off,
		},
		{
			unpack_32_12bit_unsigned_7off,
			unpack_32_12bit_signed_7off,
		},
	},
	{
		{
			unpack_33_12bit_unsigned_0off,
			unpack_33_12bit_signed_0off,
		},
		{
			unpack_33_12bit_unsigned_1off,
			unpack_33_12bit_signed_1off,
		},
		{
			unpack_33_12bit_unsigned_2off,
			unpack_33_12bit_signed_2off,
		},
		{
			unpack_33_12bit_unsigned_3off,
			unpack_33_12bit_signed_3off,
		},
		{
			unpack_33_12bit_unsigned_4off,
			unpack_33_12bit_signed_4off,
		},
		{
			unpack_33_12bit_unsigned_5off,
			unpack_33_12bit_signed_5off,
		},
		{
			unpack_33_12bit_unsigned_6off,
			unpack_33_12bit_signed_6off,
		},
		{
			unpack_33_12bit_unsigned_7off,
			unpack_33_12bit_signed_7off,
		},
	},
	{
		{
			unpack_34_12bit_unsigned_0off,
			unpack_34_12bit_signed_0off,
		},
		{
			unpack_34_12bit_unsigned_1off,
			unpack_34_12bit_signed_1off,
		},
		{
			unpack_34_12bit_unsigned_2off,
			unpack_34_12bit_signed_2off,
		},
		{
			unpack_34_12bit_unsigned_3off,
			unpack_34_12bit_signed_3off,
		},
		{
			unpack_34_12bit_unsigned_4off,
			unpack_34_12bit_signed_4off,
		},
		{
			unpack_34_12bit_unsigned_5off,
			unpack_34_12bit_signed_5off,
		},
		{
			unpack_34_12bit_unsigned_6off,
			unpack_34_12bit_signed_6off,
		},
		{
			unpack_34_12bit_unsigned_7off,
			unpack_34_12bit_signed_7off,
		},
	},
	{
		{
			unpack_35_12bit_unsigned_0off,
			unpack_35_12bit_signed_0off,
		},
		{
			unpack_35_12bit_unsigned_1off,
			unpack_35_12bit_signed_1off,
		},
		{
			unpack_35_12bit_unsigned_2off,
			unpack_35_12bit_signed_2off,
		},
		{
			unpack_35_12bit_unsigned_3off,
			unpack_35_12bit_signed_3off,
		},
		{
			unpack_35_12bit_unsigned_4off,
			unpack_35_12bit_signed_4off,
		},
		{
			unpack_35_12bit_unsigned_5off,
			unpack_35_12bit_signed_5off,
		},
		{
			unpack_35_12bit_unsigned_6off,
			unpack_35_12bit_signed_6off,
		},
		{
			unpack_35_12bit_unsigned_7off,
			unpack_35_12bit_signed_7off,
		},
	},
	{
		{
			unpack_36_12bit_unsigned_0off,
			unpack_36_12bit_signed_0off,
		},
		{
			unpack_36_12bit_unsigned_1off,
			unpack_36_12bit_signed_1off,
		},
		{
			unpack_36_12bit_unsigned_2off,
			unpack_36_12bit_signed_2off,
		},
		{
			unpack_36_12bit_unsigned_3off,
			unpack_36_12bit_signed_3off,
		},
		{
			unpack_36_12bit_unsigned_4off,
			unpack_36_12bit_signed_4off,
		},
		{
			unpack_36_12bit_unsigned_5off,
			unpack_36_12bit_signed_5off,
		},
		{
			unpack_36_12bit_unsigned_6off,
			unpack_36_12bit_signed_6off,
		},
		{
			unpack_36_12bit_unsigned_7off,
			unpack_36_12bit_signed_7off,
		},
	},
	{
		{
			unpack_37_12bit_unsigned_0off,
			unpack_37_12bit_signed_0off,
		},
		{
			unpack_37_12bit_unsigned_1off,
			unpack_37_12bit_signed_1off,
		},
		{
			unpack_37_12bit_unsigned_2off,
			unpack_37_12bit_signed_2off,
		},
		{
			unpack_37_12bit_unsigned_3off,
			unpack_37_12bit_signed_3off,
		},
		{
			unpack_37_12bit_unsigned_4off,
			unpack_37_12bit_signed_4off,
		},
		{
			unpack_37_12bit_unsigned_5off,
			unpack_37_12bit_signed_5off,
		},
		{
			unpack_37_12bit_unsigned_6off,
			unpack_37_12bit_signed_6off,
		},
		{
			unpack_37_12bit_unsigned_7off,
			unpack_37_12bit_signed_7off,
		},
	},
	{
		{
			unpack_38_12bit_unsigned_0off,
			unpack_38_12bit_signed_0off,
		},
		{
			unpack_38_12bit_unsigned_1off,
			unpack_38_12bit_signed_1off,
		},
		{
			unpack_38_12bit_unsigned_2off,
			unpack_38_12bit_signed_2off,
		},
		{
			unpack_38_12bit_unsigned_3off,
			unpack_38_12bit_signed_3off,
		},
		{
			unpack_38_12bit_unsigned_4off,
			unpack_38_12bit_signed_4off,
		},
		{
			unpack_38_12bit_unsigned_5off,
			unpack_38_12bit_signed_5off,
		},
		{
			unpack_38_12bit_unsigned_6off,
			unpack_38_12bit_signed_6off,
		},
		{
			unpack_38_12bit_unsigned_7off,
			unpack_38_12bit_signed_7off,
		},
	},
	{
		{
			unpack_39_12bit_unsigned_0off,
			unpack_39_12bit_signed_0off,
		},
		{
			unpack_39_12bit_unsigned_1off,
			unpack_39_12bit_signed_1off,
		},
		{
			unpack_39_12bit_unsigned_2off,
			unpack_39_12bit_signed_2off,
		},
		{
			unpack_39_12bit_unsigned_3off,
			unpack_39_12bit_signed_3off,
		},
		{
			unpack_39_12bit_unsigned_4off,
			unpack_39_12bit_signed_4off,
		},
		{
			unpack_39_12bit_unsigned_5off,
			unpack_39_12bit_signed_5off,
		},
		{
			unpack_39_12bit_unsigned_6off,
			unpack_39_12bit_signed_6off,
		},
		{
			unpack_39_12bit_unsigned_7off,
			unpack_39_12bit_signed_7off,
		},
	},
	{
		{
			unpack_40_12bit_unsigned_0off,
			unpack_40_12bit_signed_0off,
		},
		{
			unpack_40_12bit_unsigned_1off,
			unpack_40_12bit_signed_1off,
		},
		{
			unpack_40_12bit_unsigned_2off,
			unpack_40_12bit_signed_2off,
		},
		{
			unpack_40_12bit_unsigned_3off,
			unpack_40_12bit_signed_3off,
		},
		{
			unpack_40_12bit_unsigned_4off,
			unpack_40_12bit_signed_4off,
		},
		{
			unpack_40_12bit_unsigned_5off,
			unpack_40_12bit_signed_5off,
		},
		{
			unpack_40_12bit_unsigned_6off,
			unpack_40_12bit_signed_6off,
		},
		{
			unpack_40_12bit_unsigned_7off,
			unpack_40_12bit_signed_7off,
		},
	},
	{
		{
			unpack_41_12bit_unsigned_0off,
			unpack_41_12bit_signed_0off,
		},
		{
			unpack_41_12bit_unsigned_1off,
			unpack_41_12bit_signed_1off,
		},
		{
			unpack_41_12bit_unsigned_2off,
			unpack_41_12bit_signed_2off,
		},
		{
			unpack_41_12bit_unsigned_3off,
			unpack_41_12bit_signed_3off,
		},
		{
			unpack_41_12bit_unsigned_4off,
			unpack_41_12bit_signed_4off,
		},
		{
			unpack_41_12bit_unsigned_5off,
			unpack_41_12bit_signed_5off,
		},
		{
			unpack_41_12bit_unsigned_6off,
			unpack_41_12bit_signed_6off,
		},
		{
			unpack_41_12bit_unsigned_7off,
			unpack_41_12bit_signed_7off,
		},
	},
	{
		{
			unpack_42_12bit_unsigned_0off,
			unpack_42_12bit_signed_0off,
		},
		{
			unpack_42_12bit_unsigned_1off,
			unpack_42_12bit_signed_1off,
		},
		{
			unpack_42_12bit_unsigned_2off,
			unpack_42_12bit_signed_2off,
		},
		{
			unpack_42_12bit_unsigned_3off,
			unpack_42_12bit_signed_3off,
		},
		{
			unpack_42_12bit_unsigned_4off,
			unpack_42_12bit_signed_4off,
		},
		{
			unpack_42_12bit_unsigned_5off,
			unpack_42_12bit_signed_5off,
		},
		{
			unpack_42_12bit_unsigned_6off,
			unpack_42_12bit_signed_6off,
		},
		{
			unpack_42_12bit_unsigned_7off,
			unpack_42_12bit_signed_7off,
		},
	},
};
