// AUTOGENERATED FILE. DO NOT MODIFY.

#include <stdlib.h>
#include <stdint.h>

#include "unpack24.h"



static void unpack_1_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 24 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);
}

static void unpack_1_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 24 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);
}

static void unpack_1_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);
}

static void unpack_1_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);
}

static void unpack_1_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);
}

static void unpack_1_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);
}

static void unpack_1_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);
}

static void unpack_1_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);
}

static void unpack_1_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);
}

static void unpack_1_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);
}

static void unpack_1_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);
}

static void unpack_1_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);
}

static void unpack_1_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);
}

static void unpack_1_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);
}

static void unpack_1_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);
}

static void unpack_1_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 24 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);
}

static void unpack_2_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 48 bits of data.
	// Input must be at least 6 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);
}

static void unpack_2_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 48 bits of data.
	// Input must be at least 6 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);
}

static void unpack_2_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);
}

static void unpack_2_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);
}

static void unpack_2_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);
}

static void unpack_2_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);
}

static void unpack_2_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);
}

static void unpack_2_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);
}

static void unpack_2_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);
}

static void unpack_2_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);
}

static void unpack_2_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);
}

static void unpack_2_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);
}

static void unpack_2_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);
}

static void unpack_2_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);
}

static void unpack_2_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);
}

static void unpack_2_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);
}

static void unpack_3_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 72 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);
}

static void unpack_3_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 72 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);
}

static void unpack_3_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);
}

static void unpack_3_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);
}

static void unpack_3_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);
}

static void unpack_3_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);
}

static void unpack_3_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);
}

static void unpack_3_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);
}

static void unpack_3_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);
}

static void unpack_3_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);
}

static void unpack_3_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);
}

static void unpack_3_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);
}

static void unpack_3_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);
}

static void unpack_3_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);
}

static void unpack_3_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);
}

static void unpack_3_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 72 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);
}

static void unpack_4_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 96 bits of data.
	// Input must be at least 12 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);
}

static void unpack_4_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 96 bits of data.
	// Input must be at least 12 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);
}

static void unpack_4_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);
}

static void unpack_4_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);
}

static void unpack_4_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);
}

static void unpack_4_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);
}

static void unpack_4_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);
}

static void unpack_4_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);
}

static void unpack_4_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);
}

static void unpack_4_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);
}

static void unpack_4_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);
}

static void unpack_4_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);
}

static void unpack_4_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);
}

static void unpack_4_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);
}

static void unpack_4_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);
}

static void unpack_4_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);
}

static void unpack_5_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 120 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);
}

static void unpack_5_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 120 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);
}

static void unpack_5_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);
}

static void unpack_5_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);
}

static void unpack_5_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);
}

static void unpack_5_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);
}

static void unpack_5_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);
}

static void unpack_5_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);
}

static void unpack_5_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);
}

static void unpack_5_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);
}

static void unpack_5_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);
}

static void unpack_5_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);
}

static void unpack_5_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);
}

static void unpack_5_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);
}

static void unpack_5_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);
}

static void unpack_5_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 120 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);
}

static void unpack_6_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 144 bits of data.
	// Input must be at least 18 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);
}

static void unpack_6_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 144 bits of data.
	// Input must be at least 18 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);
}

static void unpack_6_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);
}

static void unpack_6_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);
}

static void unpack_6_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);
}

static void unpack_6_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);
}

static void unpack_6_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);
}

static void unpack_6_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);
}

static void unpack_6_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);
}

static void unpack_6_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);
}

static void unpack_6_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);
}

static void unpack_6_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);
}

static void unpack_6_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);
}

static void unpack_6_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);
}

static void unpack_6_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);
}

static void unpack_6_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);
}

static void unpack_7_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 168 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);
}

static void unpack_7_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 168 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);
}

static void unpack_7_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);
}

static void unpack_7_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);
}

static void unpack_7_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);
}

static void unpack_7_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);
}

static void unpack_7_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);
}

static void unpack_7_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);
}

static void unpack_7_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);
}

static void unpack_7_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);
}

static void unpack_7_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);
}

static void unpack_7_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);
}

static void unpack_7_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);
}

static void unpack_7_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);
}

static void unpack_7_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);
}

static void unpack_7_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);
}

static void unpack_8_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 192 bits of data.
	// Input must be at least 24 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);
}

static void unpack_8_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 192 bits of data.
	// Input must be at least 24 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);
}

static void unpack_8_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);
}

static void unpack_8_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);
}

static void unpack_8_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);
}

static void unpack_8_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);
}

static void unpack_8_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);
}

static void unpack_8_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);
}

static void unpack_8_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);
}

static void unpack_8_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);
}

static void unpack_8_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);
}

static void unpack_8_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);
}

static void unpack_8_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);
}

static void unpack_8_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);
}

static void unpack_8_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);
}

static void unpack_8_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);
}

static void unpack_9_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 216 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);
}

static void unpack_9_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 216 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);
}

static void unpack_9_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);
}

static void unpack_9_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);
}

static void unpack_9_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);
}

static void unpack_9_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);
}

static void unpack_9_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);
}

static void unpack_9_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);
}

static void unpack_9_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);
}

static void unpack_9_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);
}

static void unpack_9_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);
}

static void unpack_9_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);
}

static void unpack_9_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);
}

static void unpack_9_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);
}

static void unpack_9_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);
}

static void unpack_9_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 216 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);
}

static void unpack_10_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 240 bits of data.
	// Input must be at least 30 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);
}

static void unpack_10_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 240 bits of data.
	// Input must be at least 30 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);
}

static void unpack_10_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);
}

static void unpack_10_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);
}

static void unpack_10_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);
}

static void unpack_10_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);
}

static void unpack_10_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);
}

static void unpack_10_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);
}

static void unpack_10_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);
}

static void unpack_10_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);
}

static void unpack_10_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);
}

static void unpack_10_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);
}

static void unpack_10_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);
}

static void unpack_10_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);
}

static void unpack_10_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);
}

static void unpack_10_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);
}

static void unpack_11_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 264 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);
}

static void unpack_11_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 264 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);
}

static void unpack_11_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);
}

static void unpack_11_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);
}

static void unpack_11_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);
}

static void unpack_11_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);
}

static void unpack_11_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);
}

static void unpack_11_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);
}

static void unpack_11_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);
}

static void unpack_11_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);
}

static void unpack_11_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);
}

static void unpack_11_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);
}

static void unpack_11_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);
}

static void unpack_11_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);
}

static void unpack_11_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);
}

static void unpack_11_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 264 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);
}

static void unpack_12_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 288 bits of data.
	// Input must be at least 36 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);
}

static void unpack_12_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 288 bits of data.
	// Input must be at least 36 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);
}

static void unpack_12_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);
}

static void unpack_12_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);
}

static void unpack_12_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);
}

static void unpack_12_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);
}

static void unpack_12_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);
}

static void unpack_12_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);
}

static void unpack_12_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);
}

static void unpack_12_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);
}

static void unpack_12_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);
}

static void unpack_12_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);
}

static void unpack_12_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);
}

static void unpack_12_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);
}

static void unpack_12_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);
}

static void unpack_12_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);
}

static void unpack_13_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 312 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);
}

static void unpack_13_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 312 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);
}

static void unpack_13_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);
}

static void unpack_13_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);
}

static void unpack_13_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);
}

static void unpack_13_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);
}

static void unpack_13_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);
}

static void unpack_13_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);
}

static void unpack_13_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);
}

static void unpack_13_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);
}

static void unpack_13_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);
}

static void unpack_13_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);
}

static void unpack_13_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);
}

static void unpack_13_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);
}

static void unpack_13_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);
}

static void unpack_13_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 312 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);
}

static void unpack_14_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 336 bits of data.
	// Input must be at least 42 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);
}

static void unpack_14_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 336 bits of data.
	// Input must be at least 42 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);
}

static void unpack_14_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);
}

static void unpack_14_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);
}

static void unpack_14_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);
}

static void unpack_14_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);
}

static void unpack_14_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);
}

static void unpack_14_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);
}

static void unpack_14_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);
}

static void unpack_14_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);
}

static void unpack_14_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);
}

static void unpack_14_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);
}

static void unpack_14_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);
}

static void unpack_14_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);
}

static void unpack_14_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);
}

static void unpack_14_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);
}

static void unpack_15_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 360 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);
}

static void unpack_15_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 360 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);
}

static void unpack_15_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);
}

static void unpack_15_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);
}

static void unpack_15_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);
}

static void unpack_15_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);
}

static void unpack_15_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);
}

static void unpack_15_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);
}

static void unpack_15_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);
}

static void unpack_15_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);
}

static void unpack_15_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);
}

static void unpack_15_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);
}

static void unpack_15_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);
}

static void unpack_15_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);
}

static void unpack_15_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);
}

static void unpack_15_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 360 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);
}

static void unpack_16_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 384 bits of data.
	// Input must be at least 48 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);
}

static void unpack_16_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 384 bits of data.
	// Input must be at least 48 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);
}

static void unpack_16_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);
}

static void unpack_16_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);
}

static void unpack_16_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);
}

static void unpack_16_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);
}

static void unpack_16_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);
}

static void unpack_16_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);
}

static void unpack_16_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);
}

static void unpack_16_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);
}

static void unpack_16_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);
}

static void unpack_16_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);
}

static void unpack_16_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);
}

static void unpack_16_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);
}

static void unpack_16_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);
}

static void unpack_16_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);
}

static void unpack_17_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 408 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);
}

static void unpack_17_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 408 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);
}

static void unpack_17_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);
}

static void unpack_17_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);
}

static void unpack_17_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);
}

static void unpack_17_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);
}

static void unpack_17_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);
}

static void unpack_17_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);
}

static void unpack_17_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);
}

static void unpack_17_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);
}

static void unpack_17_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);
}

static void unpack_17_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);
}

static void unpack_17_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);
}

static void unpack_17_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);
}

static void unpack_17_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);
}

static void unpack_17_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);
}

static void unpack_18_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 432 bits of data.
	// Input must be at least 54 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);
}

static void unpack_18_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 432 bits of data.
	// Input must be at least 54 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);
}

static void unpack_18_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);
}

static void unpack_18_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);
}

static void unpack_18_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);
}

static void unpack_18_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);
}

static void unpack_18_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);
}

static void unpack_18_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);
}

static void unpack_18_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);
}

static void unpack_18_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);
}

static void unpack_18_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);
}

static void unpack_18_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);
}

static void unpack_18_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);
}

static void unpack_18_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);
}

static void unpack_18_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);
}

static void unpack_18_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);
}

static void unpack_19_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 456 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);
}

static void unpack_19_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 456 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);
}

static void unpack_19_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);
}

static void unpack_19_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);
}

static void unpack_19_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);
}

static void unpack_19_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);
}

static void unpack_19_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);
}

static void unpack_19_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);
}

static void unpack_19_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);
}

static void unpack_19_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);
}

static void unpack_19_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);
}

static void unpack_19_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);
}

static void unpack_19_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);
}

static void unpack_19_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);
}

static void unpack_19_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);
}

static void unpack_19_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 456 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);
}

static void unpack_20_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 480 bits of data.
	// Input must be at least 60 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);
}

static void unpack_20_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 480 bits of data.
	// Input must be at least 60 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);
}

static void unpack_20_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);
}

static void unpack_20_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);
}

static void unpack_20_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);
}

static void unpack_20_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);
}

static void unpack_20_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);
}

static void unpack_20_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);
}

static void unpack_20_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);
}

static void unpack_20_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);
}

static void unpack_20_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);
}

static void unpack_20_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);
}

static void unpack_20_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);
}

static void unpack_20_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);
}

static void unpack_20_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);
}

static void unpack_20_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);
}

static void unpack_21_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 504 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);
}

static void unpack_21_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 504 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);
}

static void unpack_21_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);
}

static void unpack_21_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);
}

static void unpack_21_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);
}

static void unpack_21_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);
}

static void unpack_21_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);
}

static void unpack_21_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);
}

static void unpack_21_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);
}

static void unpack_21_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);
}

static void unpack_21_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);
}

static void unpack_21_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);
}

static void unpack_21_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);
}

static void unpack_21_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);
}

static void unpack_21_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);
}

static void unpack_21_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);
}

static void unpack_22_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 528 bits of data.
	// Input must be at least 66 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);
}

static void unpack_22_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 528 bits of data.
	// Input must be at least 66 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);
}

static void unpack_22_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);
}

static void unpack_22_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);
}

static void unpack_22_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);
}

static void unpack_22_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);
}

static void unpack_22_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);
}

static void unpack_22_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);
}

static void unpack_22_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);
}

static void unpack_22_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);
}

static void unpack_22_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);
}

static void unpack_22_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);
}

static void unpack_22_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);
}

static void unpack_22_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);
}

static void unpack_22_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);
}

static void unpack_22_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);
}

static void unpack_23_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 552 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);
}

static void unpack_23_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 552 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);
}

static void unpack_23_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 552 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);
}

static void unpack_23_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 552 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);
}

static void unpack_23_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 552 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);
}

static void unpack_23_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 552 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);
}

static void unpack_23_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 552 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);
}

static void unpack_23_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 552 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);
}

static void unpack_23_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 552 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);
}

static void unpack_23_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 552 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);
}

static void unpack_23_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 552 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);
}

static void unpack_23_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 552 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);
}

static void unpack_23_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 552 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);
}

static void unpack_23_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 552 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);
}

static void unpack_23_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 552 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);
}

static void unpack_23_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 552 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);
}

static void unpack_24_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 576 bits of data.
	// Input must be at least 72 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);
}

static void unpack_24_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 576 bits of data.
	// Input must be at least 72 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);
}

static void unpack_24_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);
}

static void unpack_24_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);
}

static void unpack_24_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);
}

static void unpack_24_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);
}

static void unpack_24_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);
}

static void unpack_24_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);
}

static void unpack_24_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);
}

static void unpack_24_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);
}

static void unpack_24_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);
}

static void unpack_24_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);
}

static void unpack_24_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);
}

static void unpack_24_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);
}

static void unpack_24_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);
}

static void unpack_24_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);
}

static void unpack_25_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 600 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);
}

static void unpack_25_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 600 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);
}

static void unpack_25_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 600 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);
}

static void unpack_25_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 600 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);
}

static void unpack_25_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 600 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);
}

static void unpack_25_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 600 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);
}

static void unpack_25_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 600 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);
}

static void unpack_25_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 600 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);
}

static void unpack_25_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 600 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);
}

static void unpack_25_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 600 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);
}

static void unpack_25_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 600 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);
}

static void unpack_25_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 600 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);
}

static void unpack_25_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 600 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);
}

static void unpack_25_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 600 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);
}

static void unpack_25_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 600 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);
}

static void unpack_25_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 600 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);
}

static void unpack_26_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 624 bits of data.
	// Input must be at least 78 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);
}

static void unpack_26_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 624 bits of data.
	// Input must be at least 78 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);
}

static void unpack_26_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);
}

static void unpack_26_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);
}

static void unpack_26_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);
}

static void unpack_26_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);
}

static void unpack_26_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);
}

static void unpack_26_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);
}

static void unpack_26_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);
}

static void unpack_26_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);
}

static void unpack_26_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);
}

static void unpack_26_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);
}

static void unpack_26_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);
}

static void unpack_26_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);
}

static void unpack_26_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);
}

static void unpack_26_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);
}

static void unpack_27_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 648 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);
}

static void unpack_27_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 648 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);
}

static void unpack_27_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 648 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);
}

static void unpack_27_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 648 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);
}

static void unpack_27_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 648 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);
}

static void unpack_27_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 648 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);
}

static void unpack_27_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 648 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);
}

static void unpack_27_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 648 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);
}

static void unpack_27_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 648 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);
}

static void unpack_27_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 648 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);
}

static void unpack_27_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 648 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);
}

static void unpack_27_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 648 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);
}

static void unpack_27_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 648 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);
}

static void unpack_27_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 648 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);
}

static void unpack_27_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 648 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);
}

static void unpack_27_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 648 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);
}

static void unpack_28_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 672 bits of data.
	// Input must be at least 84 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);
}

static void unpack_28_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 672 bits of data.
	// Input must be at least 84 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);
}

static void unpack_28_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);
}

static void unpack_28_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);
}

static void unpack_28_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);
}

static void unpack_28_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);
}

static void unpack_28_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);
}

static void unpack_28_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);
}

static void unpack_28_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);
}

static void unpack_28_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);
}

static void unpack_28_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);
}

static void unpack_28_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);
}

static void unpack_28_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);
}

static void unpack_28_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);
}

static void unpack_28_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);
}

static void unpack_28_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);
}

static void unpack_29_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 696 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);
}

static void unpack_29_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 696 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);
}

static void unpack_29_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 696 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);
}

static void unpack_29_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 696 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);
}

static void unpack_29_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 696 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);
}

static void unpack_29_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 696 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);
}

static void unpack_29_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 696 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);
}

static void unpack_29_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 696 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);
}

static void unpack_29_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 696 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);
}

static void unpack_29_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 696 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);
}

static void unpack_29_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 696 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);
}

static void unpack_29_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 696 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);
}

static void unpack_29_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 696 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);
}

static void unpack_29_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 696 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);
}

static void unpack_29_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 696 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);
}

static void unpack_29_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 696 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);
}

static void unpack_30_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 720 bits of data.
	// Input must be at least 90 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);
}

static void unpack_30_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 720 bits of data.
	// Input must be at least 90 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);
}

static void unpack_30_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);
}

static void unpack_30_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);
}

static void unpack_30_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);
}

static void unpack_30_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);
}

static void unpack_30_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);
}

static void unpack_30_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);
}

static void unpack_30_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);
}

static void unpack_30_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);
}

static void unpack_30_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);
}

static void unpack_30_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);
}

static void unpack_30_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);
}

static void unpack_30_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);
}

static void unpack_30_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);
}

static void unpack_30_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);
}

static void unpack_31_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 744 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);
}

static void unpack_31_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 744 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);
}

static void unpack_31_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 744 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);
}

static void unpack_31_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 744 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);
}

static void unpack_31_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 744 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);
}

static void unpack_31_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 744 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);
}

static void unpack_31_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 744 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);
}

static void unpack_31_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 744 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);
}

static void unpack_31_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 744 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);
}

static void unpack_31_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 744 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);
}

static void unpack_31_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 744 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);
}

static void unpack_31_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 744 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);
}

static void unpack_31_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 744 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);
}

static void unpack_31_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 744 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);
}

static void unpack_31_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 744 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);
}

static void unpack_31_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 744 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);
}

static void unpack_32_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 768 bits of data.
	// Input must be at least 96 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);
}

static void unpack_32_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 768 bits of data.
	// Input must be at least 96 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);
}

static void unpack_32_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);
}

static void unpack_32_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);
}

static void unpack_32_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);
}

static void unpack_32_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);
}

static void unpack_32_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);
}

static void unpack_32_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);
}

static void unpack_32_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);
}

static void unpack_32_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);
}

static void unpack_32_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);
}

static void unpack_32_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);
}

static void unpack_32_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);
}

static void unpack_32_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);
}

static void unpack_32_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);
}

static void unpack_32_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);
}

static void unpack_33_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 792 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);
}

static void unpack_33_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 792 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);
}

static void unpack_33_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 792 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);
}

static void unpack_33_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 792 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);
}

static void unpack_33_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 792 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);
}

static void unpack_33_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 792 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);
}

static void unpack_33_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 792 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);
}

static void unpack_33_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 792 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);
}

static void unpack_33_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 792 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);
}

static void unpack_33_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 792 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);
}

static void unpack_33_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 792 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);
}

static void unpack_33_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 792 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);
}

static void unpack_33_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 792 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);
}

static void unpack_33_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 792 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);
}

static void unpack_33_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 792 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);
}

static void unpack_33_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 792 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);
}

static void unpack_34_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 816 bits of data.
	// Input must be at least 102 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);
}

static void unpack_34_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 816 bits of data.
	// Input must be at least 102 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);
}

static void unpack_34_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);
}

static void unpack_34_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);
}

static void unpack_34_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);
}

static void unpack_34_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);
}

static void unpack_34_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);
}

static void unpack_34_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);
}

static void unpack_34_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);
}

static void unpack_34_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);
}

static void unpack_34_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);
}

static void unpack_34_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);
}

static void unpack_34_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);
}

static void unpack_34_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);
}

static void unpack_34_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);
}

static void unpack_34_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);
}

static void unpack_35_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 840 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);
}

static void unpack_35_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 840 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);
}

static void unpack_35_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 840 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);
}

static void unpack_35_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 840 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);
}

static void unpack_35_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 840 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);
}

static void unpack_35_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 840 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);
}

static void unpack_35_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 840 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);
}

static void unpack_35_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 840 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);
}

static void unpack_35_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 840 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);
}

static void unpack_35_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 840 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);
}

static void unpack_35_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 840 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);
}

static void unpack_35_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 840 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);
}

static void unpack_35_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 840 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);
}

static void unpack_35_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 840 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);
}

static void unpack_35_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 840 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);
}

static void unpack_35_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 840 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);
}

static void unpack_36_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 864 bits of data.
	// Input must be at least 108 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 840 to 863
	value = ((uint32_t)input[105] << 24) |
			((uint32_t)input[106] << 16) |
			((uint32_t)input[107] << 8);
	output[35] = (double)(value >> 8);
}

static void unpack_36_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 864 bits of data.
	// Input must be at least 108 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 840 to 863
	value = ((uint32_t)input[105] << 24) |
			((uint32_t)input[106] << 16) |
			((uint32_t)input[107] << 8);
	output[35] = (double)(value >> 8);
}

static void unpack_36_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 841 to 864
	value = ((uint32_t)(input[105] & 0x7f) << 25) |
			((uint32_t)input[106] << 17) |
			((uint32_t)input[107] << 9) |
			((uint32_t)(input[108] & 0x80) << 1);
	output[35] = (double)(value >> 8);
}

static void unpack_36_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 841 to 864
	value = ((uint32_t)(input[105] & 0x7f) << 25) |
			((uint32_t)input[106] << 17) |
			((uint32_t)input[107] << 9) |
			((uint32_t)(input[108] & 0x80) << 1);
	output[35] = (double)(value >> 8);
}

static void unpack_36_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 842 to 865
	value = ((uint32_t)(input[105] & 0x3f) << 26) |
			((uint32_t)input[106] << 18) |
			((uint32_t)input[107] << 10) |
			((uint32_t)(input[108] & 0xc0) << 2);
	output[35] = (double)(value >> 8);
}

static void unpack_36_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 842 to 865
	value = ((uint32_t)(input[105] & 0x3f) << 26) |
			((uint32_t)input[106] << 18) |
			((uint32_t)input[107] << 10) |
			((uint32_t)(input[108] & 0xc0) << 2);
	output[35] = (double)(value >> 8);
}

static void unpack_36_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 843 to 866
	value = ((uint32_t)(input[105] & 0x1f) << 27) |
			((uint32_t)input[106] << 19) |
			((uint32_t)input[107] << 11) |
			((uint32_t)(input[108] & 0xe0) << 3);
	output[35] = (double)(value >> 8);
}

static void unpack_36_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 843 to 866
	value = ((uint32_t)(input[105] & 0x1f) << 27) |
			((uint32_t)input[106] << 19) |
			((uint32_t)input[107] << 11) |
			((uint32_t)(input[108] & 0xe0) << 3);
	output[35] = (double)(value >> 8);
}

static void unpack_36_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 844 to 867
	value = ((uint32_t)(input[105] & 0x0f) << 28) |
			((uint32_t)input[106] << 20) |
			((uint32_t)input[107] << 12) |
			((uint32_t)(input[108] & 0xf0) << 4);
	output[35] = (double)(value >> 8);
}

static void unpack_36_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 844 to 867
	value = ((uint32_t)(input[105] & 0x0f) << 28) |
			((uint32_t)input[106] << 20) |
			((uint32_t)input[107] << 12) |
			((uint32_t)(input[108] & 0xf0) << 4);
	output[35] = (double)(value >> 8);
}

static void unpack_36_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 845 to 868
	value = ((uint32_t)(input[105] & 0x07) << 29) |
			((uint32_t)input[106] << 21) |
			((uint32_t)input[107] << 13) |
			((uint32_t)(input[108] & 0xf8) << 5);
	output[35] = (double)(value >> 8);
}

static void unpack_36_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 845 to 868
	value = ((uint32_t)(input[105] & 0x07) << 29) |
			((uint32_t)input[106] << 21) |
			((uint32_t)input[107] << 13) |
			((uint32_t)(input[108] & 0xf8) << 5);
	output[35] = (double)(value >> 8);
}

static void unpack_36_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 846 to 869
	value = ((uint32_t)(input[105] & 0x03) << 30) |
			((uint32_t)input[106] << 22) |
			((uint32_t)input[107] << 14) |
			((uint32_t)(input[108] & 0xfc) << 6);
	output[35] = (double)(value >> 8);
}

static void unpack_36_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 846 to 869
	value = ((uint32_t)(input[105] & 0x03) << 30) |
			((uint32_t)input[106] << 22) |
			((uint32_t)input[107] << 14) |
			((uint32_t)(input[108] & 0xfc) << 6);
	output[35] = (double)(value >> 8);
}

static void unpack_36_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 847 to 870
	value = ((uint32_t)(input[105] & 0x01) << 31) |
			((uint32_t)input[106] << 23) |
			((uint32_t)input[107] << 15) |
			((uint32_t)(input[108] & 0xfe) << 7);
	output[35] = (double)(value >> 8);
}

static void unpack_36_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 847 to 870
	value = ((uint32_t)(input[105] & 0x01) << 31) |
			((uint32_t)input[106] << 23) |
			((uint32_t)input[107] << 15) |
			((uint32_t)(input[108] & 0xfe) << 7);
	output[35] = (double)(value >> 8);
}

static void unpack_37_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 888 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 840 to 863
	value = ((uint32_t)input[105] << 24) |
			((uint32_t)input[106] << 16) |
			((uint32_t)input[107] << 8);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 864 to 887
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16) |
			((uint32_t)input[110] << 8);
	output[36] = (double)(value >> 8);
}

static void unpack_37_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 888 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 840 to 863
	value = ((uint32_t)input[105] << 24) |
			((uint32_t)input[106] << 16) |
			((uint32_t)input[107] << 8);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 864 to 887
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16) |
			((uint32_t)input[110] << 8);
	output[36] = (double)(value >> 8);
}

static void unpack_37_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 888 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 841 to 864
	value = ((uint32_t)(input[105] & 0x7f) << 25) |
			((uint32_t)input[106] << 17) |
			((uint32_t)input[107] << 9) |
			((uint32_t)(input[108] & 0x80) << 1);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 865 to 888
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)input[110] << 9) |
			((uint32_t)(input[111] & 0x80) << 1);
	output[36] = (double)(value >> 8);
}

static void unpack_37_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 888 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 841 to 864
	value = ((uint32_t)(input[105] & 0x7f) << 25) |
			((uint32_t)input[106] << 17) |
			((uint32_t)input[107] << 9) |
			((uint32_t)(input[108] & 0x80) << 1);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 865 to 888
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)input[110] << 9) |
			((uint32_t)(input[111] & 0x80) << 1);
	output[36] = (double)(value >> 8);
}

static void unpack_37_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 888 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 842 to 865
	value = ((uint32_t)(input[105] & 0x3f) << 26) |
			((uint32_t)input[106] << 18) |
			((uint32_t)input[107] << 10) |
			((uint32_t)(input[108] & 0xc0) << 2);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 866 to 889
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)input[110] << 10) |
			((uint32_t)(input[111] & 0xc0) << 2);
	output[36] = (double)(value >> 8);
}

static void unpack_37_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 888 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 842 to 865
	value = ((uint32_t)(input[105] & 0x3f) << 26) |
			((uint32_t)input[106] << 18) |
			((uint32_t)input[107] << 10) |
			((uint32_t)(input[108] & 0xc0) << 2);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 866 to 889
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)input[110] << 10) |
			((uint32_t)(input[111] & 0xc0) << 2);
	output[36] = (double)(value >> 8);
}

static void unpack_37_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 888 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 843 to 866
	value = ((uint32_t)(input[105] & 0x1f) << 27) |
			((uint32_t)input[106] << 19) |
			((uint32_t)input[107] << 11) |
			((uint32_t)(input[108] & 0xe0) << 3);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 867 to 890
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)input[110] << 11) |
			((uint32_t)(input[111] & 0xe0) << 3);
	output[36] = (double)(value >> 8);
}

static void unpack_37_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 888 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 843 to 866
	value = ((uint32_t)(input[105] & 0x1f) << 27) |
			((uint32_t)input[106] << 19) |
			((uint32_t)input[107] << 11) |
			((uint32_t)(input[108] & 0xe0) << 3);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 867 to 890
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)input[110] << 11) |
			((uint32_t)(input[111] & 0xe0) << 3);
	output[36] = (double)(value >> 8);
}

static void unpack_37_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 888 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 844 to 867
	value = ((uint32_t)(input[105] & 0x0f) << 28) |
			((uint32_t)input[106] << 20) |
			((uint32_t)input[107] << 12) |
			((uint32_t)(input[108] & 0xf0) << 4);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 868 to 891
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)input[110] << 12) |
			((uint32_t)(input[111] & 0xf0) << 4);
	output[36] = (double)(value >> 8);
}

static void unpack_37_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 888 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 844 to 867
	value = ((uint32_t)(input[105] & 0x0f) << 28) |
			((uint32_t)input[106] << 20) |
			((uint32_t)input[107] << 12) |
			((uint32_t)(input[108] & 0xf0) << 4);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 868 to 891
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)input[110] << 12) |
			((uint32_t)(input[111] & 0xf0) << 4);
	output[36] = (double)(value >> 8);
}

static void unpack_37_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 888 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 845 to 868
	value = ((uint32_t)(input[105] & 0x07) << 29) |
			((uint32_t)input[106] << 21) |
			((uint32_t)input[107] << 13) |
			((uint32_t)(input[108] & 0xf8) << 5);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 869 to 892
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)input[110] << 13) |
			((uint32_t)(input[111] & 0xf8) << 5);
	output[36] = (double)(value >> 8);
}

static void unpack_37_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 888 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 845 to 868
	value = ((uint32_t)(input[105] & 0x07) << 29) |
			((uint32_t)input[106] << 21) |
			((uint32_t)input[107] << 13) |
			((uint32_t)(input[108] & 0xf8) << 5);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 869 to 892
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)input[110] << 13) |
			((uint32_t)(input[111] & 0xf8) << 5);
	output[36] = (double)(value >> 8);
}

static void unpack_37_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 888 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 846 to 869
	value = ((uint32_t)(input[105] & 0x03) << 30) |
			((uint32_t)input[106] << 22) |
			((uint32_t)input[107] << 14) |
			((uint32_t)(input[108] & 0xfc) << 6);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 870 to 893
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)input[110] << 14) |
			((uint32_t)(input[111] & 0xfc) << 6);
	output[36] = (double)(value >> 8);
}

static void unpack_37_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 888 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 846 to 869
	value = ((uint32_t)(input[105] & 0x03) << 30) |
			((uint32_t)input[106] << 22) |
			((uint32_t)input[107] << 14) |
			((uint32_t)(input[108] & 0xfc) << 6);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 870 to 893
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)input[110] << 14) |
			((uint32_t)(input[111] & 0xfc) << 6);
	output[36] = (double)(value >> 8);
}

static void unpack_37_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 888 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 847 to 870
	value = ((uint32_t)(input[105] & 0x01) << 31) |
			((uint32_t)input[106] << 23) |
			((uint32_t)input[107] << 15) |
			((uint32_t)(input[108] & 0xfe) << 7);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 871 to 894
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)input[110] << 15) |
			((uint32_t)(input[111] & 0xfe) << 7);
	output[36] = (double)(value >> 8);
}

static void unpack_37_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 888 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 847 to 870
	value = ((uint32_t)(input[105] & 0x01) << 31) |
			((uint32_t)input[106] << 23) |
			((uint32_t)input[107] << 15) |
			((uint32_t)(input[108] & 0xfe) << 7);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 871 to 894
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)input[110] << 15) |
			((uint32_t)(input[111] & 0xfe) << 7);
	output[36] = (double)(value >> 8);
}

static void unpack_38_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 912 bits of data.
	// Input must be at least 114 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 840 to 863
	value = ((uint32_t)input[105] << 24) |
			((uint32_t)input[106] << 16) |
			((uint32_t)input[107] << 8);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 864 to 887
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16) |
			((uint32_t)input[110] << 8);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 888 to 911
	value = ((uint32_t)input[111] << 24) |
			((uint32_t)input[112] << 16) |
			((uint32_t)input[113] << 8);
	output[37] = (double)(value >> 8);
}

static void unpack_38_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 912 bits of data.
	// Input must be at least 114 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 840 to 863
	value = ((uint32_t)input[105] << 24) |
			((uint32_t)input[106] << 16) |
			((uint32_t)input[107] << 8);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 864 to 887
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16) |
			((uint32_t)input[110] << 8);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 888 to 911
	value = ((uint32_t)input[111] << 24) |
			((uint32_t)input[112] << 16) |
			((uint32_t)input[113] << 8);
	output[37] = (double)(value >> 8);
}

static void unpack_38_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 841 to 864
	value = ((uint32_t)(input[105] & 0x7f) << 25) |
			((uint32_t)input[106] << 17) |
			((uint32_t)input[107] << 9) |
			((uint32_t)(input[108] & 0x80) << 1);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 865 to 888
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)input[110] << 9) |
			((uint32_t)(input[111] & 0x80) << 1);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 889 to 912
	value = ((uint32_t)(input[111] & 0x7f) << 25) |
			((uint32_t)input[112] << 17) |
			((uint32_t)input[113] << 9) |
			((uint32_t)(input[114] & 0x80) << 1);
	output[37] = (double)(value >> 8);
}

static void unpack_38_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 841 to 864
	value = ((uint32_t)(input[105] & 0x7f) << 25) |
			((uint32_t)input[106] << 17) |
			((uint32_t)input[107] << 9) |
			((uint32_t)(input[108] & 0x80) << 1);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 865 to 888
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)input[110] << 9) |
			((uint32_t)(input[111] & 0x80) << 1);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 889 to 912
	value = ((uint32_t)(input[111] & 0x7f) << 25) |
			((uint32_t)input[112] << 17) |
			((uint32_t)input[113] << 9) |
			((uint32_t)(input[114] & 0x80) << 1);
	output[37] = (double)(value >> 8);
}

static void unpack_38_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 842 to 865
	value = ((uint32_t)(input[105] & 0x3f) << 26) |
			((uint32_t)input[106] << 18) |
			((uint32_t)input[107] << 10) |
			((uint32_t)(input[108] & 0xc0) << 2);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 866 to 889
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)input[110] << 10) |
			((uint32_t)(input[111] & 0xc0) << 2);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 890 to 913
	value = ((uint32_t)(input[111] & 0x3f) << 26) |
			((uint32_t)input[112] << 18) |
			((uint32_t)input[113] << 10) |
			((uint32_t)(input[114] & 0xc0) << 2);
	output[37] = (double)(value >> 8);
}

static void unpack_38_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 842 to 865
	value = ((uint32_t)(input[105] & 0x3f) << 26) |
			((uint32_t)input[106] << 18) |
			((uint32_t)input[107] << 10) |
			((uint32_t)(input[108] & 0xc0) << 2);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 866 to 889
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)input[110] << 10) |
			((uint32_t)(input[111] & 0xc0) << 2);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 890 to 913
	value = ((uint32_t)(input[111] & 0x3f) << 26) |
			((uint32_t)input[112] << 18) |
			((uint32_t)input[113] << 10) |
			((uint32_t)(input[114] & 0xc0) << 2);
	output[37] = (double)(value >> 8);
}

static void unpack_38_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 843 to 866
	value = ((uint32_t)(input[105] & 0x1f) << 27) |
			((uint32_t)input[106] << 19) |
			((uint32_t)input[107] << 11) |
			((uint32_t)(input[108] & 0xe0) << 3);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 867 to 890
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)input[110] << 11) |
			((uint32_t)(input[111] & 0xe0) << 3);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 891 to 914
	value = ((uint32_t)(input[111] & 0x1f) << 27) |
			((uint32_t)input[112] << 19) |
			((uint32_t)input[113] << 11) |
			((uint32_t)(input[114] & 0xe0) << 3);
	output[37] = (double)(value >> 8);
}

static void unpack_38_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 843 to 866
	value = ((uint32_t)(input[105] & 0x1f) << 27) |
			((uint32_t)input[106] << 19) |
			((uint32_t)input[107] << 11) |
			((uint32_t)(input[108] & 0xe0) << 3);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 867 to 890
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)input[110] << 11) |
			((uint32_t)(input[111] & 0xe0) << 3);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 891 to 914
	value = ((uint32_t)(input[111] & 0x1f) << 27) |
			((uint32_t)input[112] << 19) |
			((uint32_t)input[113] << 11) |
			((uint32_t)(input[114] & 0xe0) << 3);
	output[37] = (double)(value >> 8);
}

static void unpack_38_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 844 to 867
	value = ((uint32_t)(input[105] & 0x0f) << 28) |
			((uint32_t)input[106] << 20) |
			((uint32_t)input[107] << 12) |
			((uint32_t)(input[108] & 0xf0) << 4);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 868 to 891
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)input[110] << 12) |
			((uint32_t)(input[111] & 0xf0) << 4);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 892 to 915
	value = ((uint32_t)(input[111] & 0x0f) << 28) |
			((uint32_t)input[112] << 20) |
			((uint32_t)input[113] << 12) |
			((uint32_t)(input[114] & 0xf0) << 4);
	output[37] = (double)(value >> 8);
}

static void unpack_38_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 844 to 867
	value = ((uint32_t)(input[105] & 0x0f) << 28) |
			((uint32_t)input[106] << 20) |
			((uint32_t)input[107] << 12) |
			((uint32_t)(input[108] & 0xf0) << 4);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 868 to 891
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)input[110] << 12) |
			((uint32_t)(input[111] & 0xf0) << 4);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 892 to 915
	value = ((uint32_t)(input[111] & 0x0f) << 28) |
			((uint32_t)input[112] << 20) |
			((uint32_t)input[113] << 12) |
			((uint32_t)(input[114] & 0xf0) << 4);
	output[37] = (double)(value >> 8);
}

static void unpack_38_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 845 to 868
	value = ((uint32_t)(input[105] & 0x07) << 29) |
			((uint32_t)input[106] << 21) |
			((uint32_t)input[107] << 13) |
			((uint32_t)(input[108] & 0xf8) << 5);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 869 to 892
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)input[110] << 13) |
			((uint32_t)(input[111] & 0xf8) << 5);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 893 to 916
	value = ((uint32_t)(input[111] & 0x07) << 29) |
			((uint32_t)input[112] << 21) |
			((uint32_t)input[113] << 13) |
			((uint32_t)(input[114] & 0xf8) << 5);
	output[37] = (double)(value >> 8);
}

static void unpack_38_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 845 to 868
	value = ((uint32_t)(input[105] & 0x07) << 29) |
			((uint32_t)input[106] << 21) |
			((uint32_t)input[107] << 13) |
			((uint32_t)(input[108] & 0xf8) << 5);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 869 to 892
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)input[110] << 13) |
			((uint32_t)(input[111] & 0xf8) << 5);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 893 to 916
	value = ((uint32_t)(input[111] & 0x07) << 29) |
			((uint32_t)input[112] << 21) |
			((uint32_t)input[113] << 13) |
			((uint32_t)(input[114] & 0xf8) << 5);
	output[37] = (double)(value >> 8);
}

static void unpack_38_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 846 to 869
	value = ((uint32_t)(input[105] & 0x03) << 30) |
			((uint32_t)input[106] << 22) |
			((uint32_t)input[107] << 14) |
			((uint32_t)(input[108] & 0xfc) << 6);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 870 to 893
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)input[110] << 14) |
			((uint32_t)(input[111] & 0xfc) << 6);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 894 to 917
	value = ((uint32_t)(input[111] & 0x03) << 30) |
			((uint32_t)input[112] << 22) |
			((uint32_t)input[113] << 14) |
			((uint32_t)(input[114] & 0xfc) << 6);
	output[37] = (double)(value >> 8);
}

static void unpack_38_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 846 to 869
	value = ((uint32_t)(input[105] & 0x03) << 30) |
			((uint32_t)input[106] << 22) |
			((uint32_t)input[107] << 14) |
			((uint32_t)(input[108] & 0xfc) << 6);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 870 to 893
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)input[110] << 14) |
			((uint32_t)(input[111] & 0xfc) << 6);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 894 to 917
	value = ((uint32_t)(input[111] & 0x03) << 30) |
			((uint32_t)input[112] << 22) |
			((uint32_t)input[113] << 14) |
			((uint32_t)(input[114] & 0xfc) << 6);
	output[37] = (double)(value >> 8);
}

static void unpack_38_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 847 to 870
	value = ((uint32_t)(input[105] & 0x01) << 31) |
			((uint32_t)input[106] << 23) |
			((uint32_t)input[107] << 15) |
			((uint32_t)(input[108] & 0xfe) << 7);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 871 to 894
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)input[110] << 15) |
			((uint32_t)(input[111] & 0xfe) << 7);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 895 to 918
	value = ((uint32_t)(input[111] & 0x01) << 31) |
			((uint32_t)input[112] << 23) |
			((uint32_t)input[113] << 15) |
			((uint32_t)(input[114] & 0xfe) << 7);
	output[37] = (double)(value >> 8);
}

static void unpack_38_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 847 to 870
	value = ((uint32_t)(input[105] & 0x01) << 31) |
			((uint32_t)input[106] << 23) |
			((uint32_t)input[107] << 15) |
			((uint32_t)(input[108] & 0xfe) << 7);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 871 to 894
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)input[110] << 15) |
			((uint32_t)(input[111] & 0xfe) << 7);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 895 to 918
	value = ((uint32_t)(input[111] & 0x01) << 31) |
			((uint32_t)input[112] << 23) |
			((uint32_t)input[113] << 15) |
			((uint32_t)(input[114] & 0xfe) << 7);
	output[37] = (double)(value >> 8);
}

static void unpack_39_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 936 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 840 to 863
	value = ((uint32_t)input[105] << 24) |
			((uint32_t)input[106] << 16) |
			((uint32_t)input[107] << 8);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 864 to 887
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16) |
			((uint32_t)input[110] << 8);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 888 to 911
	value = ((uint32_t)input[111] << 24) |
			((uint32_t)input[112] << 16) |
			((uint32_t)input[113] << 8);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 912 to 935
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16) |
			((uint32_t)input[116] << 8);
	output[38] = (double)(value >> 8);
}

static void unpack_39_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 936 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 840 to 863
	value = ((uint32_t)input[105] << 24) |
			((uint32_t)input[106] << 16) |
			((uint32_t)input[107] << 8);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 864 to 887
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16) |
			((uint32_t)input[110] << 8);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 888 to 911
	value = ((uint32_t)input[111] << 24) |
			((uint32_t)input[112] << 16) |
			((uint32_t)input[113] << 8);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 912 to 935
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16) |
			((uint32_t)input[116] << 8);
	output[38] = (double)(value >> 8);
}

static void unpack_39_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 936 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 841 to 864
	value = ((uint32_t)(input[105] & 0x7f) << 25) |
			((uint32_t)input[106] << 17) |
			((uint32_t)input[107] << 9) |
			((uint32_t)(input[108] & 0x80) << 1);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 865 to 888
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)input[110] << 9) |
			((uint32_t)(input[111] & 0x80) << 1);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 889 to 912
	value = ((uint32_t)(input[111] & 0x7f) << 25) |
			((uint32_t)input[112] << 17) |
			((uint32_t)input[113] << 9) |
			((uint32_t)(input[114] & 0x80) << 1);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 913 to 936
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)input[116] << 9) |
			((uint32_t)(input[117] & 0x80) << 1);
	output[38] = (double)(value >> 8);
}

static void unpack_39_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 936 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 841 to 864
	value = ((uint32_t)(input[105] & 0x7f) << 25) |
			((uint32_t)input[106] << 17) |
			((uint32_t)input[107] << 9) |
			((uint32_t)(input[108] & 0x80) << 1);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 865 to 888
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)input[110] << 9) |
			((uint32_t)(input[111] & 0x80) << 1);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 889 to 912
	value = ((uint32_t)(input[111] & 0x7f) << 25) |
			((uint32_t)input[112] << 17) |
			((uint32_t)input[113] << 9) |
			((uint32_t)(input[114] & 0x80) << 1);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 913 to 936
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)input[116] << 9) |
			((uint32_t)(input[117] & 0x80) << 1);
	output[38] = (double)(value >> 8);
}

static void unpack_39_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 936 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 842 to 865
	value = ((uint32_t)(input[105] & 0x3f) << 26) |
			((uint32_t)input[106] << 18) |
			((uint32_t)input[107] << 10) |
			((uint32_t)(input[108] & 0xc0) << 2);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 866 to 889
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)input[110] << 10) |
			((uint32_t)(input[111] & 0xc0) << 2);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 890 to 913
	value = ((uint32_t)(input[111] & 0x3f) << 26) |
			((uint32_t)input[112] << 18) |
			((uint32_t)input[113] << 10) |
			((uint32_t)(input[114] & 0xc0) << 2);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 914 to 937
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)input[116] << 10) |
			((uint32_t)(input[117] & 0xc0) << 2);
	output[38] = (double)(value >> 8);
}

static void unpack_39_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 936 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 842 to 865
	value = ((uint32_t)(input[105] & 0x3f) << 26) |
			((uint32_t)input[106] << 18) |
			((uint32_t)input[107] << 10) |
			((uint32_t)(input[108] & 0xc0) << 2);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 866 to 889
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)input[110] << 10) |
			((uint32_t)(input[111] & 0xc0) << 2);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 890 to 913
	value = ((uint32_t)(input[111] & 0x3f) << 26) |
			((uint32_t)input[112] << 18) |
			((uint32_t)input[113] << 10) |
			((uint32_t)(input[114] & 0xc0) << 2);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 914 to 937
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)input[116] << 10) |
			((uint32_t)(input[117] & 0xc0) << 2);
	output[38] = (double)(value >> 8);
}

static void unpack_39_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 936 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 843 to 866
	value = ((uint32_t)(input[105] & 0x1f) << 27) |
			((uint32_t)input[106] << 19) |
			((uint32_t)input[107] << 11) |
			((uint32_t)(input[108] & 0xe0) << 3);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 867 to 890
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)input[110] << 11) |
			((uint32_t)(input[111] & 0xe0) << 3);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 891 to 914
	value = ((uint32_t)(input[111] & 0x1f) << 27) |
			((uint32_t)input[112] << 19) |
			((uint32_t)input[113] << 11) |
			((uint32_t)(input[114] & 0xe0) << 3);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 915 to 938
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)input[116] << 11) |
			((uint32_t)(input[117] & 0xe0) << 3);
	output[38] = (double)(value >> 8);
}

static void unpack_39_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 936 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 843 to 866
	value = ((uint32_t)(input[105] & 0x1f) << 27) |
			((uint32_t)input[106] << 19) |
			((uint32_t)input[107] << 11) |
			((uint32_t)(input[108] & 0xe0) << 3);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 867 to 890
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)input[110] << 11) |
			((uint32_t)(input[111] & 0xe0) << 3);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 891 to 914
	value = ((uint32_t)(input[111] & 0x1f) << 27) |
			((uint32_t)input[112] << 19) |
			((uint32_t)input[113] << 11) |
			((uint32_t)(input[114] & 0xe0) << 3);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 915 to 938
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)input[116] << 11) |
			((uint32_t)(input[117] & 0xe0) << 3);
	output[38] = (double)(value >> 8);
}

static void unpack_39_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 936 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 844 to 867
	value = ((uint32_t)(input[105] & 0x0f) << 28) |
			((uint32_t)input[106] << 20) |
			((uint32_t)input[107] << 12) |
			((uint32_t)(input[108] & 0xf0) << 4);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 868 to 891
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)input[110] << 12) |
			((uint32_t)(input[111] & 0xf0) << 4);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 892 to 915
	value = ((uint32_t)(input[111] & 0x0f) << 28) |
			((uint32_t)input[112] << 20) |
			((uint32_t)input[113] << 12) |
			((uint32_t)(input[114] & 0xf0) << 4);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 916 to 939
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)input[116] << 12) |
			((uint32_t)(input[117] & 0xf0) << 4);
	output[38] = (double)(value >> 8);
}

static void unpack_39_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 936 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 844 to 867
	value = ((uint32_t)(input[105] & 0x0f) << 28) |
			((uint32_t)input[106] << 20) |
			((uint32_t)input[107] << 12) |
			((uint32_t)(input[108] & 0xf0) << 4);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 868 to 891
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)input[110] << 12) |
			((uint32_t)(input[111] & 0xf0) << 4);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 892 to 915
	value = ((uint32_t)(input[111] & 0x0f) << 28) |
			((uint32_t)input[112] << 20) |
			((uint32_t)input[113] << 12) |
			((uint32_t)(input[114] & 0xf0) << 4);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 916 to 939
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)input[116] << 12) |
			((uint32_t)(input[117] & 0xf0) << 4);
	output[38] = (double)(value >> 8);
}

static void unpack_39_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 936 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 845 to 868
	value = ((uint32_t)(input[105] & 0x07) << 29) |
			((uint32_t)input[106] << 21) |
			((uint32_t)input[107] << 13) |
			((uint32_t)(input[108] & 0xf8) << 5);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 869 to 892
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)input[110] << 13) |
			((uint32_t)(input[111] & 0xf8) << 5);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 893 to 916
	value = ((uint32_t)(input[111] & 0x07) << 29) |
			((uint32_t)input[112] << 21) |
			((uint32_t)input[113] << 13) |
			((uint32_t)(input[114] & 0xf8) << 5);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 917 to 940
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)input[116] << 13) |
			((uint32_t)(input[117] & 0xf8) << 5);
	output[38] = (double)(value >> 8);
}

static void unpack_39_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 936 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 845 to 868
	value = ((uint32_t)(input[105] & 0x07) << 29) |
			((uint32_t)input[106] << 21) |
			((uint32_t)input[107] << 13) |
			((uint32_t)(input[108] & 0xf8) << 5);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 869 to 892
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)input[110] << 13) |
			((uint32_t)(input[111] & 0xf8) << 5);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 893 to 916
	value = ((uint32_t)(input[111] & 0x07) << 29) |
			((uint32_t)input[112] << 21) |
			((uint32_t)input[113] << 13) |
			((uint32_t)(input[114] & 0xf8) << 5);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 917 to 940
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)input[116] << 13) |
			((uint32_t)(input[117] & 0xf8) << 5);
	output[38] = (double)(value >> 8);
}

static void unpack_39_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 936 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 846 to 869
	value = ((uint32_t)(input[105] & 0x03) << 30) |
			((uint32_t)input[106] << 22) |
			((uint32_t)input[107] << 14) |
			((uint32_t)(input[108] & 0xfc) << 6);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 870 to 893
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)input[110] << 14) |
			((uint32_t)(input[111] & 0xfc) << 6);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 894 to 917
	value = ((uint32_t)(input[111] & 0x03) << 30) |
			((uint32_t)input[112] << 22) |
			((uint32_t)input[113] << 14) |
			((uint32_t)(input[114] & 0xfc) << 6);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 918 to 941
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)input[116] << 14) |
			((uint32_t)(input[117] & 0xfc) << 6);
	output[38] = (double)(value >> 8);
}

static void unpack_39_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 936 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 846 to 869
	value = ((uint32_t)(input[105] & 0x03) << 30) |
			((uint32_t)input[106] << 22) |
			((uint32_t)input[107] << 14) |
			((uint32_t)(input[108] & 0xfc) << 6);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 870 to 893
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)input[110] << 14) |
			((uint32_t)(input[111] & 0xfc) << 6);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 894 to 917
	value = ((uint32_t)(input[111] & 0x03) << 30) |
			((uint32_t)input[112] << 22) |
			((uint32_t)input[113] << 14) |
			((uint32_t)(input[114] & 0xfc) << 6);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 918 to 941
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)input[116] << 14) |
			((uint32_t)(input[117] & 0xfc) << 6);
	output[38] = (double)(value >> 8);
}

static void unpack_39_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 936 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 847 to 870
	value = ((uint32_t)(input[105] & 0x01) << 31) |
			((uint32_t)input[106] << 23) |
			((uint32_t)input[107] << 15) |
			((uint32_t)(input[108] & 0xfe) << 7);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 871 to 894
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)input[110] << 15) |
			((uint32_t)(input[111] & 0xfe) << 7);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 895 to 918
	value = ((uint32_t)(input[111] & 0x01) << 31) |
			((uint32_t)input[112] << 23) |
			((uint32_t)input[113] << 15) |
			((uint32_t)(input[114] & 0xfe) << 7);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 919 to 942
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)input[116] << 15) |
			((uint32_t)(input[117] & 0xfe) << 7);
	output[38] = (double)(value >> 8);
}

static void unpack_39_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 936 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 847 to 870
	value = ((uint32_t)(input[105] & 0x01) << 31) |
			((uint32_t)input[106] << 23) |
			((uint32_t)input[107] << 15) |
			((uint32_t)(input[108] & 0xfe) << 7);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 871 to 894
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)input[110] << 15) |
			((uint32_t)(input[111] & 0xfe) << 7);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 895 to 918
	value = ((uint32_t)(input[111] & 0x01) << 31) |
			((uint32_t)input[112] << 23) |
			((uint32_t)input[113] << 15) |
			((uint32_t)(input[114] & 0xfe) << 7);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 919 to 942
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)input[116] << 15) |
			((uint32_t)(input[117] & 0xfe) << 7);
	output[38] = (double)(value >> 8);
}

static void unpack_40_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 960 bits of data.
	// Input must be at least 120 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 840 to 863
	value = ((uint32_t)input[105] << 24) |
			((uint32_t)input[106] << 16) |
			((uint32_t)input[107] << 8);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 864 to 887
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16) |
			((uint32_t)input[110] << 8);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 888 to 911
	value = ((uint32_t)input[111] << 24) |
			((uint32_t)input[112] << 16) |
			((uint32_t)input[113] << 8);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 912 to 935
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16) |
			((uint32_t)input[116] << 8);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 936 to 959
	value = ((uint32_t)input[117] << 24) |
			((uint32_t)input[118] << 16) |
			((uint32_t)input[119] << 8);
	output[39] = (double)(value >> 8);
}

static void unpack_40_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 960 bits of data.
	// Input must be at least 120 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 840 to 863
	value = ((uint32_t)input[105] << 24) |
			((uint32_t)input[106] << 16) |
			((uint32_t)input[107] << 8);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 864 to 887
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16) |
			((uint32_t)input[110] << 8);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 888 to 911
	value = ((uint32_t)input[111] << 24) |
			((uint32_t)input[112] << 16) |
			((uint32_t)input[113] << 8);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 912 to 935
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16) |
			((uint32_t)input[116] << 8);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 936 to 959
	value = ((uint32_t)input[117] << 24) |
			((uint32_t)input[118] << 16) |
			((uint32_t)input[119] << 8);
	output[39] = (double)(value >> 8);
}

static void unpack_40_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 841 to 864
	value = ((uint32_t)(input[105] & 0x7f) << 25) |
			((uint32_t)input[106] << 17) |
			((uint32_t)input[107] << 9) |
			((uint32_t)(input[108] & 0x80) << 1);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 865 to 888
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)input[110] << 9) |
			((uint32_t)(input[111] & 0x80) << 1);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 889 to 912
	value = ((uint32_t)(input[111] & 0x7f) << 25) |
			((uint32_t)input[112] << 17) |
			((uint32_t)input[113] << 9) |
			((uint32_t)(input[114] & 0x80) << 1);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 913 to 936
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)input[116] << 9) |
			((uint32_t)(input[117] & 0x80) << 1);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 937 to 960
	value = ((uint32_t)(input[117] & 0x7f) << 25) |
			((uint32_t)input[118] << 17) |
			((uint32_t)input[119] << 9) |
			((uint32_t)(input[120] & 0x80) << 1);
	output[39] = (double)(value >> 8);
}

static void unpack_40_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 841 to 864
	value = ((uint32_t)(input[105] & 0x7f) << 25) |
			((uint32_t)input[106] << 17) |
			((uint32_t)input[107] << 9) |
			((uint32_t)(input[108] & 0x80) << 1);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 865 to 888
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)input[110] << 9) |
			((uint32_t)(input[111] & 0x80) << 1);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 889 to 912
	value = ((uint32_t)(input[111] & 0x7f) << 25) |
			((uint32_t)input[112] << 17) |
			((uint32_t)input[113] << 9) |
			((uint32_t)(input[114] & 0x80) << 1);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 913 to 936
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)input[116] << 9) |
			((uint32_t)(input[117] & 0x80) << 1);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 937 to 960
	value = ((uint32_t)(input[117] & 0x7f) << 25) |
			((uint32_t)input[118] << 17) |
			((uint32_t)input[119] << 9) |
			((uint32_t)(input[120] & 0x80) << 1);
	output[39] = (double)(value >> 8);
}

static void unpack_40_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 842 to 865
	value = ((uint32_t)(input[105] & 0x3f) << 26) |
			((uint32_t)input[106] << 18) |
			((uint32_t)input[107] << 10) |
			((uint32_t)(input[108] & 0xc0) << 2);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 866 to 889
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)input[110] << 10) |
			((uint32_t)(input[111] & 0xc0) << 2);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 890 to 913
	value = ((uint32_t)(input[111] & 0x3f) << 26) |
			((uint32_t)input[112] << 18) |
			((uint32_t)input[113] << 10) |
			((uint32_t)(input[114] & 0xc0) << 2);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 914 to 937
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)input[116] << 10) |
			((uint32_t)(input[117] & 0xc0) << 2);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 938 to 961
	value = ((uint32_t)(input[117] & 0x3f) << 26) |
			((uint32_t)input[118] << 18) |
			((uint32_t)input[119] << 10) |
			((uint32_t)(input[120] & 0xc0) << 2);
	output[39] = (double)(value >> 8);
}

static void unpack_40_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 842 to 865
	value = ((uint32_t)(input[105] & 0x3f) << 26) |
			((uint32_t)input[106] << 18) |
			((uint32_t)input[107] << 10) |
			((uint32_t)(input[108] & 0xc0) << 2);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 866 to 889
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)input[110] << 10) |
			((uint32_t)(input[111] & 0xc0) << 2);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 890 to 913
	value = ((uint32_t)(input[111] & 0x3f) << 26) |
			((uint32_t)input[112] << 18) |
			((uint32_t)input[113] << 10) |
			((uint32_t)(input[114] & 0xc0) << 2);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 914 to 937
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)input[116] << 10) |
			((uint32_t)(input[117] & 0xc0) << 2);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 938 to 961
	value = ((uint32_t)(input[117] & 0x3f) << 26) |
			((uint32_t)input[118] << 18) |
			((uint32_t)input[119] << 10) |
			((uint32_t)(input[120] & 0xc0) << 2);
	output[39] = (double)(value >> 8);
}

static void unpack_40_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 843 to 866
	value = ((uint32_t)(input[105] & 0x1f) << 27) |
			((uint32_t)input[106] << 19) |
			((uint32_t)input[107] << 11) |
			((uint32_t)(input[108] & 0xe0) << 3);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 867 to 890
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)input[110] << 11) |
			((uint32_t)(input[111] & 0xe0) << 3);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 891 to 914
	value = ((uint32_t)(input[111] & 0x1f) << 27) |
			((uint32_t)input[112] << 19) |
			((uint32_t)input[113] << 11) |
			((uint32_t)(input[114] & 0xe0) << 3);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 915 to 938
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)input[116] << 11) |
			((uint32_t)(input[117] & 0xe0) << 3);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 939 to 962
	value = ((uint32_t)(input[117] & 0x1f) << 27) |
			((uint32_t)input[118] << 19) |
			((uint32_t)input[119] << 11) |
			((uint32_t)(input[120] & 0xe0) << 3);
	output[39] = (double)(value >> 8);
}

static void unpack_40_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 843 to 866
	value = ((uint32_t)(input[105] & 0x1f) << 27) |
			((uint32_t)input[106] << 19) |
			((uint32_t)input[107] << 11) |
			((uint32_t)(input[108] & 0xe0) << 3);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 867 to 890
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)input[110] << 11) |
			((uint32_t)(input[111] & 0xe0) << 3);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 891 to 914
	value = ((uint32_t)(input[111] & 0x1f) << 27) |
			((uint32_t)input[112] << 19) |
			((uint32_t)input[113] << 11) |
			((uint32_t)(input[114] & 0xe0) << 3);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 915 to 938
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)input[116] << 11) |
			((uint32_t)(input[117] & 0xe0) << 3);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 939 to 962
	value = ((uint32_t)(input[117] & 0x1f) << 27) |
			((uint32_t)input[118] << 19) |
			((uint32_t)input[119] << 11) |
			((uint32_t)(input[120] & 0xe0) << 3);
	output[39] = (double)(value >> 8);
}

static void unpack_40_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 844 to 867
	value = ((uint32_t)(input[105] & 0x0f) << 28) |
			((uint32_t)input[106] << 20) |
			((uint32_t)input[107] << 12) |
			((uint32_t)(input[108] & 0xf0) << 4);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 868 to 891
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)input[110] << 12) |
			((uint32_t)(input[111] & 0xf0) << 4);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 892 to 915
	value = ((uint32_t)(input[111] & 0x0f) << 28) |
			((uint32_t)input[112] << 20) |
			((uint32_t)input[113] << 12) |
			((uint32_t)(input[114] & 0xf0) << 4);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 916 to 939
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)input[116] << 12) |
			((uint32_t)(input[117] & 0xf0) << 4);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 940 to 963
	value = ((uint32_t)(input[117] & 0x0f) << 28) |
			((uint32_t)input[118] << 20) |
			((uint32_t)input[119] << 12) |
			((uint32_t)(input[120] & 0xf0) << 4);
	output[39] = (double)(value >> 8);
}

static void unpack_40_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 844 to 867
	value = ((uint32_t)(input[105] & 0x0f) << 28) |
			((uint32_t)input[106] << 20) |
			((uint32_t)input[107] << 12) |
			((uint32_t)(input[108] & 0xf0) << 4);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 868 to 891
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)input[110] << 12) |
			((uint32_t)(input[111] & 0xf0) << 4);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 892 to 915
	value = ((uint32_t)(input[111] & 0x0f) << 28) |
			((uint32_t)input[112] << 20) |
			((uint32_t)input[113] << 12) |
			((uint32_t)(input[114] & 0xf0) << 4);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 916 to 939
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)input[116] << 12) |
			((uint32_t)(input[117] & 0xf0) << 4);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 940 to 963
	value = ((uint32_t)(input[117] & 0x0f) << 28) |
			((uint32_t)input[118] << 20) |
			((uint32_t)input[119] << 12) |
			((uint32_t)(input[120] & 0xf0) << 4);
	output[39] = (double)(value >> 8);
}

static void unpack_40_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 845 to 868
	value = ((uint32_t)(input[105] & 0x07) << 29) |
			((uint32_t)input[106] << 21) |
			((uint32_t)input[107] << 13) |
			((uint32_t)(input[108] & 0xf8) << 5);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 869 to 892
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)input[110] << 13) |
			((uint32_t)(input[111] & 0xf8) << 5);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 893 to 916
	value = ((uint32_t)(input[111] & 0x07) << 29) |
			((uint32_t)input[112] << 21) |
			((uint32_t)input[113] << 13) |
			((uint32_t)(input[114] & 0xf8) << 5);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 917 to 940
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)input[116] << 13) |
			((uint32_t)(input[117] & 0xf8) << 5);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 941 to 964
	value = ((uint32_t)(input[117] & 0x07) << 29) |
			((uint32_t)input[118] << 21) |
			((uint32_t)input[119] << 13) |
			((uint32_t)(input[120] & 0xf8) << 5);
	output[39] = (double)(value >> 8);
}

static void unpack_40_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 845 to 868
	value = ((uint32_t)(input[105] & 0x07) << 29) |
			((uint32_t)input[106] << 21) |
			((uint32_t)input[107] << 13) |
			((uint32_t)(input[108] & 0xf8) << 5);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 869 to 892
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)input[110] << 13) |
			((uint32_t)(input[111] & 0xf8) << 5);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 893 to 916
	value = ((uint32_t)(input[111] & 0x07) << 29) |
			((uint32_t)input[112] << 21) |
			((uint32_t)input[113] << 13) |
			((uint32_t)(input[114] & 0xf8) << 5);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 917 to 940
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)input[116] << 13) |
			((uint32_t)(input[117] & 0xf8) << 5);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 941 to 964
	value = ((uint32_t)(input[117] & 0x07) << 29) |
			((uint32_t)input[118] << 21) |
			((uint32_t)input[119] << 13) |
			((uint32_t)(input[120] & 0xf8) << 5);
	output[39] = (double)(value >> 8);
}

static void unpack_40_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 846 to 869
	value = ((uint32_t)(input[105] & 0x03) << 30) |
			((uint32_t)input[106] << 22) |
			((uint32_t)input[107] << 14) |
			((uint32_t)(input[108] & 0xfc) << 6);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 870 to 893
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)input[110] << 14) |
			((uint32_t)(input[111] & 0xfc) << 6);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 894 to 917
	value = ((uint32_t)(input[111] & 0x03) << 30) |
			((uint32_t)input[112] << 22) |
			((uint32_t)input[113] << 14) |
			((uint32_t)(input[114] & 0xfc) << 6);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 918 to 941
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)input[116] << 14) |
			((uint32_t)(input[117] & 0xfc) << 6);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 942 to 965
	value = ((uint32_t)(input[117] & 0x03) << 30) |
			((uint32_t)input[118] << 22) |
			((uint32_t)input[119] << 14) |
			((uint32_t)(input[120] & 0xfc) << 6);
	output[39] = (double)(value >> 8);
}

static void unpack_40_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 846 to 869
	value = ((uint32_t)(input[105] & 0x03) << 30) |
			((uint32_t)input[106] << 22) |
			((uint32_t)input[107] << 14) |
			((uint32_t)(input[108] & 0xfc) << 6);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 870 to 893
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)input[110] << 14) |
			((uint32_t)(input[111] & 0xfc) << 6);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 894 to 917
	value = ((uint32_t)(input[111] & 0x03) << 30) |
			((uint32_t)input[112] << 22) |
			((uint32_t)input[113] << 14) |
			((uint32_t)(input[114] & 0xfc) << 6);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 918 to 941
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)input[116] << 14) |
			((uint32_t)(input[117] & 0xfc) << 6);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 942 to 965
	value = ((uint32_t)(input[117] & 0x03) << 30) |
			((uint32_t)input[118] << 22) |
			((uint32_t)input[119] << 14) |
			((uint32_t)(input[120] & 0xfc) << 6);
	output[39] = (double)(value >> 8);
}

static void unpack_40_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 847 to 870
	value = ((uint32_t)(input[105] & 0x01) << 31) |
			((uint32_t)input[106] << 23) |
			((uint32_t)input[107] << 15) |
			((uint32_t)(input[108] & 0xfe) << 7);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 871 to 894
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)input[110] << 15) |
			((uint32_t)(input[111] & 0xfe) << 7);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 895 to 918
	value = ((uint32_t)(input[111] & 0x01) << 31) |
			((uint32_t)input[112] << 23) |
			((uint32_t)input[113] << 15) |
			((uint32_t)(input[114] & 0xfe) << 7);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 919 to 942
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)input[116] << 15) |
			((uint32_t)(input[117] & 0xfe) << 7);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 943 to 966
	value = ((uint32_t)(input[117] & 0x01) << 31) |
			((uint32_t)input[118] << 23) |
			((uint32_t)input[119] << 15) |
			((uint32_t)(input[120] & 0xfe) << 7);
	output[39] = (double)(value >> 8);
}

static void unpack_40_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 847 to 870
	value = ((uint32_t)(input[105] & 0x01) << 31) |
			((uint32_t)input[106] << 23) |
			((uint32_t)input[107] << 15) |
			((uint32_t)(input[108] & 0xfe) << 7);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 871 to 894
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)input[110] << 15) |
			((uint32_t)(input[111] & 0xfe) << 7);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 895 to 918
	value = ((uint32_t)(input[111] & 0x01) << 31) |
			((uint32_t)input[112] << 23) |
			((uint32_t)input[113] << 15) |
			((uint32_t)(input[114] & 0xfe) << 7);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 919 to 942
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)input[116] << 15) |
			((uint32_t)(input[117] & 0xfe) << 7);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 943 to 966
	value = ((uint32_t)(input[117] & 0x01) << 31) |
			((uint32_t)input[118] << 23) |
			((uint32_t)input[119] << 15) |
			((uint32_t)(input[120] & 0xfe) << 7);
	output[39] = (double)(value >> 8);
}

static void unpack_41_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 984 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 840 to 863
	value = ((uint32_t)input[105] << 24) |
			((uint32_t)input[106] << 16) |
			((uint32_t)input[107] << 8);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 864 to 887
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16) |
			((uint32_t)input[110] << 8);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 888 to 911
	value = ((uint32_t)input[111] << 24) |
			((uint32_t)input[112] << 16) |
			((uint32_t)input[113] << 8);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 912 to 935
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16) |
			((uint32_t)input[116] << 8);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 936 to 959
	value = ((uint32_t)input[117] << 24) |
			((uint32_t)input[118] << 16) |
			((uint32_t)input[119] << 8);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 960 to 983
	value = ((uint32_t)input[120] << 24) |
			((uint32_t)input[121] << 16) |
			((uint32_t)input[122] << 8);
	output[40] = (double)(value >> 8);
}

static void unpack_41_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 984 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 840 to 863
	value = ((uint32_t)input[105] << 24) |
			((uint32_t)input[106] << 16) |
			((uint32_t)input[107] << 8);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 864 to 887
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16) |
			((uint32_t)input[110] << 8);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 888 to 911
	value = ((uint32_t)input[111] << 24) |
			((uint32_t)input[112] << 16) |
			((uint32_t)input[113] << 8);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 912 to 935
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16) |
			((uint32_t)input[116] << 8);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 936 to 959
	value = ((uint32_t)input[117] << 24) |
			((uint32_t)input[118] << 16) |
			((uint32_t)input[119] << 8);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 960 to 983
	value = ((uint32_t)input[120] << 24) |
			((uint32_t)input[121] << 16) |
			((uint32_t)input[122] << 8);
	output[40] = (double)(value >> 8);
}

static void unpack_41_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 984 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 841 to 864
	value = ((uint32_t)(input[105] & 0x7f) << 25) |
			((uint32_t)input[106] << 17) |
			((uint32_t)input[107] << 9) |
			((uint32_t)(input[108] & 0x80) << 1);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 865 to 888
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)input[110] << 9) |
			((uint32_t)(input[111] & 0x80) << 1);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 889 to 912
	value = ((uint32_t)(input[111] & 0x7f) << 25) |
			((uint32_t)input[112] << 17) |
			((uint32_t)input[113] << 9) |
			((uint32_t)(input[114] & 0x80) << 1);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 913 to 936
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)input[116] << 9) |
			((uint32_t)(input[117] & 0x80) << 1);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 937 to 960
	value = ((uint32_t)(input[117] & 0x7f) << 25) |
			((uint32_t)input[118] << 17) |
			((uint32_t)input[119] << 9) |
			((uint32_t)(input[120] & 0x80) << 1);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 961 to 984
	value = ((uint32_t)(input[120] & 0x7f) << 25) |
			((uint32_t)input[121] << 17) |
			((uint32_t)input[122] << 9) |
			((uint32_t)(input[123] & 0x80) << 1);
	output[40] = (double)(value >> 8);
}

static void unpack_41_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 984 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 841 to 864
	value = ((uint32_t)(input[105] & 0x7f) << 25) |
			((uint32_t)input[106] << 17) |
			((uint32_t)input[107] << 9) |
			((uint32_t)(input[108] & 0x80) << 1);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 865 to 888
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)input[110] << 9) |
			((uint32_t)(input[111] & 0x80) << 1);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 889 to 912
	value = ((uint32_t)(input[111] & 0x7f) << 25) |
			((uint32_t)input[112] << 17) |
			((uint32_t)input[113] << 9) |
			((uint32_t)(input[114] & 0x80) << 1);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 913 to 936
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)input[116] << 9) |
			((uint32_t)(input[117] & 0x80) << 1);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 937 to 960
	value = ((uint32_t)(input[117] & 0x7f) << 25) |
			((uint32_t)input[118] << 17) |
			((uint32_t)input[119] << 9) |
			((uint32_t)(input[120] & 0x80) << 1);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 961 to 984
	value = ((uint32_t)(input[120] & 0x7f) << 25) |
			((uint32_t)input[121] << 17) |
			((uint32_t)input[122] << 9) |
			((uint32_t)(input[123] & 0x80) << 1);
	output[40] = (double)(value >> 8);
}

static void unpack_41_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 984 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 842 to 865
	value = ((uint32_t)(input[105] & 0x3f) << 26) |
			((uint32_t)input[106] << 18) |
			((uint32_t)input[107] << 10) |
			((uint32_t)(input[108] & 0xc0) << 2);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 866 to 889
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)input[110] << 10) |
			((uint32_t)(input[111] & 0xc0) << 2);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 890 to 913
	value = ((uint32_t)(input[111] & 0x3f) << 26) |
			((uint32_t)input[112] << 18) |
			((uint32_t)input[113] << 10) |
			((uint32_t)(input[114] & 0xc0) << 2);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 914 to 937
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)input[116] << 10) |
			((uint32_t)(input[117] & 0xc0) << 2);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 938 to 961
	value = ((uint32_t)(input[117] & 0x3f) << 26) |
			((uint32_t)input[118] << 18) |
			((uint32_t)input[119] << 10) |
			((uint32_t)(input[120] & 0xc0) << 2);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 962 to 985
	value = ((uint32_t)(input[120] & 0x3f) << 26) |
			((uint32_t)input[121] << 18) |
			((uint32_t)input[122] << 10) |
			((uint32_t)(input[123] & 0xc0) << 2);
	output[40] = (double)(value >> 8);
}

static void unpack_41_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 984 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 842 to 865
	value = ((uint32_t)(input[105] & 0x3f) << 26) |
			((uint32_t)input[106] << 18) |
			((uint32_t)input[107] << 10) |
			((uint32_t)(input[108] & 0xc0) << 2);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 866 to 889
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)input[110] << 10) |
			((uint32_t)(input[111] & 0xc0) << 2);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 890 to 913
	value = ((uint32_t)(input[111] & 0x3f) << 26) |
			((uint32_t)input[112] << 18) |
			((uint32_t)input[113] << 10) |
			((uint32_t)(input[114] & 0xc0) << 2);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 914 to 937
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)input[116] << 10) |
			((uint32_t)(input[117] & 0xc0) << 2);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 938 to 961
	value = ((uint32_t)(input[117] & 0x3f) << 26) |
			((uint32_t)input[118] << 18) |
			((uint32_t)input[119] << 10) |
			((uint32_t)(input[120] & 0xc0) << 2);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 962 to 985
	value = ((uint32_t)(input[120] & 0x3f) << 26) |
			((uint32_t)input[121] << 18) |
			((uint32_t)input[122] << 10) |
			((uint32_t)(input[123] & 0xc0) << 2);
	output[40] = (double)(value >> 8);
}

static void unpack_41_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 984 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 843 to 866
	value = ((uint32_t)(input[105] & 0x1f) << 27) |
			((uint32_t)input[106] << 19) |
			((uint32_t)input[107] << 11) |
			((uint32_t)(input[108] & 0xe0) << 3);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 867 to 890
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)input[110] << 11) |
			((uint32_t)(input[111] & 0xe0) << 3);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 891 to 914
	value = ((uint32_t)(input[111] & 0x1f) << 27) |
			((uint32_t)input[112] << 19) |
			((uint32_t)input[113] << 11) |
			((uint32_t)(input[114] & 0xe0) << 3);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 915 to 938
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)input[116] << 11) |
			((uint32_t)(input[117] & 0xe0) << 3);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 939 to 962
	value = ((uint32_t)(input[117] & 0x1f) << 27) |
			((uint32_t)input[118] << 19) |
			((uint32_t)input[119] << 11) |
			((uint32_t)(input[120] & 0xe0) << 3);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 963 to 986
	value = ((uint32_t)(input[120] & 0x1f) << 27) |
			((uint32_t)input[121] << 19) |
			((uint32_t)input[122] << 11) |
			((uint32_t)(input[123] & 0xe0) << 3);
	output[40] = (double)(value >> 8);
}

static void unpack_41_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 984 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 843 to 866
	value = ((uint32_t)(input[105] & 0x1f) << 27) |
			((uint32_t)input[106] << 19) |
			((uint32_t)input[107] << 11) |
			((uint32_t)(input[108] & 0xe0) << 3);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 867 to 890
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)input[110] << 11) |
			((uint32_t)(input[111] & 0xe0) << 3);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 891 to 914
	value = ((uint32_t)(input[111] & 0x1f) << 27) |
			((uint32_t)input[112] << 19) |
			((uint32_t)input[113] << 11) |
			((uint32_t)(input[114] & 0xe0) << 3);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 915 to 938
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)input[116] << 11) |
			((uint32_t)(input[117] & 0xe0) << 3);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 939 to 962
	value = ((uint32_t)(input[117] & 0x1f) << 27) |
			((uint32_t)input[118] << 19) |
			((uint32_t)input[119] << 11) |
			((uint32_t)(input[120] & 0xe0) << 3);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 963 to 986
	value = ((uint32_t)(input[120] & 0x1f) << 27) |
			((uint32_t)input[121] << 19) |
			((uint32_t)input[122] << 11) |
			((uint32_t)(input[123] & 0xe0) << 3);
	output[40] = (double)(value >> 8);
}

static void unpack_41_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 984 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 844 to 867
	value = ((uint32_t)(input[105] & 0x0f) << 28) |
			((uint32_t)input[106] << 20) |
			((uint32_t)input[107] << 12) |
			((uint32_t)(input[108] & 0xf0) << 4);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 868 to 891
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)input[110] << 12) |
			((uint32_t)(input[111] & 0xf0) << 4);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 892 to 915
	value = ((uint32_t)(input[111] & 0x0f) << 28) |
			((uint32_t)input[112] << 20) |
			((uint32_t)input[113] << 12) |
			((uint32_t)(input[114] & 0xf0) << 4);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 916 to 939
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)input[116] << 12) |
			((uint32_t)(input[117] & 0xf0) << 4);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 940 to 963
	value = ((uint32_t)(input[117] & 0x0f) << 28) |
			((uint32_t)input[118] << 20) |
			((uint32_t)input[119] << 12) |
			((uint32_t)(input[120] & 0xf0) << 4);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 964 to 987
	value = ((uint32_t)(input[120] & 0x0f) << 28) |
			((uint32_t)input[121] << 20) |
			((uint32_t)input[122] << 12) |
			((uint32_t)(input[123] & 0xf0) << 4);
	output[40] = (double)(value >> 8);
}

static void unpack_41_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 984 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 844 to 867
	value = ((uint32_t)(input[105] & 0x0f) << 28) |
			((uint32_t)input[106] << 20) |
			((uint32_t)input[107] << 12) |
			((uint32_t)(input[108] & 0xf0) << 4);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 868 to 891
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)input[110] << 12) |
			((uint32_t)(input[111] & 0xf0) << 4);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 892 to 915
	value = ((uint32_t)(input[111] & 0x0f) << 28) |
			((uint32_t)input[112] << 20) |
			((uint32_t)input[113] << 12) |
			((uint32_t)(input[114] & 0xf0) << 4);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 916 to 939
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)input[116] << 12) |
			((uint32_t)(input[117] & 0xf0) << 4);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 940 to 963
	value = ((uint32_t)(input[117] & 0x0f) << 28) |
			((uint32_t)input[118] << 20) |
			((uint32_t)input[119] << 12) |
			((uint32_t)(input[120] & 0xf0) << 4);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 964 to 987
	value = ((uint32_t)(input[120] & 0x0f) << 28) |
			((uint32_t)input[121] << 20) |
			((uint32_t)input[122] << 12) |
			((uint32_t)(input[123] & 0xf0) << 4);
	output[40] = (double)(value >> 8);
}

static void unpack_41_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 984 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 845 to 868
	value = ((uint32_t)(input[105] & 0x07) << 29) |
			((uint32_t)input[106] << 21) |
			((uint32_t)input[107] << 13) |
			((uint32_t)(input[108] & 0xf8) << 5);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 869 to 892
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)input[110] << 13) |
			((uint32_t)(input[111] & 0xf8) << 5);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 893 to 916
	value = ((uint32_t)(input[111] & 0x07) << 29) |
			((uint32_t)input[112] << 21) |
			((uint32_t)input[113] << 13) |
			((uint32_t)(input[114] & 0xf8) << 5);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 917 to 940
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)input[116] << 13) |
			((uint32_t)(input[117] & 0xf8) << 5);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 941 to 964
	value = ((uint32_t)(input[117] & 0x07) << 29) |
			((uint32_t)input[118] << 21) |
			((uint32_t)input[119] << 13) |
			((uint32_t)(input[120] & 0xf8) << 5);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 965 to 988
	value = ((uint32_t)(input[120] & 0x07) << 29) |
			((uint32_t)input[121] << 21) |
			((uint32_t)input[122] << 13) |
			((uint32_t)(input[123] & 0xf8) << 5);
	output[40] = (double)(value >> 8);
}

static void unpack_41_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 984 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 845 to 868
	value = ((uint32_t)(input[105] & 0x07) << 29) |
			((uint32_t)input[106] << 21) |
			((uint32_t)input[107] << 13) |
			((uint32_t)(input[108] & 0xf8) << 5);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 869 to 892
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)input[110] << 13) |
			((uint32_t)(input[111] & 0xf8) << 5);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 893 to 916
	value = ((uint32_t)(input[111] & 0x07) << 29) |
			((uint32_t)input[112] << 21) |
			((uint32_t)input[113] << 13) |
			((uint32_t)(input[114] & 0xf8) << 5);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 917 to 940
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)input[116] << 13) |
			((uint32_t)(input[117] & 0xf8) << 5);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 941 to 964
	value = ((uint32_t)(input[117] & 0x07) << 29) |
			((uint32_t)input[118] << 21) |
			((uint32_t)input[119] << 13) |
			((uint32_t)(input[120] & 0xf8) << 5);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 965 to 988
	value = ((uint32_t)(input[120] & 0x07) << 29) |
			((uint32_t)input[121] << 21) |
			((uint32_t)input[122] << 13) |
			((uint32_t)(input[123] & 0xf8) << 5);
	output[40] = (double)(value >> 8);
}

static void unpack_41_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 984 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 846 to 869
	value = ((uint32_t)(input[105] & 0x03) << 30) |
			((uint32_t)input[106] << 22) |
			((uint32_t)input[107] << 14) |
			((uint32_t)(input[108] & 0xfc) << 6);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 870 to 893
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)input[110] << 14) |
			((uint32_t)(input[111] & 0xfc) << 6);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 894 to 917
	value = ((uint32_t)(input[111] & 0x03) << 30) |
			((uint32_t)input[112] << 22) |
			((uint32_t)input[113] << 14) |
			((uint32_t)(input[114] & 0xfc) << 6);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 918 to 941
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)input[116] << 14) |
			((uint32_t)(input[117] & 0xfc) << 6);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 942 to 965
	value = ((uint32_t)(input[117] & 0x03) << 30) |
			((uint32_t)input[118] << 22) |
			((uint32_t)input[119] << 14) |
			((uint32_t)(input[120] & 0xfc) << 6);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 966 to 989
	value = ((uint32_t)(input[120] & 0x03) << 30) |
			((uint32_t)input[121] << 22) |
			((uint32_t)input[122] << 14) |
			((uint32_t)(input[123] & 0xfc) << 6);
	output[40] = (double)(value >> 8);
}

static void unpack_41_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 984 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 846 to 869
	value = ((uint32_t)(input[105] & 0x03) << 30) |
			((uint32_t)input[106] << 22) |
			((uint32_t)input[107] << 14) |
			((uint32_t)(input[108] & 0xfc) << 6);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 870 to 893
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)input[110] << 14) |
			((uint32_t)(input[111] & 0xfc) << 6);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 894 to 917
	value = ((uint32_t)(input[111] & 0x03) << 30) |
			((uint32_t)input[112] << 22) |
			((uint32_t)input[113] << 14) |
			((uint32_t)(input[114] & 0xfc) << 6);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 918 to 941
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)input[116] << 14) |
			((uint32_t)(input[117] & 0xfc) << 6);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 942 to 965
	value = ((uint32_t)(input[117] & 0x03) << 30) |
			((uint32_t)input[118] << 22) |
			((uint32_t)input[119] << 14) |
			((uint32_t)(input[120] & 0xfc) << 6);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 966 to 989
	value = ((uint32_t)(input[120] & 0x03) << 30) |
			((uint32_t)input[121] << 22) |
			((uint32_t)input[122] << 14) |
			((uint32_t)(input[123] & 0xfc) << 6);
	output[40] = (double)(value >> 8);
}

static void unpack_41_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 984 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 847 to 870
	value = ((uint32_t)(input[105] & 0x01) << 31) |
			((uint32_t)input[106] << 23) |
			((uint32_t)input[107] << 15) |
			((uint32_t)(input[108] & 0xfe) << 7);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 871 to 894
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)input[110] << 15) |
			((uint32_t)(input[111] & 0xfe) << 7);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 895 to 918
	value = ((uint32_t)(input[111] & 0x01) << 31) |
			((uint32_t)input[112] << 23) |
			((uint32_t)input[113] << 15) |
			((uint32_t)(input[114] & 0xfe) << 7);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 919 to 942
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)input[116] << 15) |
			((uint32_t)(input[117] & 0xfe) << 7);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 943 to 966
	value = ((uint32_t)(input[117] & 0x01) << 31) |
			((uint32_t)input[118] << 23) |
			((uint32_t)input[119] << 15) |
			((uint32_t)(input[120] & 0xfe) << 7);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 967 to 990
	value = ((uint32_t)(input[120] & 0x01) << 31) |
			((uint32_t)input[121] << 23) |
			((uint32_t)input[122] << 15) |
			((uint32_t)(input[123] & 0xfe) << 7);
	output[40] = (double)(value >> 8);
}

static void unpack_41_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 984 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 847 to 870
	value = ((uint32_t)(input[105] & 0x01) << 31) |
			((uint32_t)input[106] << 23) |
			((uint32_t)input[107] << 15) |
			((uint32_t)(input[108] & 0xfe) << 7);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 871 to 894
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)input[110] << 15) |
			((uint32_t)(input[111] & 0xfe) << 7);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 895 to 918
	value = ((uint32_t)(input[111] & 0x01) << 31) |
			((uint32_t)input[112] << 23) |
			((uint32_t)input[113] << 15) |
			((uint32_t)(input[114] & 0xfe) << 7);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 919 to 942
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)input[116] << 15) |
			((uint32_t)(input[117] & 0xfe) << 7);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 943 to 966
	value = ((uint32_t)(input[117] & 0x01) << 31) |
			((uint32_t)input[118] << 23) |
			((uint32_t)input[119] << 15) |
			((uint32_t)(input[120] & 0xfe) << 7);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 967 to 990
	value = ((uint32_t)(input[120] & 0x01) << 31) |
			((uint32_t)input[121] << 23) |
			((uint32_t)input[122] << 15) |
			((uint32_t)(input[123] & 0xfe) << 7);
	output[40] = (double)(value >> 8);
}

static void unpack_42_24bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit signed
	// Skip 0 bits, read 1008 bits of data.
	// Input must be at least 126 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 840 to 863
	value = ((uint32_t)input[105] << 24) |
			((uint32_t)input[106] << 16) |
			((uint32_t)input[107] << 8);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 864 to 887
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16) |
			((uint32_t)input[110] << 8);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 888 to 911
	value = ((uint32_t)input[111] << 24) |
			((uint32_t)input[112] << 16) |
			((uint32_t)input[113] << 8);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 912 to 935
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16) |
			((uint32_t)input[116] << 8);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 936 to 959
	value = ((uint32_t)input[117] << 24) |
			((uint32_t)input[118] << 16) |
			((uint32_t)input[119] << 8);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 960 to 983
	value = ((uint32_t)input[120] << 24) |
			((uint32_t)input[121] << 16) |
			((uint32_t)input[122] << 8);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 984 to 1007
	value = ((uint32_t)input[123] << 24) |
			((uint32_t)input[124] << 16) |
			((uint32_t)input[125] << 8);
	output[41] = (double)(value >> 8);
}

static void unpack_42_24bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit unsigned
	// Skip 0 bits, read 1008 bits of data.
	// Input must be at least 126 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 23
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)input[2] << 8);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 24 to 47
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)input[5] << 8);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 48 to 71
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)input[8] << 8);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 72 to 95
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)input[11] << 8);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 96 to 119
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16) |
			((uint32_t)input[14] << 8);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 120 to 143
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)input[17] << 8);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 144 to 167
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16) |
			((uint32_t)input[20] << 8);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 168 to 191
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)input[23] << 8);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 192 to 215
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)input[26] << 8);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 216 to 239
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)input[29] << 8);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 240 to 263
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)input[32] << 8);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 264 to 287
	value = ((uint32_t)input[33] << 24) |
			((uint32_t)input[34] << 16) |
			((uint32_t)input[35] << 8);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 288 to 311
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16) |
			((uint32_t)input[38] << 8);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 312 to 335
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)input[41] << 8);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 336 to 359
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)input[44] << 8);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 360 to 383
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)input[47] << 8);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 384 to 407
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)input[50] << 8);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 408 to 431
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)input[53] << 8);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 432 to 455
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)input[56] << 8);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 456 to 479
	value = ((uint32_t)input[57] << 24) |
			((uint32_t)input[58] << 16) |
			((uint32_t)input[59] << 8);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 480 to 503
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)input[62] << 8);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 504 to 527
	value = ((uint32_t)input[63] << 24) |
			((uint32_t)input[64] << 16) |
			((uint32_t)input[65] << 8);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 528 to 551
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16) |
			((uint32_t)input[68] << 8);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 552 to 575
	value = ((uint32_t)input[69] << 24) |
			((uint32_t)input[70] << 16) |
			((uint32_t)input[71] << 8);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 576 to 599
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16) |
			((uint32_t)input[74] << 8);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 600 to 623
	value = ((uint32_t)input[75] << 24) |
			((uint32_t)input[76] << 16) |
			((uint32_t)input[77] << 8);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 624 to 647
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16) |
			((uint32_t)input[80] << 8);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 648 to 671
	value = ((uint32_t)input[81] << 24) |
			((uint32_t)input[82] << 16) |
			((uint32_t)input[83] << 8);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 672 to 695
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16) |
			((uint32_t)input[86] << 8);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 696 to 719
	value = ((uint32_t)input[87] << 24) |
			((uint32_t)input[88] << 16) |
			((uint32_t)input[89] << 8);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 720 to 743
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16) |
			((uint32_t)input[92] << 8);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 744 to 767
	value = ((uint32_t)input[93] << 24) |
			((uint32_t)input[94] << 16) |
			((uint32_t)input[95] << 8);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 768 to 791
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16) |
			((uint32_t)input[98] << 8);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 792 to 815
	value = ((uint32_t)input[99] << 24) |
			((uint32_t)input[100] << 16) |
			((uint32_t)input[101] << 8);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 816 to 839
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16) |
			((uint32_t)input[104] << 8);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 840 to 863
	value = ((uint32_t)input[105] << 24) |
			((uint32_t)input[106] << 16) |
			((uint32_t)input[107] << 8);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 864 to 887
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16) |
			((uint32_t)input[110] << 8);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 888 to 911
	value = ((uint32_t)input[111] << 24) |
			((uint32_t)input[112] << 16) |
			((uint32_t)input[113] << 8);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 912 to 935
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16) |
			((uint32_t)input[116] << 8);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 936 to 959
	value = ((uint32_t)input[117] << 24) |
			((uint32_t)input[118] << 16) |
			((uint32_t)input[119] << 8);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 960 to 983
	value = ((uint32_t)input[120] << 24) |
			((uint32_t)input[121] << 16) |
			((uint32_t)input[122] << 8);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 984 to 1007
	value = ((uint32_t)input[123] << 24) |
			((uint32_t)input[124] << 16) |
			((uint32_t)input[125] << 8);
	output[41] = (double)(value >> 8);
}

static void unpack_42_24bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit signed
	// Skip 1 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 841 to 864
	value = ((uint32_t)(input[105] & 0x7f) << 25) |
			((uint32_t)input[106] << 17) |
			((uint32_t)input[107] << 9) |
			((uint32_t)(input[108] & 0x80) << 1);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 865 to 888
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)input[110] << 9) |
			((uint32_t)(input[111] & 0x80) << 1);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 889 to 912
	value = ((uint32_t)(input[111] & 0x7f) << 25) |
			((uint32_t)input[112] << 17) |
			((uint32_t)input[113] << 9) |
			((uint32_t)(input[114] & 0x80) << 1);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 913 to 936
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)input[116] << 9) |
			((uint32_t)(input[117] & 0x80) << 1);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 937 to 960
	value = ((uint32_t)(input[117] & 0x7f) << 25) |
			((uint32_t)input[118] << 17) |
			((uint32_t)input[119] << 9) |
			((uint32_t)(input[120] & 0x80) << 1);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 961 to 984
	value = ((uint32_t)(input[120] & 0x7f) << 25) |
			((uint32_t)input[121] << 17) |
			((uint32_t)input[122] << 9) |
			((uint32_t)(input[123] & 0x80) << 1);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 985 to 1008
	value = ((uint32_t)(input[123] & 0x7f) << 25) |
			((uint32_t)input[124] << 17) |
			((uint32_t)input[125] << 9) |
			((uint32_t)(input[126] & 0x80) << 1);
	output[41] = (double)(value >> 8);
}

static void unpack_42_24bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit unsigned
	// Skip 1 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 24
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)input[2] << 9) |
			((uint32_t)(input[3] & 0x80) << 1);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 25 to 48
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)input[5] << 9) |
			((uint32_t)(input[6] & 0x80) << 1);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 49 to 72
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)input[8] << 9) |
			((uint32_t)(input[9] & 0x80) << 1);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 73 to 96
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)input[11] << 9) |
			((uint32_t)(input[12] & 0x80) << 1);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 97 to 120
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)input[14] << 9) |
			((uint32_t)(input[15] & 0x80) << 1);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 121 to 144
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)input[17] << 9) |
			((uint32_t)(input[18] & 0x80) << 1);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 145 to 168
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)input[20] << 9) |
			((uint32_t)(input[21] & 0x80) << 1);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 169 to 192
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)input[23] << 9) |
			((uint32_t)(input[24] & 0x80) << 1);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 193 to 216
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)input[26] << 9) |
			((uint32_t)(input[27] & 0x80) << 1);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 217 to 240
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)input[29] << 9) |
			((uint32_t)(input[30] & 0x80) << 1);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 241 to 264
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)input[32] << 9) |
			((uint32_t)(input[33] & 0x80) << 1);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 265 to 288
	value = ((uint32_t)(input[33] & 0x7f) << 25) |
			((uint32_t)input[34] << 17) |
			((uint32_t)input[35] << 9) |
			((uint32_t)(input[36] & 0x80) << 1);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 289 to 312
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)input[38] << 9) |
			((uint32_t)(input[39] & 0x80) << 1);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 313 to 336
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)input[41] << 9) |
			((uint32_t)(input[42] & 0x80) << 1);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 337 to 360
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)input[44] << 9) |
			((uint32_t)(input[45] & 0x80) << 1);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 361 to 384
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)input[47] << 9) |
			((uint32_t)(input[48] & 0x80) << 1);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 385 to 408
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)input[50] << 9) |
			((uint32_t)(input[51] & 0x80) << 1);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 409 to 432
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)input[53] << 9) |
			((uint32_t)(input[54] & 0x80) << 1);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 433 to 456
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)input[56] << 9) |
			((uint32_t)(input[57] & 0x80) << 1);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 457 to 480
	value = ((uint32_t)(input[57] & 0x7f) << 25) |
			((uint32_t)input[58] << 17) |
			((uint32_t)input[59] << 9) |
			((uint32_t)(input[60] & 0x80) << 1);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 481 to 504
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)input[62] << 9) |
			((uint32_t)(input[63] & 0x80) << 1);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 505 to 528
	value = ((uint32_t)(input[63] & 0x7f) << 25) |
			((uint32_t)input[64] << 17) |
			((uint32_t)input[65] << 9) |
			((uint32_t)(input[66] & 0x80) << 1);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 529 to 552
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)input[68] << 9) |
			((uint32_t)(input[69] & 0x80) << 1);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 553 to 576
	value = ((uint32_t)(input[69] & 0x7f) << 25) |
			((uint32_t)input[70] << 17) |
			((uint32_t)input[71] << 9) |
			((uint32_t)(input[72] & 0x80) << 1);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 577 to 600
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)input[74] << 9) |
			((uint32_t)(input[75] & 0x80) << 1);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 601 to 624
	value = ((uint32_t)(input[75] & 0x7f) << 25) |
			((uint32_t)input[76] << 17) |
			((uint32_t)input[77] << 9) |
			((uint32_t)(input[78] & 0x80) << 1);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 625 to 648
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)input[80] << 9) |
			((uint32_t)(input[81] & 0x80) << 1);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 649 to 672
	value = ((uint32_t)(input[81] & 0x7f) << 25) |
			((uint32_t)input[82] << 17) |
			((uint32_t)input[83] << 9) |
			((uint32_t)(input[84] & 0x80) << 1);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 673 to 696
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)input[86] << 9) |
			((uint32_t)(input[87] & 0x80) << 1);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 697 to 720
	value = ((uint32_t)(input[87] & 0x7f) << 25) |
			((uint32_t)input[88] << 17) |
			((uint32_t)input[89] << 9) |
			((uint32_t)(input[90] & 0x80) << 1);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 721 to 744
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)input[92] << 9) |
			((uint32_t)(input[93] & 0x80) << 1);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 745 to 768
	value = ((uint32_t)(input[93] & 0x7f) << 25) |
			((uint32_t)input[94] << 17) |
			((uint32_t)input[95] << 9) |
			((uint32_t)(input[96] & 0x80) << 1);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 769 to 792
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)input[98] << 9) |
			((uint32_t)(input[99] & 0x80) << 1);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 793 to 816
	value = ((uint32_t)(input[99] & 0x7f) << 25) |
			((uint32_t)input[100] << 17) |
			((uint32_t)input[101] << 9) |
			((uint32_t)(input[102] & 0x80) << 1);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 817 to 840
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)input[104] << 9) |
			((uint32_t)(input[105] & 0x80) << 1);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 841 to 864
	value = ((uint32_t)(input[105] & 0x7f) << 25) |
			((uint32_t)input[106] << 17) |
			((uint32_t)input[107] << 9) |
			((uint32_t)(input[108] & 0x80) << 1);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 865 to 888
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)input[110] << 9) |
			((uint32_t)(input[111] & 0x80) << 1);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 889 to 912
	value = ((uint32_t)(input[111] & 0x7f) << 25) |
			((uint32_t)input[112] << 17) |
			((uint32_t)input[113] << 9) |
			((uint32_t)(input[114] & 0x80) << 1);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 913 to 936
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)input[116] << 9) |
			((uint32_t)(input[117] & 0x80) << 1);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 937 to 960
	value = ((uint32_t)(input[117] & 0x7f) << 25) |
			((uint32_t)input[118] << 17) |
			((uint32_t)input[119] << 9) |
			((uint32_t)(input[120] & 0x80) << 1);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 961 to 984
	value = ((uint32_t)(input[120] & 0x7f) << 25) |
			((uint32_t)input[121] << 17) |
			((uint32_t)input[122] << 9) |
			((uint32_t)(input[123] & 0x80) << 1);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 985 to 1008
	value = ((uint32_t)(input[123] & 0x7f) << 25) |
			((uint32_t)input[124] << 17) |
			((uint32_t)input[125] << 9) |
			((uint32_t)(input[126] & 0x80) << 1);
	output[41] = (double)(value >> 8);
}

static void unpack_42_24bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit signed
	// Skip 2 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 842 to 865
	value = ((uint32_t)(input[105] & 0x3f) << 26) |
			((uint32_t)input[106] << 18) |
			((uint32_t)input[107] << 10) |
			((uint32_t)(input[108] & 0xc0) << 2);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 866 to 889
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)input[110] << 10) |
			((uint32_t)(input[111] & 0xc0) << 2);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 890 to 913
	value = ((uint32_t)(input[111] & 0x3f) << 26) |
			((uint32_t)input[112] << 18) |
			((uint32_t)input[113] << 10) |
			((uint32_t)(input[114] & 0xc0) << 2);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 914 to 937
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)input[116] << 10) |
			((uint32_t)(input[117] & 0xc0) << 2);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 938 to 961
	value = ((uint32_t)(input[117] & 0x3f) << 26) |
			((uint32_t)input[118] << 18) |
			((uint32_t)input[119] << 10) |
			((uint32_t)(input[120] & 0xc0) << 2);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 962 to 985
	value = ((uint32_t)(input[120] & 0x3f) << 26) |
			((uint32_t)input[121] << 18) |
			((uint32_t)input[122] << 10) |
			((uint32_t)(input[123] & 0xc0) << 2);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 986 to 1009
	value = ((uint32_t)(input[123] & 0x3f) << 26) |
			((uint32_t)input[124] << 18) |
			((uint32_t)input[125] << 10) |
			((uint32_t)(input[126] & 0xc0) << 2);
	output[41] = (double)(value >> 8);
}

static void unpack_42_24bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit unsigned
	// Skip 2 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 25
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)input[2] << 10) |
			((uint32_t)(input[3] & 0xc0) << 2);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 26 to 49
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)input[5] << 10) |
			((uint32_t)(input[6] & 0xc0) << 2);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 50 to 73
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)input[8] << 10) |
			((uint32_t)(input[9] & 0xc0) << 2);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 74 to 97
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)input[11] << 10) |
			((uint32_t)(input[12] & 0xc0) << 2);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 98 to 121
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)input[14] << 10) |
			((uint32_t)(input[15] & 0xc0) << 2);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 122 to 145
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)input[17] << 10) |
			((uint32_t)(input[18] & 0xc0) << 2);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 146 to 169
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)input[20] << 10) |
			((uint32_t)(input[21] & 0xc0) << 2);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 170 to 193
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)input[23] << 10) |
			((uint32_t)(input[24] & 0xc0) << 2);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 194 to 217
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)input[26] << 10) |
			((uint32_t)(input[27] & 0xc0) << 2);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 218 to 241
	value = ((uint32_t)(input[27] & 0x3f) << 26) |
			((uint32_t)input[28] << 18) |
			((uint32_t)input[29] << 10) |
			((uint32_t)(input[30] & 0xc0) << 2);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 242 to 265
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)input[32] << 10) |
			((uint32_t)(input[33] & 0xc0) << 2);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 266 to 289
	value = ((uint32_t)(input[33] & 0x3f) << 26) |
			((uint32_t)input[34] << 18) |
			((uint32_t)input[35] << 10) |
			((uint32_t)(input[36] & 0xc0) << 2);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 290 to 313
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)input[38] << 10) |
			((uint32_t)(input[39] & 0xc0) << 2);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 314 to 337
	value = ((uint32_t)(input[39] & 0x3f) << 26) |
			((uint32_t)input[40] << 18) |
			((uint32_t)input[41] << 10) |
			((uint32_t)(input[42] & 0xc0) << 2);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 338 to 361
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)input[44] << 10) |
			((uint32_t)(input[45] & 0xc0) << 2);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 362 to 385
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)input[47] << 10) |
			((uint32_t)(input[48] & 0xc0) << 2);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 386 to 409
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)input[50] << 10) |
			((uint32_t)(input[51] & 0xc0) << 2);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 410 to 433
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)input[53] << 10) |
			((uint32_t)(input[54] & 0xc0) << 2);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 434 to 457
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)input[56] << 10) |
			((uint32_t)(input[57] & 0xc0) << 2);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 458 to 481
	value = ((uint32_t)(input[57] & 0x3f) << 26) |
			((uint32_t)input[58] << 18) |
			((uint32_t)input[59] << 10) |
			((uint32_t)(input[60] & 0xc0) << 2);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 482 to 505
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)input[62] << 10) |
			((uint32_t)(input[63] & 0xc0) << 2);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 506 to 529
	value = ((uint32_t)(input[63] & 0x3f) << 26) |
			((uint32_t)input[64] << 18) |
			((uint32_t)input[65] << 10) |
			((uint32_t)(input[66] & 0xc0) << 2);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 530 to 553
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)input[68] << 10) |
			((uint32_t)(input[69] & 0xc0) << 2);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 554 to 577
	value = ((uint32_t)(input[69] & 0x3f) << 26) |
			((uint32_t)input[70] << 18) |
			((uint32_t)input[71] << 10) |
			((uint32_t)(input[72] & 0xc0) << 2);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 578 to 601
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)input[74] << 10) |
			((uint32_t)(input[75] & 0xc0) << 2);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 602 to 625
	value = ((uint32_t)(input[75] & 0x3f) << 26) |
			((uint32_t)input[76] << 18) |
			((uint32_t)input[77] << 10) |
			((uint32_t)(input[78] & 0xc0) << 2);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 626 to 649
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)input[80] << 10) |
			((uint32_t)(input[81] & 0xc0) << 2);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 650 to 673
	value = ((uint32_t)(input[81] & 0x3f) << 26) |
			((uint32_t)input[82] << 18) |
			((uint32_t)input[83] << 10) |
			((uint32_t)(input[84] & 0xc0) << 2);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 674 to 697
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)input[86] << 10) |
			((uint32_t)(input[87] & 0xc0) << 2);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 698 to 721
	value = ((uint32_t)(input[87] & 0x3f) << 26) |
			((uint32_t)input[88] << 18) |
			((uint32_t)input[89] << 10) |
			((uint32_t)(input[90] & 0xc0) << 2);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 722 to 745
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)input[92] << 10) |
			((uint32_t)(input[93] & 0xc0) << 2);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 746 to 769
	value = ((uint32_t)(input[93] & 0x3f) << 26) |
			((uint32_t)input[94] << 18) |
			((uint32_t)input[95] << 10) |
			((uint32_t)(input[96] & 0xc0) << 2);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 770 to 793
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)input[98] << 10) |
			((uint32_t)(input[99] & 0xc0) << 2);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 794 to 817
	value = ((uint32_t)(input[99] & 0x3f) << 26) |
			((uint32_t)input[100] << 18) |
			((uint32_t)input[101] << 10) |
			((uint32_t)(input[102] & 0xc0) << 2);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 818 to 841
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)input[104] << 10) |
			((uint32_t)(input[105] & 0xc0) << 2);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 842 to 865
	value = ((uint32_t)(input[105] & 0x3f) << 26) |
			((uint32_t)input[106] << 18) |
			((uint32_t)input[107] << 10) |
			((uint32_t)(input[108] & 0xc0) << 2);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 866 to 889
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)input[110] << 10) |
			((uint32_t)(input[111] & 0xc0) << 2);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 890 to 913
	value = ((uint32_t)(input[111] & 0x3f) << 26) |
			((uint32_t)input[112] << 18) |
			((uint32_t)input[113] << 10) |
			((uint32_t)(input[114] & 0xc0) << 2);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 914 to 937
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)input[116] << 10) |
			((uint32_t)(input[117] & 0xc0) << 2);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 938 to 961
	value = ((uint32_t)(input[117] & 0x3f) << 26) |
			((uint32_t)input[118] << 18) |
			((uint32_t)input[119] << 10) |
			((uint32_t)(input[120] & 0xc0) << 2);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 962 to 985
	value = ((uint32_t)(input[120] & 0x3f) << 26) |
			((uint32_t)input[121] << 18) |
			((uint32_t)input[122] << 10) |
			((uint32_t)(input[123] & 0xc0) << 2);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 986 to 1009
	value = ((uint32_t)(input[123] & 0x3f) << 26) |
			((uint32_t)input[124] << 18) |
			((uint32_t)input[125] << 10) |
			((uint32_t)(input[126] & 0xc0) << 2);
	output[41] = (double)(value >> 8);
}

static void unpack_42_24bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit signed
	// Skip 3 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 843 to 866
	value = ((uint32_t)(input[105] & 0x1f) << 27) |
			((uint32_t)input[106] << 19) |
			((uint32_t)input[107] << 11) |
			((uint32_t)(input[108] & 0xe0) << 3);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 867 to 890
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)input[110] << 11) |
			((uint32_t)(input[111] & 0xe0) << 3);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 891 to 914
	value = ((uint32_t)(input[111] & 0x1f) << 27) |
			((uint32_t)input[112] << 19) |
			((uint32_t)input[113] << 11) |
			((uint32_t)(input[114] & 0xe0) << 3);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 915 to 938
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)input[116] << 11) |
			((uint32_t)(input[117] & 0xe0) << 3);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 939 to 962
	value = ((uint32_t)(input[117] & 0x1f) << 27) |
			((uint32_t)input[118] << 19) |
			((uint32_t)input[119] << 11) |
			((uint32_t)(input[120] & 0xe0) << 3);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 963 to 986
	value = ((uint32_t)(input[120] & 0x1f) << 27) |
			((uint32_t)input[121] << 19) |
			((uint32_t)input[122] << 11) |
			((uint32_t)(input[123] & 0xe0) << 3);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 987 to 1010
	value = ((uint32_t)(input[123] & 0x1f) << 27) |
			((uint32_t)input[124] << 19) |
			((uint32_t)input[125] << 11) |
			((uint32_t)(input[126] & 0xe0) << 3);
	output[41] = (double)(value >> 8);
}

static void unpack_42_24bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit unsigned
	// Skip 3 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 26
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11) |
			((uint32_t)(input[3] & 0xe0) << 3);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 27 to 50
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11) |
			((uint32_t)(input[6] & 0xe0) << 3);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 51 to 74
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)input[8] << 11) |
			((uint32_t)(input[9] & 0xe0) << 3);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 75 to 98
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)input[11] << 11) |
			((uint32_t)(input[12] & 0xe0) << 3);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 99 to 122
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)input[14] << 11) |
			((uint32_t)(input[15] & 0xe0) << 3);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 123 to 146
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)input[17] << 11) |
			((uint32_t)(input[18] & 0xe0) << 3);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 147 to 170
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11) |
			((uint32_t)(input[21] & 0xe0) << 3);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 171 to 194
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11) |
			((uint32_t)(input[24] & 0xe0) << 3);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 195 to 218
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11) |
			((uint32_t)(input[27] & 0xe0) << 3);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 219 to 242
	value = ((uint32_t)(input[27] & 0x1f) << 27) |
			((uint32_t)input[28] << 19) |
			((uint32_t)input[29] << 11) |
			((uint32_t)(input[30] & 0xe0) << 3);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 243 to 266
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)input[32] << 11) |
			((uint32_t)(input[33] & 0xe0) << 3);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 267 to 290
	value = ((uint32_t)(input[33] & 0x1f) << 27) |
			((uint32_t)input[34] << 19) |
			((uint32_t)input[35] << 11) |
			((uint32_t)(input[36] & 0xe0) << 3);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 291 to 314
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)input[38] << 11) |
			((uint32_t)(input[39] & 0xe0) << 3);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 315 to 338
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11) |
			((uint32_t)(input[42] & 0xe0) << 3);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 339 to 362
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11) |
			((uint32_t)(input[45] & 0xe0) << 3);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 363 to 386
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11) |
			((uint32_t)(input[48] & 0xe0) << 3);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 387 to 410
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)input[50] << 11) |
			((uint32_t)(input[51] & 0xe0) << 3);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 411 to 434
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)input[53] << 11) |
			((uint32_t)(input[54] & 0xe0) << 3);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 435 to 458
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)input[56] << 11) |
			((uint32_t)(input[57] & 0xe0) << 3);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 459 to 482
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)input[59] << 11) |
			((uint32_t)(input[60] & 0xe0) << 3);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 483 to 506
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11) |
			((uint32_t)(input[63] & 0xe0) << 3);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 507 to 530
	value = ((uint32_t)(input[63] & 0x1f) << 27) |
			((uint32_t)input[64] << 19) |
			((uint32_t)input[65] << 11) |
			((uint32_t)(input[66] & 0xe0) << 3);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 531 to 554
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)input[68] << 11) |
			((uint32_t)(input[69] & 0xe0) << 3);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 555 to 578
	value = ((uint32_t)(input[69] & 0x1f) << 27) |
			((uint32_t)input[70] << 19) |
			((uint32_t)input[71] << 11) |
			((uint32_t)(input[72] & 0xe0) << 3);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 579 to 602
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)input[74] << 11) |
			((uint32_t)(input[75] & 0xe0) << 3);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 603 to 626
	value = ((uint32_t)(input[75] & 0x1f) << 27) |
			((uint32_t)input[76] << 19) |
			((uint32_t)input[77] << 11) |
			((uint32_t)(input[78] & 0xe0) << 3);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 627 to 650
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)input[80] << 11) |
			((uint32_t)(input[81] & 0xe0) << 3);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 651 to 674
	value = ((uint32_t)(input[81] & 0x1f) << 27) |
			((uint32_t)input[82] << 19) |
			((uint32_t)input[83] << 11) |
			((uint32_t)(input[84] & 0xe0) << 3);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 675 to 698
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)input[86] << 11) |
			((uint32_t)(input[87] & 0xe0) << 3);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 699 to 722
	value = ((uint32_t)(input[87] & 0x1f) << 27) |
			((uint32_t)input[88] << 19) |
			((uint32_t)input[89] << 11) |
			((uint32_t)(input[90] & 0xe0) << 3);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 723 to 746
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)input[92] << 11) |
			((uint32_t)(input[93] & 0xe0) << 3);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 747 to 770
	value = ((uint32_t)(input[93] & 0x1f) << 27) |
			((uint32_t)input[94] << 19) |
			((uint32_t)input[95] << 11) |
			((uint32_t)(input[96] & 0xe0) << 3);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 771 to 794
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)input[98] << 11) |
			((uint32_t)(input[99] & 0xe0) << 3);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 795 to 818
	value = ((uint32_t)(input[99] & 0x1f) << 27) |
			((uint32_t)input[100] << 19) |
			((uint32_t)input[101] << 11) |
			((uint32_t)(input[102] & 0xe0) << 3);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 819 to 842
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)input[104] << 11) |
			((uint32_t)(input[105] & 0xe0) << 3);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 843 to 866
	value = ((uint32_t)(input[105] & 0x1f) << 27) |
			((uint32_t)input[106] << 19) |
			((uint32_t)input[107] << 11) |
			((uint32_t)(input[108] & 0xe0) << 3);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 867 to 890
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)input[110] << 11) |
			((uint32_t)(input[111] & 0xe0) << 3);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 891 to 914
	value = ((uint32_t)(input[111] & 0x1f) << 27) |
			((uint32_t)input[112] << 19) |
			((uint32_t)input[113] << 11) |
			((uint32_t)(input[114] & 0xe0) << 3);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 915 to 938
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)input[116] << 11) |
			((uint32_t)(input[117] & 0xe0) << 3);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 939 to 962
	value = ((uint32_t)(input[117] & 0x1f) << 27) |
			((uint32_t)input[118] << 19) |
			((uint32_t)input[119] << 11) |
			((uint32_t)(input[120] & 0xe0) << 3);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 963 to 986
	value = ((uint32_t)(input[120] & 0x1f) << 27) |
			((uint32_t)input[121] << 19) |
			((uint32_t)input[122] << 11) |
			((uint32_t)(input[123] & 0xe0) << 3);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 987 to 1010
	value = ((uint32_t)(input[123] & 0x1f) << 27) |
			((uint32_t)input[124] << 19) |
			((uint32_t)input[125] << 11) |
			((uint32_t)(input[126] & 0xe0) << 3);
	output[41] = (double)(value >> 8);
}

static void unpack_42_24bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit signed
	// Skip 4 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 844 to 867
	value = ((uint32_t)(input[105] & 0x0f) << 28) |
			((uint32_t)input[106] << 20) |
			((uint32_t)input[107] << 12) |
			((uint32_t)(input[108] & 0xf0) << 4);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 868 to 891
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)input[110] << 12) |
			((uint32_t)(input[111] & 0xf0) << 4);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 892 to 915
	value = ((uint32_t)(input[111] & 0x0f) << 28) |
			((uint32_t)input[112] << 20) |
			((uint32_t)input[113] << 12) |
			((uint32_t)(input[114] & 0xf0) << 4);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 916 to 939
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)input[116] << 12) |
			((uint32_t)(input[117] & 0xf0) << 4);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 940 to 963
	value = ((uint32_t)(input[117] & 0x0f) << 28) |
			((uint32_t)input[118] << 20) |
			((uint32_t)input[119] << 12) |
			((uint32_t)(input[120] & 0xf0) << 4);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 964 to 987
	value = ((uint32_t)(input[120] & 0x0f) << 28) |
			((uint32_t)input[121] << 20) |
			((uint32_t)input[122] << 12) |
			((uint32_t)(input[123] & 0xf0) << 4);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 988 to 1011
	value = ((uint32_t)(input[123] & 0x0f) << 28) |
			((uint32_t)input[124] << 20) |
			((uint32_t)input[125] << 12) |
			((uint32_t)(input[126] & 0xf0) << 4);
	output[41] = (double)(value >> 8);
}

static void unpack_42_24bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit unsigned
	// Skip 4 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 27
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0xf0) << 4);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 28 to 51
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0xf0) << 4);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 52 to 75
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)input[8] << 12) |
			((uint32_t)(input[9] & 0xf0) << 4);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 76 to 99
	value = ((uint32_t)(input[9] & 0x0f) << 28) |
			((uint32_t)input[10] << 20) |
			((uint32_t)input[11] << 12) |
			((uint32_t)(input[12] & 0xf0) << 4);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 100 to 123
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)input[14] << 12) |
			((uint32_t)(input[15] & 0xf0) << 4);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 124 to 147
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)input[17] << 12) |
			((uint32_t)(input[18] & 0xf0) << 4);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 148 to 171
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0xf0) << 4);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 172 to 195
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0xf0) << 4);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 196 to 219
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0xf0) << 4);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 220 to 243
	value = ((uint32_t)(input[27] & 0x0f) << 28) |
			((uint32_t)input[28] << 20) |
			((uint32_t)input[29] << 12) |
			((uint32_t)(input[30] & 0xf0) << 4);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 244 to 267
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)input[32] << 12) |
			((uint32_t)(input[33] & 0xf0) << 4);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 268 to 291
	value = ((uint32_t)(input[33] & 0x0f) << 28) |
			((uint32_t)input[34] << 20) |
			((uint32_t)input[35] << 12) |
			((uint32_t)(input[36] & 0xf0) << 4);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 292 to 315
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)input[38] << 12) |
			((uint32_t)(input[39] & 0xf0) << 4);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 316 to 339
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0xf0) << 4);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 340 to 363
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0xf0) << 4);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 364 to 387
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0xf0) << 4);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 388 to 411
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)input[50] << 12) |
			((uint32_t)(input[51] & 0xf0) << 4);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 412 to 435
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)input[53] << 12) |
			((uint32_t)(input[54] & 0xf0) << 4);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 436 to 459
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)input[56] << 12) |
			((uint32_t)(input[57] & 0xf0) << 4);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 460 to 483
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)input[59] << 12) |
			((uint32_t)(input[60] & 0xf0) << 4);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 484 to 507
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0xf0) << 4);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 508 to 531
	value = ((uint32_t)(input[63] & 0x0f) << 28) |
			((uint32_t)input[64] << 20) |
			((uint32_t)input[65] << 12) |
			((uint32_t)(input[66] & 0xf0) << 4);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 532 to 555
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)input[68] << 12) |
			((uint32_t)(input[69] & 0xf0) << 4);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 556 to 579
	value = ((uint32_t)(input[69] & 0x0f) << 28) |
			((uint32_t)input[70] << 20) |
			((uint32_t)input[71] << 12) |
			((uint32_t)(input[72] & 0xf0) << 4);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 580 to 603
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)input[74] << 12) |
			((uint32_t)(input[75] & 0xf0) << 4);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 604 to 627
	value = ((uint32_t)(input[75] & 0x0f) << 28) |
			((uint32_t)input[76] << 20) |
			((uint32_t)input[77] << 12) |
			((uint32_t)(input[78] & 0xf0) << 4);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 628 to 651
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)input[80] << 12) |
			((uint32_t)(input[81] & 0xf0) << 4);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 652 to 675
	value = ((uint32_t)(input[81] & 0x0f) << 28) |
			((uint32_t)input[82] << 20) |
			((uint32_t)input[83] << 12) |
			((uint32_t)(input[84] & 0xf0) << 4);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 676 to 699
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)input[86] << 12) |
			((uint32_t)(input[87] & 0xf0) << 4);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 700 to 723
	value = ((uint32_t)(input[87] & 0x0f) << 28) |
			((uint32_t)input[88] << 20) |
			((uint32_t)input[89] << 12) |
			((uint32_t)(input[90] & 0xf0) << 4);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 724 to 747
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)input[92] << 12) |
			((uint32_t)(input[93] & 0xf0) << 4);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 748 to 771
	value = ((uint32_t)(input[93] & 0x0f) << 28) |
			((uint32_t)input[94] << 20) |
			((uint32_t)input[95] << 12) |
			((uint32_t)(input[96] & 0xf0) << 4);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 772 to 795
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)input[98] << 12) |
			((uint32_t)(input[99] & 0xf0) << 4);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 796 to 819
	value = ((uint32_t)(input[99] & 0x0f) << 28) |
			((uint32_t)input[100] << 20) |
			((uint32_t)input[101] << 12) |
			((uint32_t)(input[102] & 0xf0) << 4);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 820 to 843
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)input[104] << 12) |
			((uint32_t)(input[105] & 0xf0) << 4);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 844 to 867
	value = ((uint32_t)(input[105] & 0x0f) << 28) |
			((uint32_t)input[106] << 20) |
			((uint32_t)input[107] << 12) |
			((uint32_t)(input[108] & 0xf0) << 4);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 868 to 891
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)input[110] << 12) |
			((uint32_t)(input[111] & 0xf0) << 4);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 892 to 915
	value = ((uint32_t)(input[111] & 0x0f) << 28) |
			((uint32_t)input[112] << 20) |
			((uint32_t)input[113] << 12) |
			((uint32_t)(input[114] & 0xf0) << 4);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 916 to 939
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)input[116] << 12) |
			((uint32_t)(input[117] & 0xf0) << 4);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 940 to 963
	value = ((uint32_t)(input[117] & 0x0f) << 28) |
			((uint32_t)input[118] << 20) |
			((uint32_t)input[119] << 12) |
			((uint32_t)(input[120] & 0xf0) << 4);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 964 to 987
	value = ((uint32_t)(input[120] & 0x0f) << 28) |
			((uint32_t)input[121] << 20) |
			((uint32_t)input[122] << 12) |
			((uint32_t)(input[123] & 0xf0) << 4);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 988 to 1011
	value = ((uint32_t)(input[123] & 0x0f) << 28) |
			((uint32_t)input[124] << 20) |
			((uint32_t)input[125] << 12) |
			((uint32_t)(input[126] & 0xf0) << 4);
	output[41] = (double)(value >> 8);
}

static void unpack_42_24bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit signed
	// Skip 5 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 845 to 868
	value = ((uint32_t)(input[105] & 0x07) << 29) |
			((uint32_t)input[106] << 21) |
			((uint32_t)input[107] << 13) |
			((uint32_t)(input[108] & 0xf8) << 5);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 869 to 892
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)input[110] << 13) |
			((uint32_t)(input[111] & 0xf8) << 5);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 893 to 916
	value = ((uint32_t)(input[111] & 0x07) << 29) |
			((uint32_t)input[112] << 21) |
			((uint32_t)input[113] << 13) |
			((uint32_t)(input[114] & 0xf8) << 5);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 917 to 940
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)input[116] << 13) |
			((uint32_t)(input[117] & 0xf8) << 5);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 941 to 964
	value = ((uint32_t)(input[117] & 0x07) << 29) |
			((uint32_t)input[118] << 21) |
			((uint32_t)input[119] << 13) |
			((uint32_t)(input[120] & 0xf8) << 5);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 965 to 988
	value = ((uint32_t)(input[120] & 0x07) << 29) |
			((uint32_t)input[121] << 21) |
			((uint32_t)input[122] << 13) |
			((uint32_t)(input[123] & 0xf8) << 5);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 989 to 1012
	value = ((uint32_t)(input[123] & 0x07) << 29) |
			((uint32_t)input[124] << 21) |
			((uint32_t)input[125] << 13) |
			((uint32_t)(input[126] & 0xf8) << 5);
	output[41] = (double)(value >> 8);
}

static void unpack_42_24bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit unsigned
	// Skip 5 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 28
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xf8) << 5);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 29 to 52
	value = ((uint32_t)(input[3] & 0x07) << 29) |
			((uint32_t)input[4] << 21) |
			((uint32_t)input[5] << 13) |
			((uint32_t)(input[6] & 0xf8) << 5);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 53 to 76
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)input[8] << 13) |
			((uint32_t)(input[9] & 0xf8) << 5);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 77 to 100
	value = ((uint32_t)(input[9] & 0x07) << 29) |
			((uint32_t)input[10] << 21) |
			((uint32_t)input[11] << 13) |
			((uint32_t)(input[12] & 0xf8) << 5);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 101 to 124
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)input[14] << 13) |
			((uint32_t)(input[15] & 0xf8) << 5);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 125 to 148
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)input[17] << 13) |
			((uint32_t)(input[18] & 0xf8) << 5);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 149 to 172
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xf8) << 5);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 173 to 196
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xf8) << 5);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 197 to 220
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)input[26] << 13) |
			((uint32_t)(input[27] & 0xf8) << 5);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 221 to 244
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)input[29] << 13) |
			((uint32_t)(input[30] & 0xf8) << 5);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 245 to 268
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)input[32] << 13) |
			((uint32_t)(input[33] & 0xf8) << 5);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 269 to 292
	value = ((uint32_t)(input[33] & 0x07) << 29) |
			((uint32_t)input[34] << 21) |
			((uint32_t)input[35] << 13) |
			((uint32_t)(input[36] & 0xf8) << 5);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 293 to 316
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)input[38] << 13) |
			((uint32_t)(input[39] & 0xf8) << 5);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 317 to 340
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xf8) << 5);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 341 to 364
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xf8) << 5);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 365 to 388
	value = ((uint32_t)(input[45] & 0x07) << 29) |
			((uint32_t)input[46] << 21) |
			((uint32_t)input[47] << 13) |
			((uint32_t)(input[48] & 0xf8) << 5);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 389 to 412
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)input[50] << 13) |
			((uint32_t)(input[51] & 0xf8) << 5);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 413 to 436
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)input[53] << 13) |
			((uint32_t)(input[54] & 0xf8) << 5);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 437 to 460
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)input[56] << 13) |
			((uint32_t)(input[57] & 0xf8) << 5);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 461 to 484
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)input[59] << 13) |
			((uint32_t)(input[60] & 0xf8) << 5);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 485 to 508
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xf8) << 5);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 509 to 532
	value = ((uint32_t)(input[63] & 0x07) << 29) |
			((uint32_t)input[64] << 21) |
			((uint32_t)input[65] << 13) |
			((uint32_t)(input[66] & 0xf8) << 5);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 533 to 556
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)input[68] << 13) |
			((uint32_t)(input[69] & 0xf8) << 5);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 557 to 580
	value = ((uint32_t)(input[69] & 0x07) << 29) |
			((uint32_t)input[70] << 21) |
			((uint32_t)input[71] << 13) |
			((uint32_t)(input[72] & 0xf8) << 5);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 581 to 604
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)input[74] << 13) |
			((uint32_t)(input[75] & 0xf8) << 5);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 605 to 628
	value = ((uint32_t)(input[75] & 0x07) << 29) |
			((uint32_t)input[76] << 21) |
			((uint32_t)input[77] << 13) |
			((uint32_t)(input[78] & 0xf8) << 5);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 629 to 652
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)input[80] << 13) |
			((uint32_t)(input[81] & 0xf8) << 5);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 653 to 676
	value = ((uint32_t)(input[81] & 0x07) << 29) |
			((uint32_t)input[82] << 21) |
			((uint32_t)input[83] << 13) |
			((uint32_t)(input[84] & 0xf8) << 5);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 677 to 700
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)input[86] << 13) |
			((uint32_t)(input[87] & 0xf8) << 5);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 701 to 724
	value = ((uint32_t)(input[87] & 0x07) << 29) |
			((uint32_t)input[88] << 21) |
			((uint32_t)input[89] << 13) |
			((uint32_t)(input[90] & 0xf8) << 5);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 725 to 748
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)input[92] << 13) |
			((uint32_t)(input[93] & 0xf8) << 5);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 749 to 772
	value = ((uint32_t)(input[93] & 0x07) << 29) |
			((uint32_t)input[94] << 21) |
			((uint32_t)input[95] << 13) |
			((uint32_t)(input[96] & 0xf8) << 5);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 773 to 796
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)input[98] << 13) |
			((uint32_t)(input[99] & 0xf8) << 5);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 797 to 820
	value = ((uint32_t)(input[99] & 0x07) << 29) |
			((uint32_t)input[100] << 21) |
			((uint32_t)input[101] << 13) |
			((uint32_t)(input[102] & 0xf8) << 5);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 821 to 844
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)input[104] << 13) |
			((uint32_t)(input[105] & 0xf8) << 5);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 845 to 868
	value = ((uint32_t)(input[105] & 0x07) << 29) |
			((uint32_t)input[106] << 21) |
			((uint32_t)input[107] << 13) |
			((uint32_t)(input[108] & 0xf8) << 5);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 869 to 892
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)input[110] << 13) |
			((uint32_t)(input[111] & 0xf8) << 5);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 893 to 916
	value = ((uint32_t)(input[111] & 0x07) << 29) |
			((uint32_t)input[112] << 21) |
			((uint32_t)input[113] << 13) |
			((uint32_t)(input[114] & 0xf8) << 5);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 917 to 940
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)input[116] << 13) |
			((uint32_t)(input[117] & 0xf8) << 5);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 941 to 964
	value = ((uint32_t)(input[117] & 0x07) << 29) |
			((uint32_t)input[118] << 21) |
			((uint32_t)input[119] << 13) |
			((uint32_t)(input[120] & 0xf8) << 5);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 965 to 988
	value = ((uint32_t)(input[120] & 0x07) << 29) |
			((uint32_t)input[121] << 21) |
			((uint32_t)input[122] << 13) |
			((uint32_t)(input[123] & 0xf8) << 5);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 989 to 1012
	value = ((uint32_t)(input[123] & 0x07) << 29) |
			((uint32_t)input[124] << 21) |
			((uint32_t)input[125] << 13) |
			((uint32_t)(input[126] & 0xf8) << 5);
	output[41] = (double)(value >> 8);
}

static void unpack_42_24bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit signed
	// Skip 6 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 846 to 869
	value = ((uint32_t)(input[105] & 0x03) << 30) |
			((uint32_t)input[106] << 22) |
			((uint32_t)input[107] << 14) |
			((uint32_t)(input[108] & 0xfc) << 6);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 870 to 893
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)input[110] << 14) |
			((uint32_t)(input[111] & 0xfc) << 6);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 894 to 917
	value = ((uint32_t)(input[111] & 0x03) << 30) |
			((uint32_t)input[112] << 22) |
			((uint32_t)input[113] << 14) |
			((uint32_t)(input[114] & 0xfc) << 6);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 918 to 941
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)input[116] << 14) |
			((uint32_t)(input[117] & 0xfc) << 6);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 942 to 965
	value = ((uint32_t)(input[117] & 0x03) << 30) |
			((uint32_t)input[118] << 22) |
			((uint32_t)input[119] << 14) |
			((uint32_t)(input[120] & 0xfc) << 6);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 966 to 989
	value = ((uint32_t)(input[120] & 0x03) << 30) |
			((uint32_t)input[121] << 22) |
			((uint32_t)input[122] << 14) |
			((uint32_t)(input[123] & 0xfc) << 6);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 990 to 1013
	value = ((uint32_t)(input[123] & 0x03) << 30) |
			((uint32_t)input[124] << 22) |
			((uint32_t)input[125] << 14) |
			((uint32_t)(input[126] & 0xfc) << 6);
	output[41] = (double)(value >> 8);
}

static void unpack_42_24bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit unsigned
	// Skip 6 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 29
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xfc) << 6);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 30 to 53
	value = ((uint32_t)(input[3] & 0x03) << 30) |
			((uint32_t)input[4] << 22) |
			((uint32_t)input[5] << 14) |
			((uint32_t)(input[6] & 0xfc) << 6);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 54 to 77
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)input[8] << 14) |
			((uint32_t)(input[9] & 0xfc) << 6);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 78 to 101
	value = ((uint32_t)(input[9] & 0x03) << 30) |
			((uint32_t)input[10] << 22) |
			((uint32_t)input[11] << 14) |
			((uint32_t)(input[12] & 0xfc) << 6);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 102 to 125
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)input[14] << 14) |
			((uint32_t)(input[15] & 0xfc) << 6);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 126 to 149
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xfc) << 6);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 150 to 173
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xfc) << 6);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 174 to 197
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xfc) << 6);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 198 to 221
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)input[26] << 14) |
			((uint32_t)(input[27] & 0xfc) << 6);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 222 to 245
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)input[29] << 14) |
			((uint32_t)(input[30] & 0xfc) << 6);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 246 to 269
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)input[32] << 14) |
			((uint32_t)(input[33] & 0xfc) << 6);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 270 to 293
	value = ((uint32_t)(input[33] & 0x03) << 30) |
			((uint32_t)input[34] << 22) |
			((uint32_t)input[35] << 14) |
			((uint32_t)(input[36] & 0xfc) << 6);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 294 to 317
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xfc) << 6);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 318 to 341
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xfc) << 6);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 342 to 365
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xfc) << 6);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 366 to 389
	value = ((uint32_t)(input[45] & 0x03) << 30) |
			((uint32_t)input[46] << 22) |
			((uint32_t)input[47] << 14) |
			((uint32_t)(input[48] & 0xfc) << 6);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 390 to 413
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)input[50] << 14) |
			((uint32_t)(input[51] & 0xfc) << 6);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 414 to 437
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)input[53] << 14) |
			((uint32_t)(input[54] & 0xfc) << 6);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 438 to 461
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)input[56] << 14) |
			((uint32_t)(input[57] & 0xfc) << 6);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 462 to 485
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xfc) << 6);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 486 to 509
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xfc) << 6);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 510 to 533
	value = ((uint32_t)(input[63] & 0x03) << 30) |
			((uint32_t)input[64] << 22) |
			((uint32_t)input[65] << 14) |
			((uint32_t)(input[66] & 0xfc) << 6);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 534 to 557
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)input[68] << 14) |
			((uint32_t)(input[69] & 0xfc) << 6);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 558 to 581
	value = ((uint32_t)(input[69] & 0x03) << 30) |
			((uint32_t)input[70] << 22) |
			((uint32_t)input[71] << 14) |
			((uint32_t)(input[72] & 0xfc) << 6);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 582 to 605
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)input[74] << 14) |
			((uint32_t)(input[75] & 0xfc) << 6);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 606 to 629
	value = ((uint32_t)(input[75] & 0x03) << 30) |
			((uint32_t)input[76] << 22) |
			((uint32_t)input[77] << 14) |
			((uint32_t)(input[78] & 0xfc) << 6);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 630 to 653
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)input[80] << 14) |
			((uint32_t)(input[81] & 0xfc) << 6);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 654 to 677
	value = ((uint32_t)(input[81] & 0x03) << 30) |
			((uint32_t)input[82] << 22) |
			((uint32_t)input[83] << 14) |
			((uint32_t)(input[84] & 0xfc) << 6);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 678 to 701
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)input[86] << 14) |
			((uint32_t)(input[87] & 0xfc) << 6);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 702 to 725
	value = ((uint32_t)(input[87] & 0x03) << 30) |
			((uint32_t)input[88] << 22) |
			((uint32_t)input[89] << 14) |
			((uint32_t)(input[90] & 0xfc) << 6);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 726 to 749
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)input[92] << 14) |
			((uint32_t)(input[93] & 0xfc) << 6);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 750 to 773
	value = ((uint32_t)(input[93] & 0x03) << 30) |
			((uint32_t)input[94] << 22) |
			((uint32_t)input[95] << 14) |
			((uint32_t)(input[96] & 0xfc) << 6);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 774 to 797
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)input[98] << 14) |
			((uint32_t)(input[99] & 0xfc) << 6);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 798 to 821
	value = ((uint32_t)(input[99] & 0x03) << 30) |
			((uint32_t)input[100] << 22) |
			((uint32_t)input[101] << 14) |
			((uint32_t)(input[102] & 0xfc) << 6);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 822 to 845
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)input[104] << 14) |
			((uint32_t)(input[105] & 0xfc) << 6);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 846 to 869
	value = ((uint32_t)(input[105] & 0x03) << 30) |
			((uint32_t)input[106] << 22) |
			((uint32_t)input[107] << 14) |
			((uint32_t)(input[108] & 0xfc) << 6);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 870 to 893
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)input[110] << 14) |
			((uint32_t)(input[111] & 0xfc) << 6);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 894 to 917
	value = ((uint32_t)(input[111] & 0x03) << 30) |
			((uint32_t)input[112] << 22) |
			((uint32_t)input[113] << 14) |
			((uint32_t)(input[114] & 0xfc) << 6);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 918 to 941
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)input[116] << 14) |
			((uint32_t)(input[117] & 0xfc) << 6);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 942 to 965
	value = ((uint32_t)(input[117] & 0x03) << 30) |
			((uint32_t)input[118] << 22) |
			((uint32_t)input[119] << 14) |
			((uint32_t)(input[120] & 0xfc) << 6);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 966 to 989
	value = ((uint32_t)(input[120] & 0x03) << 30) |
			((uint32_t)input[121] << 22) |
			((uint32_t)input[122] << 14) |
			((uint32_t)(input[123] & 0xfc) << 6);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 990 to 1013
	value = ((uint32_t)(input[123] & 0x03) << 30) |
			((uint32_t)input[124] << 22) |
			((uint32_t)input[125] << 14) |
			((uint32_t)(input[126] & 0xfc) << 6);
	output[41] = (double)(value >> 8);
}

static void unpack_42_24bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit signed
	// Skip 7 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 847 to 870
	value = ((uint32_t)(input[105] & 0x01) << 31) |
			((uint32_t)input[106] << 23) |
			((uint32_t)input[107] << 15) |
			((uint32_t)(input[108] & 0xfe) << 7);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 871 to 894
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)input[110] << 15) |
			((uint32_t)(input[111] & 0xfe) << 7);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 895 to 918
	value = ((uint32_t)(input[111] & 0x01) << 31) |
			((uint32_t)input[112] << 23) |
			((uint32_t)input[113] << 15) |
			((uint32_t)(input[114] & 0xfe) << 7);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 919 to 942
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)input[116] << 15) |
			((uint32_t)(input[117] & 0xfe) << 7);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 943 to 966
	value = ((uint32_t)(input[117] & 0x01) << 31) |
			((uint32_t)input[118] << 23) |
			((uint32_t)input[119] << 15) |
			((uint32_t)(input[120] & 0xfe) << 7);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 967 to 990
	value = ((uint32_t)(input[120] & 0x01) << 31) |
			((uint32_t)input[121] << 23) |
			((uint32_t)input[122] << 15) |
			((uint32_t)(input[123] & 0xfe) << 7);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 991 to 1014
	value = ((uint32_t)(input[123] & 0x01) << 31) |
			((uint32_t)input[124] << 23) |
			((uint32_t)input[125] << 15) |
			((uint32_t)(input[126] & 0xfe) << 7);
	output[41] = (double)(value >> 8);
}

static void unpack_42_24bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 24-bit unsigned
	// Skip 7 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 30
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xfe) << 7);
	output[0] = (double)(value >> 8);

	// read output[1]: from bit 31 to 54
	value = ((uint32_t)(input[3] & 0x01) << 31) |
			((uint32_t)input[4] << 23) |
			((uint32_t)input[5] << 15) |
			((uint32_t)(input[6] & 0xfe) << 7);
	output[1] = (double)(value >> 8);

	// read output[2]: from bit 55 to 78
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15) |
			((uint32_t)(input[9] & 0xfe) << 7);
	output[2] = (double)(value >> 8);

	// read output[3]: from bit 79 to 102
	value = ((uint32_t)(input[9] & 0x01) << 31) |
			((uint32_t)input[10] << 23) |
			((uint32_t)input[11] << 15) |
			((uint32_t)(input[12] & 0xfe) << 7);
	output[3] = (double)(value >> 8);

	// read output[4]: from bit 103 to 126
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15) |
			((uint32_t)(input[15] & 0xfe) << 7);
	output[4] = (double)(value >> 8);

	// read output[5]: from bit 127 to 150
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xfe) << 7);
	output[5] = (double)(value >> 8);

	// read output[6]: from bit 151 to 174
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xfe) << 7);
	output[6] = (double)(value >> 8);

	// read output[7]: from bit 175 to 198
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xfe) << 7);
	output[7] = (double)(value >> 8);

	// read output[8]: from bit 199 to 222
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)input[26] << 15) |
			((uint32_t)(input[27] & 0xfe) << 7);
	output[8] = (double)(value >> 8);

	// read output[9]: from bit 223 to 246
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15) |
			((uint32_t)(input[30] & 0xfe) << 7);
	output[9] = (double)(value >> 8);

	// read output[10]: from bit 247 to 270
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)input[32] << 15) |
			((uint32_t)(input[33] & 0xfe) << 7);
	output[10] = (double)(value >> 8);

	// read output[11]: from bit 271 to 294
	value = ((uint32_t)(input[33] & 0x01) << 31) |
			((uint32_t)input[34] << 23) |
			((uint32_t)input[35] << 15) |
			((uint32_t)(input[36] & 0xfe) << 7);
	output[11] = (double)(value >> 8);

	// read output[12]: from bit 295 to 318
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xfe) << 7);
	output[12] = (double)(value >> 8);

	// read output[13]: from bit 319 to 342
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xfe) << 7);
	output[13] = (double)(value >> 8);

	// read output[14]: from bit 343 to 366
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xfe) << 7);
	output[14] = (double)(value >> 8);

	// read output[15]: from bit 367 to 390
	value = ((uint32_t)(input[45] & 0x01) << 31) |
			((uint32_t)input[46] << 23) |
			((uint32_t)input[47] << 15) |
			((uint32_t)(input[48] & 0xfe) << 7);
	output[15] = (double)(value >> 8);

	// read output[16]: from bit 391 to 414
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15) |
			((uint32_t)(input[51] & 0xfe) << 7);
	output[16] = (double)(value >> 8);

	// read output[17]: from bit 415 to 438
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15) |
			((uint32_t)(input[54] & 0xfe) << 7);
	output[17] = (double)(value >> 8);

	// read output[18]: from bit 439 to 462
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)input[56] << 15) |
			((uint32_t)(input[57] & 0xfe) << 7);
	output[18] = (double)(value >> 8);

	// read output[19]: from bit 463 to 486
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xfe) << 7);
	output[19] = (double)(value >> 8);

	// read output[20]: from bit 487 to 510
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xfe) << 7);
	output[20] = (double)(value >> 8);

	// read output[21]: from bit 511 to 534
	value = ((uint32_t)(input[63] & 0x01) << 31) |
			((uint32_t)input[64] << 23) |
			((uint32_t)input[65] << 15) |
			((uint32_t)(input[66] & 0xfe) << 7);
	output[21] = (double)(value >> 8);

	// read output[22]: from bit 535 to 558
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)input[68] << 15) |
			((uint32_t)(input[69] & 0xfe) << 7);
	output[22] = (double)(value >> 8);

	// read output[23]: from bit 559 to 582
	value = ((uint32_t)(input[69] & 0x01) << 31) |
			((uint32_t)input[70] << 23) |
			((uint32_t)input[71] << 15) |
			((uint32_t)(input[72] & 0xfe) << 7);
	output[23] = (double)(value >> 8);

	// read output[24]: from bit 583 to 606
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)input[74] << 15) |
			((uint32_t)(input[75] & 0xfe) << 7);
	output[24] = (double)(value >> 8);

	// read output[25]: from bit 607 to 630
	value = ((uint32_t)(input[75] & 0x01) << 31) |
			((uint32_t)input[76] << 23) |
			((uint32_t)input[77] << 15) |
			((uint32_t)(input[78] & 0xfe) << 7);
	output[25] = (double)(value >> 8);

	// read output[26]: from bit 631 to 654
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)input[80] << 15) |
			((uint32_t)(input[81] & 0xfe) << 7);
	output[26] = (double)(value >> 8);

	// read output[27]: from bit 655 to 678
	value = ((uint32_t)(input[81] & 0x01) << 31) |
			((uint32_t)input[82] << 23) |
			((uint32_t)input[83] << 15) |
			((uint32_t)(input[84] & 0xfe) << 7);
	output[27] = (double)(value >> 8);

	// read output[28]: from bit 679 to 702
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)input[86] << 15) |
			((uint32_t)(input[87] & 0xfe) << 7);
	output[28] = (double)(value >> 8);

	// read output[29]: from bit 703 to 726
	value = ((uint32_t)(input[87] & 0x01) << 31) |
			((uint32_t)input[88] << 23) |
			((uint32_t)input[89] << 15) |
			((uint32_t)(input[90] & 0xfe) << 7);
	output[29] = (double)(value >> 8);

	// read output[30]: from bit 727 to 750
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)input[92] << 15) |
			((uint32_t)(input[93] & 0xfe) << 7);
	output[30] = (double)(value >> 8);

	// read output[31]: from bit 751 to 774
	value = ((uint32_t)(input[93] & 0x01) << 31) |
			((uint32_t)input[94] << 23) |
			((uint32_t)input[95] << 15) |
			((uint32_t)(input[96] & 0xfe) << 7);
	output[31] = (double)(value >> 8);

	// read output[32]: from bit 775 to 798
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)input[98] << 15) |
			((uint32_t)(input[99] & 0xfe) << 7);
	output[32] = (double)(value >> 8);

	// read output[33]: from bit 799 to 822
	value = ((uint32_t)(input[99] & 0x01) << 31) |
			((uint32_t)input[100] << 23) |
			((uint32_t)input[101] << 15) |
			((uint32_t)(input[102] & 0xfe) << 7);
	output[33] = (double)(value >> 8);

	// read output[34]: from bit 823 to 846
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)input[104] << 15) |
			((uint32_t)(input[105] & 0xfe) << 7);
	output[34] = (double)(value >> 8);

	// read output[35]: from bit 847 to 870
	value = ((uint32_t)(input[105] & 0x01) << 31) |
			((uint32_t)input[106] << 23) |
			((uint32_t)input[107] << 15) |
			((uint32_t)(input[108] & 0xfe) << 7);
	output[35] = (double)(value >> 8);

	// read output[36]: from bit 871 to 894
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)input[110] << 15) |
			((uint32_t)(input[111] & 0xfe) << 7);
	output[36] = (double)(value >> 8);

	// read output[37]: from bit 895 to 918
	value = ((uint32_t)(input[111] & 0x01) << 31) |
			((uint32_t)input[112] << 23) |
			((uint32_t)input[113] << 15) |
			((uint32_t)(input[114] & 0xfe) << 7);
	output[37] = (double)(value >> 8);

	// read output[38]: from bit 919 to 942
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)input[116] << 15) |
			((uint32_t)(input[117] & 0xfe) << 7);
	output[38] = (double)(value >> 8);

	// read output[39]: from bit 943 to 966
	value = ((uint32_t)(input[117] & 0x01) << 31) |
			((uint32_t)input[118] << 23) |
			((uint32_t)input[119] << 15) |
			((uint32_t)(input[120] & 0xfe) << 7);
	output[39] = (double)(value >> 8);

	// read output[40]: from bit 967 to 990
	value = ((uint32_t)(input[120] & 0x01) << 31) |
			((uint32_t)input[121] << 23) |
			((uint32_t)input[122] << 15) |
			((uint32_t)(input[123] & 0xfe) << 7);
	output[40] = (double)(value >> 8);

	// read output[41]: from bit 991 to 1014
	value = ((uint32_t)(input[123] & 0x01) << 31) |
			((uint32_t)input[124] << 23) |
			((uint32_t)input[125] << 15) |
			((uint32_t)(input[126] & 0xfe) << 7);
	output[41] = (double)(value >> 8);
}


unpack_func_t unpack_24bit[UNPACK_24BIT_MAX_COUNT][8][2] = {
	{
		{
			unpack_1_24bit_unsigned_0off,
			unpack_1_24bit_signed_0off,
		},
		{
			unpack_1_24bit_unsigned_1off,
			unpack_1_24bit_signed_1off,
		},
		{
			unpack_1_24bit_unsigned_2off,
			unpack_1_24bit_signed_2off,
		},
		{
			unpack_1_24bit_unsigned_3off,
			unpack_1_24bit_signed_3off,
		},
		{
			unpack_1_24bit_unsigned_4off,
			unpack_1_24bit_signed_4off,
		},
		{
			unpack_1_24bit_unsigned_5off,
			unpack_1_24bit_signed_5off,
		},
		{
			unpack_1_24bit_unsigned_6off,
			unpack_1_24bit_signed_6off,
		},
		{
			unpack_1_24bit_unsigned_7off,
			unpack_1_24bit_signed_7off,
		},
	},
	{
		{
			unpack_2_24bit_unsigned_0off,
			unpack_2_24bit_signed_0off,
		},
		{
			unpack_2_24bit_unsigned_1off,
			unpack_2_24bit_signed_1off,
		},
		{
			unpack_2_24bit_unsigned_2off,
			unpack_2_24bit_signed_2off,
		},
		{
			unpack_2_24bit_unsigned_3off,
			unpack_2_24bit_signed_3off,
		},
		{
			unpack_2_24bit_unsigned_4off,
			unpack_2_24bit_signed_4off,
		},
		{
			unpack_2_24bit_unsigned_5off,
			unpack_2_24bit_signed_5off,
		},
		{
			unpack_2_24bit_unsigned_6off,
			unpack_2_24bit_signed_6off,
		},
		{
			unpack_2_24bit_unsigned_7off,
			unpack_2_24bit_signed_7off,
		},
	},
	{
		{
			unpack_3_24bit_unsigned_0off,
			unpack_3_24bit_signed_0off,
		},
		{
			unpack_3_24bit_unsigned_1off,
			unpack_3_24bit_signed_1off,
		},
		{
			unpack_3_24bit_unsigned_2off,
			unpack_3_24bit_signed_2off,
		},
		{
			unpack_3_24bit_unsigned_3off,
			unpack_3_24bit_signed_3off,
		},
		{
			unpack_3_24bit_unsigned_4off,
			unpack_3_24bit_signed_4off,
		},
		{
			unpack_3_24bit_unsigned_5off,
			unpack_3_24bit_signed_5off,
		},
		{
			unpack_3_24bit_unsigned_6off,
			unpack_3_24bit_signed_6off,
		},
		{
			unpack_3_24bit_unsigned_7off,
			unpack_3_24bit_signed_7off,
		},
	},
	{
		{
			unpack_4_24bit_unsigned_0off,
			unpack_4_24bit_signed_0off,
		},
		{
			unpack_4_24bit_unsigned_1off,
			unpack_4_24bit_signed_1off,
		},
		{
			unpack_4_24bit_unsigned_2off,
			unpack_4_24bit_signed_2off,
		},
		{
			unpack_4_24bit_unsigned_3off,
			unpack_4_24bit_signed_3off,
		},
		{
			unpack_4_24bit_unsigned_4off,
			unpack_4_24bit_signed_4off,
		},
		{
			unpack_4_24bit_unsigned_5off,
			unpack_4_24bit_signed_5off,
		},
		{
			unpack_4_24bit_unsigned_6off,
			unpack_4_24bit_signed_6off,
		},
		{
			unpack_4_24bit_unsigned_7off,
			unpack_4_24bit_signed_7off,
		},
	},
	{
		{
			unpack_5_24bit_unsigned_0off,
			unpack_5_24bit_signed_0off,
		},
		{
			unpack_5_24bit_unsigned_1off,
			unpack_5_24bit_signed_1off,
		},
		{
			unpack_5_24bit_unsigned_2off,
			unpack_5_24bit_signed_2off,
		},
		{
			unpack_5_24bit_unsigned_3off,
			unpack_5_24bit_signed_3off,
		},
		{
			unpack_5_24bit_unsigned_4off,
			unpack_5_24bit_signed_4off,
		},
		{
			unpack_5_24bit_unsigned_5off,
			unpack_5_24bit_signed_5off,
		},
		{
			unpack_5_24bit_unsigned_6off,
			unpack_5_24bit_signed_6off,
		},
		{
			unpack_5_24bit_unsigned_7off,
			unpack_5_24bit_signed_7off,
		},
	},
	{
		{
			unpack_6_24bit_unsigned_0off,
			unpack_6_24bit_signed_0off,
		},
		{
			unpack_6_24bit_unsigned_1off,
			unpack_6_24bit_signed_1off,
		},
		{
			unpack_6_24bit_unsigned_2off,
			unpack_6_24bit_signed_2off,
		},
		{
			unpack_6_24bit_unsigned_3off,
			unpack_6_24bit_signed_3off,
		},
		{
			unpack_6_24bit_unsigned_4off,
			unpack_6_24bit_signed_4off,
		},
		{
			unpack_6_24bit_unsigned_5off,
			unpack_6_24bit_signed_5off,
		},
		{
			unpack_6_24bit_unsigned_6off,
			unpack_6_24bit_signed_6off,
		},
		{
			unpack_6_24bit_unsigned_7off,
			unpack_6_24bit_signed_7off,
		},
	},
	{
		{
			unpack_7_24bit_unsigned_0off,
			unpack_7_24bit_signed_0off,
		},
		{
			unpack_7_24bit_unsigned_1off,
			unpack_7_24bit_signed_1off,
		},
		{
			unpack_7_24bit_unsigned_2off,
			unpack_7_24bit_signed_2off,
		},
		{
			unpack_7_24bit_unsigned_3off,
			unpack_7_24bit_signed_3off,
		},
		{
			unpack_7_24bit_unsigned_4off,
			unpack_7_24bit_signed_4off,
		},
		{
			unpack_7_24bit_unsigned_5off,
			unpack_7_24bit_signed_5off,
		},
		{
			unpack_7_24bit_unsigned_6off,
			unpack_7_24bit_signed_6off,
		},
		{
			unpack_7_24bit_unsigned_7off,
			unpack_7_24bit_signed_7off,
		},
	},
	{
		{
			unpack_8_24bit_unsigned_0off,
			unpack_8_24bit_signed_0off,
		},
		{
			unpack_8_24bit_unsigned_1off,
			unpack_8_24bit_signed_1off,
		},
		{
			unpack_8_24bit_unsigned_2off,
			unpack_8_24bit_signed_2off,
		},
		{
			unpack_8_24bit_unsigned_3off,
			unpack_8_24bit_signed_3off,
		},
		{
			unpack_8_24bit_unsigned_4off,
			unpack_8_24bit_signed_4off,
		},
		{
			unpack_8_24bit_unsigned_5off,
			unpack_8_24bit_signed_5off,
		},
		{
			unpack_8_24bit_unsigned_6off,
			unpack_8_24bit_signed_6off,
		},
		{
			unpack_8_24bit_unsigned_7off,
			unpack_8_24bit_signed_7off,
		},
	},
	{
		{
			unpack_9_24bit_unsigned_0off,
			unpack_9_24bit_signed_0off,
		},
		{
			unpack_9_24bit_unsigned_1off,
			unpack_9_24bit_signed_1off,
		},
		{
			unpack_9_24bit_unsigned_2off,
			unpack_9_24bit_signed_2off,
		},
		{
			unpack_9_24bit_unsigned_3off,
			unpack_9_24bit_signed_3off,
		},
		{
			unpack_9_24bit_unsigned_4off,
			unpack_9_24bit_signed_4off,
		},
		{
			unpack_9_24bit_unsigned_5off,
			unpack_9_24bit_signed_5off,
		},
		{
			unpack_9_24bit_unsigned_6off,
			unpack_9_24bit_signed_6off,
		},
		{
			unpack_9_24bit_unsigned_7off,
			unpack_9_24bit_signed_7off,
		},
	},
	{
		{
			unpack_10_24bit_unsigned_0off,
			unpack_10_24bit_signed_0off,
		},
		{
			unpack_10_24bit_unsigned_1off,
			unpack_10_24bit_signed_1off,
		},
		{
			unpack_10_24bit_unsigned_2off,
			unpack_10_24bit_signed_2off,
		},
		{
			unpack_10_24bit_unsigned_3off,
			unpack_10_24bit_signed_3off,
		},
		{
			unpack_10_24bit_unsigned_4off,
			unpack_10_24bit_signed_4off,
		},
		{
			unpack_10_24bit_unsigned_5off,
			unpack_10_24bit_signed_5off,
		},
		{
			unpack_10_24bit_unsigned_6off,
			unpack_10_24bit_signed_6off,
		},
		{
			unpack_10_24bit_unsigned_7off,
			unpack_10_24bit_signed_7off,
		},
	},
	{
		{
			unpack_11_24bit_unsigned_0off,
			unpack_11_24bit_signed_0off,
		},
		{
			unpack_11_24bit_unsigned_1off,
			unpack_11_24bit_signed_1off,
		},
		{
			unpack_11_24bit_unsigned_2off,
			unpack_11_24bit_signed_2off,
		},
		{
			unpack_11_24bit_unsigned_3off,
			unpack_11_24bit_signed_3off,
		},
		{
			unpack_11_24bit_unsigned_4off,
			unpack_11_24bit_signed_4off,
		},
		{
			unpack_11_24bit_unsigned_5off,
			unpack_11_24bit_signed_5off,
		},
		{
			unpack_11_24bit_unsigned_6off,
			unpack_11_24bit_signed_6off,
		},
		{
			unpack_11_24bit_unsigned_7off,
			unpack_11_24bit_signed_7off,
		},
	},
	{
		{
			unpack_12_24bit_unsigned_0off,
			unpack_12_24bit_signed_0off,
		},
		{
			unpack_12_24bit_unsigned_1off,
			unpack_12_24bit_signed_1off,
		},
		{
			unpack_12_24bit_unsigned_2off,
			unpack_12_24bit_signed_2off,
		},
		{
			unpack_12_24bit_unsigned_3off,
			unpack_12_24bit_signed_3off,
		},
		{
			unpack_12_24bit_unsigned_4off,
			unpack_12_24bit_signed_4off,
		},
		{
			unpack_12_24bit_unsigned_5off,
			unpack_12_24bit_signed_5off,
		},
		{
			unpack_12_24bit_unsigned_6off,
			unpack_12_24bit_signed_6off,
		},
		{
			unpack_12_24bit_unsigned_7off,
			unpack_12_24bit_signed_7off,
		},
	},
	{
		{
			unpack_13_24bit_unsigned_0off,
			unpack_13_24bit_signed_0off,
		},
		{
			unpack_13_24bit_unsigned_1off,
			unpack_13_24bit_signed_1off,
		},
		{
			unpack_13_24bit_unsigned_2off,
			unpack_13_24bit_signed_2off,
		},
		{
			unpack_13_24bit_unsigned_3off,
			unpack_13_24bit_signed_3off,
		},
		{
			unpack_13_24bit_unsigned_4off,
			unpack_13_24bit_signed_4off,
		},
		{
			unpack_13_24bit_unsigned_5off,
			unpack_13_24bit_signed_5off,
		},
		{
			unpack_13_24bit_unsigned_6off,
			unpack_13_24bit_signed_6off,
		},
		{
			unpack_13_24bit_unsigned_7off,
			unpack_13_24bit_signed_7off,
		},
	},
	{
		{
			unpack_14_24bit_unsigned_0off,
			unpack_14_24bit_signed_0off,
		},
		{
			unpack_14_24bit_unsigned_1off,
			unpack_14_24bit_signed_1off,
		},
		{
			unpack_14_24bit_unsigned_2off,
			unpack_14_24bit_signed_2off,
		},
		{
			unpack_14_24bit_unsigned_3off,
			unpack_14_24bit_signed_3off,
		},
		{
			unpack_14_24bit_unsigned_4off,
			unpack_14_24bit_signed_4off,
		},
		{
			unpack_14_24bit_unsigned_5off,
			unpack_14_24bit_signed_5off,
		},
		{
			unpack_14_24bit_unsigned_6off,
			unpack_14_24bit_signed_6off,
		},
		{
			unpack_14_24bit_unsigned_7off,
			unpack_14_24bit_signed_7off,
		},
	},
	{
		{
			unpack_15_24bit_unsigned_0off,
			unpack_15_24bit_signed_0off,
		},
		{
			unpack_15_24bit_unsigned_1off,
			unpack_15_24bit_signed_1off,
		},
		{
			unpack_15_24bit_unsigned_2off,
			unpack_15_24bit_signed_2off,
		},
		{
			unpack_15_24bit_unsigned_3off,
			unpack_15_24bit_signed_3off,
		},
		{
			unpack_15_24bit_unsigned_4off,
			unpack_15_24bit_signed_4off,
		},
		{
			unpack_15_24bit_unsigned_5off,
			unpack_15_24bit_signed_5off,
		},
		{
			unpack_15_24bit_unsigned_6off,
			unpack_15_24bit_signed_6off,
		},
		{
			unpack_15_24bit_unsigned_7off,
			unpack_15_24bit_signed_7off,
		},
	},
	{
		{
			unpack_16_24bit_unsigned_0off,
			unpack_16_24bit_signed_0off,
		},
		{
			unpack_16_24bit_unsigned_1off,
			unpack_16_24bit_signed_1off,
		},
		{
			unpack_16_24bit_unsigned_2off,
			unpack_16_24bit_signed_2off,
		},
		{
			unpack_16_24bit_unsigned_3off,
			unpack_16_24bit_signed_3off,
		},
		{
			unpack_16_24bit_unsigned_4off,
			unpack_16_24bit_signed_4off,
		},
		{
			unpack_16_24bit_unsigned_5off,
			unpack_16_24bit_signed_5off,
		},
		{
			unpack_16_24bit_unsigned_6off,
			unpack_16_24bit_signed_6off,
		},
		{
			unpack_16_24bit_unsigned_7off,
			unpack_16_24bit_signed_7off,
		},
	},
	{
		{
			unpack_17_24bit_unsigned_0off,
			unpack_17_24bit_signed_0off,
		},
		{
			unpack_17_24bit_unsigned_1off,
			unpack_17_24bit_signed_1off,
		},
		{
			unpack_17_24bit_unsigned_2off,
			unpack_17_24bit_signed_2off,
		},
		{
			unpack_17_24bit_unsigned_3off,
			unpack_17_24bit_signed_3off,
		},
		{
			unpack_17_24bit_unsigned_4off,
			unpack_17_24bit_signed_4off,
		},
		{
			unpack_17_24bit_unsigned_5off,
			unpack_17_24bit_signed_5off,
		},
		{
			unpack_17_24bit_unsigned_6off,
			unpack_17_24bit_signed_6off,
		},
		{
			unpack_17_24bit_unsigned_7off,
			unpack_17_24bit_signed_7off,
		},
	},
	{
		{
			unpack_18_24bit_unsigned_0off,
			unpack_18_24bit_signed_0off,
		},
		{
			unpack_18_24bit_unsigned_1off,
			unpack_18_24bit_signed_1off,
		},
		{
			unpack_18_24bit_unsigned_2off,
			unpack_18_24bit_signed_2off,
		},
		{
			unpack_18_24bit_unsigned_3off,
			unpack_18_24bit_signed_3off,
		},
		{
			unpack_18_24bit_unsigned_4off,
			unpack_18_24bit_signed_4off,
		},
		{
			unpack_18_24bit_unsigned_5off,
			unpack_18_24bit_signed_5off,
		},
		{
			unpack_18_24bit_unsigned_6off,
			unpack_18_24bit_signed_6off,
		},
		{
			unpack_18_24bit_unsigned_7off,
			unpack_18_24bit_signed_7off,
		},
	},
	{
		{
			unpack_19_24bit_unsigned_0off,
			unpack_19_24bit_signed_0off,
		},
		{
			unpack_19_24bit_unsigned_1off,
			unpack_19_24bit_signed_1off,
		},
		{
			unpack_19_24bit_unsigned_2off,
			unpack_19_24bit_signed_2off,
		},
		{
			unpack_19_24bit_unsigned_3off,
			unpack_19_24bit_signed_3off,
		},
		{
			unpack_19_24bit_unsigned_4off,
			unpack_19_24bit_signed_4off,
		},
		{
			unpack_19_24bit_unsigned_5off,
			unpack_19_24bit_signed_5off,
		},
		{
			unpack_19_24bit_unsigned_6off,
			unpack_19_24bit_signed_6off,
		},
		{
			unpack_19_24bit_unsigned_7off,
			unpack_19_24bit_signed_7off,
		},
	},
	{
		{
			unpack_20_24bit_unsigned_0off,
			unpack_20_24bit_signed_0off,
		},
		{
			unpack_20_24bit_unsigned_1off,
			unpack_20_24bit_signed_1off,
		},
		{
			unpack_20_24bit_unsigned_2off,
			unpack_20_24bit_signed_2off,
		},
		{
			unpack_20_24bit_unsigned_3off,
			unpack_20_24bit_signed_3off,
		},
		{
			unpack_20_24bit_unsigned_4off,
			unpack_20_24bit_signed_4off,
		},
		{
			unpack_20_24bit_unsigned_5off,
			unpack_20_24bit_signed_5off,
		},
		{
			unpack_20_24bit_unsigned_6off,
			unpack_20_24bit_signed_6off,
		},
		{
			unpack_20_24bit_unsigned_7off,
			unpack_20_24bit_signed_7off,
		},
	},
	{
		{
			unpack_21_24bit_unsigned_0off,
			unpack_21_24bit_signed_0off,
		},
		{
			unpack_21_24bit_unsigned_1off,
			unpack_21_24bit_signed_1off,
		},
		{
			unpack_21_24bit_unsigned_2off,
			unpack_21_24bit_signed_2off,
		},
		{
			unpack_21_24bit_unsigned_3off,
			unpack_21_24bit_signed_3off,
		},
		{
			unpack_21_24bit_unsigned_4off,
			unpack_21_24bit_signed_4off,
		},
		{
			unpack_21_24bit_unsigned_5off,
			unpack_21_24bit_signed_5off,
		},
		{
			unpack_21_24bit_unsigned_6off,
			unpack_21_24bit_signed_6off,
		},
		{
			unpack_21_24bit_unsigned_7off,
			unpack_21_24bit_signed_7off,
		},
	},
	{
		{
			unpack_22_24bit_unsigned_0off,
			unpack_22_24bit_signed_0off,
		},
		{
			unpack_22_24bit_unsigned_1off,
			unpack_22_24bit_signed_1off,
		},
		{
			unpack_22_24bit_unsigned_2off,
			unpack_22_24bit_signed_2off,
		},
		{
			unpack_22_24bit_unsigned_3off,
			unpack_22_24bit_signed_3off,
		},
		{
			unpack_22_24bit_unsigned_4off,
			unpack_22_24bit_signed_4off,
		},
		{
			unpack_22_24bit_unsigned_5off,
			unpack_22_24bit_signed_5off,
		},
		{
			unpack_22_24bit_unsigned_6off,
			unpack_22_24bit_signed_6off,
		},
		{
			unpack_22_24bit_unsigned_7off,
			unpack_22_24bit_signed_7off,
		},
	},
	{
		{
			unpack_23_24bit_unsigned_0off,
			unpack_23_24bit_signed_0off,
		},
		{
			unpack_23_24bit_unsigned_1off,
			unpack_23_24bit_signed_1off,
		},
		{
			unpack_23_24bit_unsigned_2off,
			unpack_23_24bit_signed_2off,
		},
		{
			unpack_23_24bit_unsigned_3off,
			unpack_23_24bit_signed_3off,
		},
		{
			unpack_23_24bit_unsigned_4off,
			unpack_23_24bit_signed_4off,
		},
		{
			unpack_23_24bit_unsigned_5off,
			unpack_23_24bit_signed_5off,
		},
		{
			unpack_23_24bit_unsigned_6off,
			unpack_23_24bit_signed_6off,
		},
		{
			unpack_23_24bit_unsigned_7off,
			unpack_23_24bit_signed_7off,
		},
	},
	{
		{
			unpack_24_24bit_unsigned_0off,
			unpack_24_24bit_signed_0off,
		},
		{
			unpack_24_24bit_unsigned_1off,
			unpack_24_24bit_signed_1off,
		},
		{
			unpack_24_24bit_unsigned_2off,
			unpack_24_24bit_signed_2off,
		},
		{
			unpack_24_24bit_unsigned_3off,
			unpack_24_24bit_signed_3off,
		},
		{
			unpack_24_24bit_unsigned_4off,
			unpack_24_24bit_signed_4off,
		},
		{
			unpack_24_24bit_unsigned_5off,
			unpack_24_24bit_signed_5off,
		},
		{
			unpack_24_24bit_unsigned_6off,
			unpack_24_24bit_signed_6off,
		},
		{
			unpack_24_24bit_unsigned_7off,
			unpack_24_24bit_signed_7off,
		},
	},
	{
		{
			unpack_25_24bit_unsigned_0off,
			unpack_25_24bit_signed_0off,
		},
		{
			unpack_25_24bit_unsigned_1off,
			unpack_25_24bit_signed_1off,
		},
		{
			unpack_25_24bit_unsigned_2off,
			unpack_25_24bit_signed_2off,
		},
		{
			unpack_25_24bit_unsigned_3off,
			unpack_25_24bit_signed_3off,
		},
		{
			unpack_25_24bit_unsigned_4off,
			unpack_25_24bit_signed_4off,
		},
		{
			unpack_25_24bit_unsigned_5off,
			unpack_25_24bit_signed_5off,
		},
		{
			unpack_25_24bit_unsigned_6off,
			unpack_25_24bit_signed_6off,
		},
		{
			unpack_25_24bit_unsigned_7off,
			unpack_25_24bit_signed_7off,
		},
	},
	{
		{
			unpack_26_24bit_unsigned_0off,
			unpack_26_24bit_signed_0off,
		},
		{
			unpack_26_24bit_unsigned_1off,
			unpack_26_24bit_signed_1off,
		},
		{
			unpack_26_24bit_unsigned_2off,
			unpack_26_24bit_signed_2off,
		},
		{
			unpack_26_24bit_unsigned_3off,
			unpack_26_24bit_signed_3off,
		},
		{
			unpack_26_24bit_unsigned_4off,
			unpack_26_24bit_signed_4off,
		},
		{
			unpack_26_24bit_unsigned_5off,
			unpack_26_24bit_signed_5off,
		},
		{
			unpack_26_24bit_unsigned_6off,
			unpack_26_24bit_signed_6off,
		},
		{
			unpack_26_24bit_unsigned_7off,
			unpack_26_24bit_signed_7off,
		},
	},
	{
		{
			unpack_27_24bit_unsigned_0off,
			unpack_27_24bit_signed_0off,
		},
		{
			unpack_27_24bit_unsigned_1off,
			unpack_27_24bit_signed_1off,
		},
		{
			unpack_27_24bit_unsigned_2off,
			unpack_27_24bit_signed_2off,
		},
		{
			unpack_27_24bit_unsigned_3off,
			unpack_27_24bit_signed_3off,
		},
		{
			unpack_27_24bit_unsigned_4off,
			unpack_27_24bit_signed_4off,
		},
		{
			unpack_27_24bit_unsigned_5off,
			unpack_27_24bit_signed_5off,
		},
		{
			unpack_27_24bit_unsigned_6off,
			unpack_27_24bit_signed_6off,
		},
		{
			unpack_27_24bit_unsigned_7off,
			unpack_27_24bit_signed_7off,
		},
	},
	{
		{
			unpack_28_24bit_unsigned_0off,
			unpack_28_24bit_signed_0off,
		},
		{
			unpack_28_24bit_unsigned_1off,
			unpack_28_24bit_signed_1off,
		},
		{
			unpack_28_24bit_unsigned_2off,
			unpack_28_24bit_signed_2off,
		},
		{
			unpack_28_24bit_unsigned_3off,
			unpack_28_24bit_signed_3off,
		},
		{
			unpack_28_24bit_unsigned_4off,
			unpack_28_24bit_signed_4off,
		},
		{
			unpack_28_24bit_unsigned_5off,
			unpack_28_24bit_signed_5off,
		},
		{
			unpack_28_24bit_unsigned_6off,
			unpack_28_24bit_signed_6off,
		},
		{
			unpack_28_24bit_unsigned_7off,
			unpack_28_24bit_signed_7off,
		},
	},
	{
		{
			unpack_29_24bit_unsigned_0off,
			unpack_29_24bit_signed_0off,
		},
		{
			unpack_29_24bit_unsigned_1off,
			unpack_29_24bit_signed_1off,
		},
		{
			unpack_29_24bit_unsigned_2off,
			unpack_29_24bit_signed_2off,
		},
		{
			unpack_29_24bit_unsigned_3off,
			unpack_29_24bit_signed_3off,
		},
		{
			unpack_29_24bit_unsigned_4off,
			unpack_29_24bit_signed_4off,
		},
		{
			unpack_29_24bit_unsigned_5off,
			unpack_29_24bit_signed_5off,
		},
		{
			unpack_29_24bit_unsigned_6off,
			unpack_29_24bit_signed_6off,
		},
		{
			unpack_29_24bit_unsigned_7off,
			unpack_29_24bit_signed_7off,
		},
	},
	{
		{
			unpack_30_24bit_unsigned_0off,
			unpack_30_24bit_signed_0off,
		},
		{
			unpack_30_24bit_unsigned_1off,
			unpack_30_24bit_signed_1off,
		},
		{
			unpack_30_24bit_unsigned_2off,
			unpack_30_24bit_signed_2off,
		},
		{
			unpack_30_24bit_unsigned_3off,
			unpack_30_24bit_signed_3off,
		},
		{
			unpack_30_24bit_unsigned_4off,
			unpack_30_24bit_signed_4off,
		},
		{
			unpack_30_24bit_unsigned_5off,
			unpack_30_24bit_signed_5off,
		},
		{
			unpack_30_24bit_unsigned_6off,
			unpack_30_24bit_signed_6off,
		},
		{
			unpack_30_24bit_unsigned_7off,
			unpack_30_24bit_signed_7off,
		},
	},
	{
		{
			unpack_31_24bit_unsigned_0off,
			unpack_31_24bit_signed_0off,
		},
		{
			unpack_31_24bit_unsigned_1off,
			unpack_31_24bit_signed_1off,
		},
		{
			unpack_31_24bit_unsigned_2off,
			unpack_31_24bit_signed_2off,
		},
		{
			unpack_31_24bit_unsigned_3off,
			unpack_31_24bit_signed_3off,
		},
		{
			unpack_31_24bit_unsigned_4off,
			unpack_31_24bit_signed_4off,
		},
		{
			unpack_31_24bit_unsigned_5off,
			unpack_31_24bit_signed_5off,
		},
		{
			unpack_31_24bit_unsigned_6off,
			unpack_31_24bit_signed_6off,
		},
		{
			unpack_31_24bit_unsigned_7off,
			unpack_31_24bit_signed_7off,
		},
	},
	{
		{
			unpack_32_24bit_unsigned_0off,
			unpack_32_24bit_signed_0off,
		},
		{
			unpack_32_24bit_unsigned_1off,
			unpack_32_24bit_signed_1off,
		},
		{
			unpack_32_24bit_unsigned_2off,
			unpack_32_24bit_signed_2off,
		},
		{
			unpack_32_24bit_unsigned_3off,
			unpack_32_24bit_signed_3off,
		},
		{
			unpack_32_24bit_unsigned_4off,
			unpack_32_24bit_signed_4off,
		},
		{
			unpack_32_24bit_unsigned_5off,
			unpack_32_24bit_signed_5off,
		},
		{
			unpack_32_24bit_unsigned_6off,
			unpack_32_24bit_signed_6off,
		},
		{
			unpack_32_24bit_unsigned_7off,
			unpack_32_24bit_signed_7off,
		},
	},
	{
		{
			unpack_33_24bit_unsigned_0off,
			unpack_33_24bit_signed_0off,
		},
		{
			unpack_33_24bit_unsigned_1off,
			unpack_33_24bit_signed_1off,
		},
		{
			unpack_33_24bit_unsigned_2off,
			unpack_33_24bit_signed_2off,
		},
		{
			unpack_33_24bit_unsigned_3off,
			unpack_33_24bit_signed_3off,
		},
		{
			unpack_33_24bit_unsigned_4off,
			unpack_33_24bit_signed_4off,
		},
		{
			unpack_33_24bit_unsigned_5off,
			unpack_33_24bit_signed_5off,
		},
		{
			unpack_33_24bit_unsigned_6off,
			unpack_33_24bit_signed_6off,
		},
		{
			unpack_33_24bit_unsigned_7off,
			unpack_33_24bit_signed_7off,
		},
	},
	{
		{
			unpack_34_24bit_unsigned_0off,
			unpack_34_24bit_signed_0off,
		},
		{
			unpack_34_24bit_unsigned_1off,
			unpack_34_24bit_signed_1off,
		},
		{
			unpack_34_24bit_unsigned_2off,
			unpack_34_24bit_signed_2off,
		},
		{
			unpack_34_24bit_unsigned_3off,
			unpack_34_24bit_signed_3off,
		},
		{
			unpack_34_24bit_unsigned_4off,
			unpack_34_24bit_signed_4off,
		},
		{
			unpack_34_24bit_unsigned_5off,
			unpack_34_24bit_signed_5off,
		},
		{
			unpack_34_24bit_unsigned_6off,
			unpack_34_24bit_signed_6off,
		},
		{
			unpack_34_24bit_unsigned_7off,
			unpack_34_24bit_signed_7off,
		},
	},
	{
		{
			unpack_35_24bit_unsigned_0off,
			unpack_35_24bit_signed_0off,
		},
		{
			unpack_35_24bit_unsigned_1off,
			unpack_35_24bit_signed_1off,
		},
		{
			unpack_35_24bit_unsigned_2off,
			unpack_35_24bit_signed_2off,
		},
		{
			unpack_35_24bit_unsigned_3off,
			unpack_35_24bit_signed_3off,
		},
		{
			unpack_35_24bit_unsigned_4off,
			unpack_35_24bit_signed_4off,
		},
		{
			unpack_35_24bit_unsigned_5off,
			unpack_35_24bit_signed_5off,
		},
		{
			unpack_35_24bit_unsigned_6off,
			unpack_35_24bit_signed_6off,
		},
		{
			unpack_35_24bit_unsigned_7off,
			unpack_35_24bit_signed_7off,
		},
	},
	{
		{
			unpack_36_24bit_unsigned_0off,
			unpack_36_24bit_signed_0off,
		},
		{
			unpack_36_24bit_unsigned_1off,
			unpack_36_24bit_signed_1off,
		},
		{
			unpack_36_24bit_unsigned_2off,
			unpack_36_24bit_signed_2off,
		},
		{
			unpack_36_24bit_unsigned_3off,
			unpack_36_24bit_signed_3off,
		},
		{
			unpack_36_24bit_unsigned_4off,
			unpack_36_24bit_signed_4off,
		},
		{
			unpack_36_24bit_unsigned_5off,
			unpack_36_24bit_signed_5off,
		},
		{
			unpack_36_24bit_unsigned_6off,
			unpack_36_24bit_signed_6off,
		},
		{
			unpack_36_24bit_unsigned_7off,
			unpack_36_24bit_signed_7off,
		},
	},
	{
		{
			unpack_37_24bit_unsigned_0off,
			unpack_37_24bit_signed_0off,
		},
		{
			unpack_37_24bit_unsigned_1off,
			unpack_37_24bit_signed_1off,
		},
		{
			unpack_37_24bit_unsigned_2off,
			unpack_37_24bit_signed_2off,
		},
		{
			unpack_37_24bit_unsigned_3off,
			unpack_37_24bit_signed_3off,
		},
		{
			unpack_37_24bit_unsigned_4off,
			unpack_37_24bit_signed_4off,
		},
		{
			unpack_37_24bit_unsigned_5off,
			unpack_37_24bit_signed_5off,
		},
		{
			unpack_37_24bit_unsigned_6off,
			unpack_37_24bit_signed_6off,
		},
		{
			unpack_37_24bit_unsigned_7off,
			unpack_37_24bit_signed_7off,
		},
	},
	{
		{
			unpack_38_24bit_unsigned_0off,
			unpack_38_24bit_signed_0off,
		},
		{
			unpack_38_24bit_unsigned_1off,
			unpack_38_24bit_signed_1off,
		},
		{
			unpack_38_24bit_unsigned_2off,
			unpack_38_24bit_signed_2off,
		},
		{
			unpack_38_24bit_unsigned_3off,
			unpack_38_24bit_signed_3off,
		},
		{
			unpack_38_24bit_unsigned_4off,
			unpack_38_24bit_signed_4off,
		},
		{
			unpack_38_24bit_unsigned_5off,
			unpack_38_24bit_signed_5off,
		},
		{
			unpack_38_24bit_unsigned_6off,
			unpack_38_24bit_signed_6off,
		},
		{
			unpack_38_24bit_unsigned_7off,
			unpack_38_24bit_signed_7off,
		},
	},
	{
		{
			unpack_39_24bit_unsigned_0off,
			unpack_39_24bit_signed_0off,
		},
		{
			unpack_39_24bit_unsigned_1off,
			unpack_39_24bit_signed_1off,
		},
		{
			unpack_39_24bit_unsigned_2off,
			unpack_39_24bit_signed_2off,
		},
		{
			unpack_39_24bit_unsigned_3off,
			unpack_39_24bit_signed_3off,
		},
		{
			unpack_39_24bit_unsigned_4off,
			unpack_39_24bit_signed_4off,
		},
		{
			unpack_39_24bit_unsigned_5off,
			unpack_39_24bit_signed_5off,
		},
		{
			unpack_39_24bit_unsigned_6off,
			unpack_39_24bit_signed_6off,
		},
		{
			unpack_39_24bit_unsigned_7off,
			unpack_39_24bit_signed_7off,
		},
	},
	{
		{
			unpack_40_24bit_unsigned_0off,
			unpack_40_24bit_signed_0off,
		},
		{
			unpack_40_24bit_unsigned_1off,
			unpack_40_24bit_signed_1off,
		},
		{
			unpack_40_24bit_unsigned_2off,
			unpack_40_24bit_signed_2off,
		},
		{
			unpack_40_24bit_unsigned_3off,
			unpack_40_24bit_signed_3off,
		},
		{
			unpack_40_24bit_unsigned_4off,
			unpack_40_24bit_signed_4off,
		},
		{
			unpack_40_24bit_unsigned_5off,
			unpack_40_24bit_signed_5off,
		},
		{
			unpack_40_24bit_unsigned_6off,
			unpack_40_24bit_signed_6off,
		},
		{
			unpack_40_24bit_unsigned_7off,
			unpack_40_24bit_signed_7off,
		},
	},
	{
		{
			unpack_41_24bit_unsigned_0off,
			unpack_41_24bit_signed_0off,
		},
		{
			unpack_41_24bit_unsigned_1off,
			unpack_41_24bit_signed_1off,
		},
		{
			unpack_41_24bit_unsigned_2off,
			unpack_41_24bit_signed_2off,
		},
		{
			unpack_41_24bit_unsigned_3off,
			unpack_41_24bit_signed_3off,
		},
		{
			unpack_41_24bit_unsigned_4off,
			unpack_41_24bit_signed_4off,
		},
		{
			unpack_41_24bit_unsigned_5off,
			unpack_41_24bit_signed_5off,
		},
		{
			unpack_41_24bit_unsigned_6off,
			unpack_41_24bit_signed_6off,
		},
		{
			unpack_41_24bit_unsigned_7off,
			unpack_41_24bit_signed_7off,
		},
	},
	{
		{
			unpack_42_24bit_unsigned_0off,
			unpack_42_24bit_signed_0off,
		},
		{
			unpack_42_24bit_unsigned_1off,
			unpack_42_24bit_signed_1off,
		},
		{
			unpack_42_24bit_unsigned_2off,
			unpack_42_24bit_signed_2off,
		},
		{
			unpack_42_24bit_unsigned_3off,
			unpack_42_24bit_signed_3off,
		},
		{
			unpack_42_24bit_unsigned_4off,
			unpack_42_24bit_signed_4off,
		},
		{
			unpack_42_24bit_unsigned_5off,
			unpack_42_24bit_signed_5off,
		},
		{
			unpack_42_24bit_unsigned_6off,
			unpack_42_24bit_signed_6off,
		},
		{
			unpack_42_24bit_unsigned_7off,
			unpack_42_24bit_signed_7off,
		},
	},
};
